

#include "puls.h"
#include "uart2.h"
#include <string.h>
#include "data_base.h"
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

char conststr_4_4[]="%04d,%04d#";

/*
$GPRMC Sentence (Position and time)
Example (signal not acquired): $GPRMC,235947.000,V,0000.0000,N,00000.0000,E,,,041299,,*1D
Example (signal acquired): $GPRMC,092204.999,A,4250.5589,S,14718.5084,E,0.00,89.68,211200,,*25
Field	Example	Comments

Sentence ID	$GPRMC	 
UTC Time	092204.999	hhmmss.sss
Status	A	A = Valid, V = Invalid
Latitude	4250.5589	ddmm.mmmm
N/S Indicator	S	N = North, S = South
Longitude	14718.5084	dddmm.mmmm
E/W Indicator	E	E = East, W = West
Speed over ground	0.00	Knots
Course over ground	0.00	Degrees
UTC Date	211200	DDMMYY
Magnetic variation	 	Degrees
Magnetic variation	 	E = East, W = West
Checksum	*25	 
Terminator	CR/LF	 
*/
//A valid
//V non-valid
//       hhmmssact47,34.63,,018,5936,K,0.0,53.5,nn.hh.,3.3,E,A*chksum
//$GPRMC,152736,A,4734.6386,N,01859.3634,E,0.0,53.5,170504,3.3,E,A*23
//        						 ,ooppss									 
//$GPGLL,4734.6423,N,01859.3675,E,153734,A,A*45
/* LX200 input... */


//char SlewState;

static int IIx=0;
//int Buttons;
static int LX200_Ix=0;
static int Beg_LX200_Ix=0;
//char LX200_LongFormat;
//static char TrackFlag=0;
//static char MaxHandpadFlag=0;
static int Ix=0;
//float obj_coord[2];

extern unsigned int estiteszt;

extern char LX200_swap_tube;
extern char LX200_goto_ra_dec;
extern char Display_mem[];
extern float mot_offset[2];	
extern char polecross;
extern char saveparams;
extern char initallparam;

extern char LX200_gohome;
extern char LX200_upgrade;
extern const char VER_str[];
extern const char DATE_str[];

extern unsigned char no_synctest;
extern  long tick;
extern float mot_pos[2];	
extern struct  user_par userpar[2]; 
extern float SidT;
extern struct time ti;
extern struct time tis;
extern float scope_ALT;
extern float scope_AZ;
extern struct  misc_par misc;
extern struct  motor_par mot[2];
extern short debug_int;
extern unsigned char autostop_local_enable; 
extern char IsParked; 
extern char IsParking;
extern char IsSlewing;
extern char swappingtube;


void SendLx200Str(char *dbuf);
void LX200uartSendBytebuff( char kar);
void pulse_guide (unsigned char dir,unsigned short ms);


char LX200Queue[LX200QueueSize];







struct Position In;

void uartsendbuff(char *StrBuf){

	uartSendBuffer( LX200ComPort, StrBuf, strlen( StrBuf));

}

void send_LX200_OK(void){

	LX200uartSendBytebuff(LX200_OK);

}



void initLx200(void)

{

for( Ix = 0; Ix < LX200QueueSize; Ix++)
		LX200Queue[Ix] = Blank;

	
}


void ReadLX200Input_direct( void)
{
	static unsigned char B;
//	static char DataReady;
	
	static char lx_act=0;
		
	if (!lx_act){
			
	lx_act=1;
	

	if( uartReceiveByte( LX200ComPort, &B))
	{
		
		/* get rest of buffered serial data */
		do
		{
			LX200_Ix++;
			LX200_Ix %= LX200QueueSize;
			LX200Queue[LX200_Ix] = B;
			if( LX200Queue[LX200_Ix] == LX200_ACK)
			{
				LX200uartSendBytebuff('A');
//				InsertLX200CmdIntoArray( Ack);
				/* start fresh, ignoring any previous commands */
				Beg_LX200_Ix = LX200_Ix+1;
				Beg_LX200_Ix %= LX200QueueSize;
				
			}
		} while( uartReceiveByte( LX200ComPort, &B));
//		printf("----%c",LX200Queue[LX200_Ix]);
		if (LX200Queue[LX200_Ix] == '#')
						{
			            //    printf("+++++");

							ProcessLX200Cmds();
							
							/* get ready for next command... */
							Beg_LX200_Ix = LX200_Ix+1;
							Beg_LX200_Ix %= LX200QueueSize;
						}
		
			 
			 
			
		
		
	}
 lx_act=0;	
 }	
}




void ReadLX200Input( void)
{
	static unsigned char B;
	static char DataReady;
	static char ReadData;
	static  long ReadDataSidT;
	long TimeDiff;

	static char lx_act=0;
	
	if (!lx_act){
		
	lx_act=1;
	
	if( uartReceiveByte( LX200ComPort, &B))
	{
		ReadData = Yes;
		/* get rest of buffered serial data */
		do
		{
			LX200_Ix++;
			LX200_Ix %= LX200QueueSize;
			LX200Queue[LX200_Ix] = B;
			if( LX200Queue[LX200_Ix] == LX200_ACK)
			{
				LX200uartSendBytebuff('A');
//				InsertLX200CmdIntoArray( Ack);
				/* start fresh, ignoring any previous commands */
				Beg_LX200_Ix = LX200_Ix+1;
				Beg_LX200_Ix %= LX200QueueSize;
				ReadData = No;
			}
		} while( uartReceiveByte( LX200ComPort, &B));
		
		
		
	}
	else
		ReadData = No;

	/* since multiple commands can be streamed at one time, wait until input port is quiet before
	processing commands and returning any requested data */
	if( ReadData == Yes)
	{
		ReadDataSidT = tick;
		DataReady = True;
	}
	/* else LX200 port quiet */
	else
		if( DataReady == True)
		{
			TimeDiff = tick - ReadDataSidT;
		/*	if( TimeDiff <= -MS_1000)
				TimeDiff += MS_1000;*/
			if( TimeDiff <0)		  	   			//tick resets to zero 
				TimeDiff += TICKMAX;	
				
			/* after 1 second, if nothing further received, and commands do not end with '#', process
			it as unfinished */
			if( TimeDiff > MS_1000)
		
			{
//				InsertLX200CmdIntoArray( LX200_Unfinished_Cmd);
				DataReady = No;
				/* get ready for next command... */
				Beg_LX200_Ix = LX200_Ix+1;
				Beg_LX200_Ix %= LX200QueueSize;
			}
			else
				/* wait one clock tick, or 55 ms to process, all commands must end with a '#' */
//				if( TimeDiff >= ClockTickToRad && LX200Queue[LX200_Ix] == '#')
				if( TimeDiff >= MS_55 && LX200Queue[LX200_Ix] == '#')
	//			if( TimeDiff >= MS_55 && LX200Queue[LX200_Ix] == 0x0d)
				
				{
					ProcessLX200Cmds();
					DataReady = No;
					/* get ready for next command... */
					Beg_LX200_Ix = LX200_Ix+1;
					Beg_LX200_Ix %= LX200QueueSize;
				}
		}
	lx_act=0;
	}
}


void LX200_Read_homepos(int Ix)

{

int IxA;
int deg;
unsigned int degres;
char si;

send_LX200_OK();

	IxA = Ix+3;
	IxA %= LX200QueueSize;
	si='+';
	if (LX200Queue[IxA]=='+')
	{
	 si='+';	
	 IxA++;
	} 
	else
	if (LX200Queue[IxA]=='-')
	{
	 si='-';	
	 IxA++;
	} 
	
	deg= LX200_Read_Int_From_Queue( IxA);
	LX200_Incr_Ix_Until_Terminate_Char( &IxA);
	if( LX200Queue[IxA] =='.')
	{
		IxA++;
		degres = LX200_Read_Int_From_Queue( IxA);
		if (si=='-')deg=-deg;
		if ((deg<=90)&&(deg>=-90))
		{
		 userpar[RA].home=degfloat_to_rad(deg,degres);
		} 
	}	



LX200_Incr_Ix_Until_Terminate_Char( &IxA);
if( LX200Queue[IxA] ==',')
	
{
	IxA++;
/*	
	si='+';
	if (LX200Queue[IxA]=='-')
	{
	 si='-';	
	 IxA++;
	} 
	if (LX200Queue[IxA]=='+')
	{
	 si='+';	
	 IxA++;
	} 
	
*/
	
	deg= LX200_Read_Int_From_Queue( IxA);
	LX200_Incr_Ix_Until_Terminate_Char( &IxA);
	if( LX200Queue[IxA] =='.')
	{
		IxA++;
		degres= LX200_Read_Int_From_Queue( IxA);
//		if (deg<=180)
			{
			// if (si=='+')
/*			   if (si=='-')
			  {
			   deg=360-deg;
			   degres=10000-degres;
			   if (degres)deg--;
			  }
			 
			  
	*/		  
			 
			  
			  
			 
	 		 userpar[DEC].home=degfloat_to_rad(deg,degres);
			
			} 
		}
 }
}


/*
LX200_Read_homepos(int Ix)

{

int IxA;

send_LX200_OK();
In.DecDMS.Deg = In.DecDMS.Min = In.DecDMS.Sec = 0;
	In.DecDMS.Sign = PLUS;

	IxA = Ix+3;
	IxA %= LX200QueueSize;
	if( LX200Queue[IxA] == '-')
		In.DecDMS.Sign = MINUS;
	IxA++;
	In.DecDMS.Deg = LX200_Read_Int_From_Queue( IxA);
	LX200_Incr_Ix_Until_Terminate_Char( &IxA);
	if( LX200Queue[IxA] == DegSym || LX200Queue[IxA] == ':' || LX200Queue[IxA] == '*')
	{
		IxA++;
		In.DecDMS.Min = LX200_Read_Int_From_Queue( IxA);
		LX200_Incr_Ix_Until_Terminate_Char( &IxA);
		if( LX200Queue[IxA] == ':')
		{
			IxA++;
			In.DecDMS.Sec = LX200_Read_Int_From_Queue( IxA);
		}
	}
	else
		if( LX200Queue[IxA] == '#')
		{
			IxA++;
			In.DecDMS.Min = LX200_Read_Int_From_Queue( IxA);
		}

		userpar[RA].home=deg_to_rad(In.DecDMS.Sign,In.DecDMS.Deg,In.DecDMS.Min,In.DecDMS.Sec);
		
//-----------------------------------------------------------------------------------------------		
		
In.DecDMS.Deg = In.DecDMS.Min = In.DecDMS.Sec = 0;
	In.DecDMS.Sign = PLUS;

	
//most jn a dec beolvass
	LX200_Incr_Ix_Until_Terminate_Char( &IxA);
if( LX200Queue[IxA] == ',')
{	

	IxA++;
	IxA %= LX200QueueSize;
	
	In.DecDMS.Deg = LX200_Read_Int_From_Queue( IxA);
	LX200_Incr_Ix_Until_Terminate_Char( &IxA);
	if( LX200Queue[IxA] == DegSym || LX200Queue[IxA] == ':' || LX200Queue[IxA] == '*')
	{
		IxA++;
		In.DecDMS.Min = LX200_Read_Int_From_Queue( IxA);
		LX200_Incr_Ix_Until_Terminate_Char( &IxA);
		if( LX200Queue[IxA] == ':')
		{
			IxA++;
			In.DecDMS.Sec = LX200_Read_Int_From_Queue( IxA);
		}
	}
	else
		if( LX200Queue[IxA] == '#')
		{
			IxA++;
			In.DecDMS.Min = LX200_Read_Int_From_Queue( IxA);
		}

		userpar[DEC].home=deg_to_rad(In.DecDMS.Sign,In.DecDMS.Deg,In.DecDMS.Min,In.DecDMS.Sec);

			
		
 }		
		
}
*/
void LX200_Write_homepos(void)
{

float r;
int deg;
unsigned int degres;
char si;
float longi;
char StrBuf[17];

	
r=rad_to_degfloat(userpar[RA].home,&deg,&degres);
si='+';

if (deg<0)si='-'; 
deg=abs(deg);
sprintf(StrBuf,"%c%02d.%04u,",si,deg,degres);	
uartsendbuff(StrBuf);
	



/*
if (userpar[DEC].home>M_PI)
{
 si='-';
 // si='+';
longi=M2_PI-userpar[DEC].home;
}
else
*/
{
 //si='-';
  si='+';
 longi=userpar[DEC].home;
}	
	
	r=rad_to_degfloat(longi,&deg,&degres);
  //  sprintf(StrBuf,"%c%03d.%04u#",si,deg,degres);
    sprintf(StrBuf,"%03d.%04u#",deg,degres);
	uartsendbuff(StrBuf);
	

}
/*
void LX200_Write_homepos(void)


{
char buf[20];
char sign;
char hour;
char min;
char sec;
unsigned short deg;
char hundsec;

//rad_to_time(userpar[RA].home,&sign,&hour,&min,&sec,&hundsec);
  //  if( misc.lx200format)
//	sprintf(buf,"%02d:%02d:%02d,",hour,min,sec);
	
rad_to_deg(userpar[RA].home,&sign,&deg,&min,&sec);
if (sign==MINUS)sign='-';else sign='+';
	
	if (misc.lx200format)
	sprintf(buf,"%c%02u:%02u:%02u,",sign,deg,min,sec);
	else
	{
	    
		if( sec > 29)
		{
			min++;
			if( min > 59)
			{
				min = 0;
				deg++;
			}
		}
		sprintf( buf, "%c%02d%c%02d,", sign, deg, DegSym, min);
	
	}

SendLx200Str( buf);


rad_to_deg(userpar[DEC].home,&sign,&deg,&min,&sec);
if (sign==MINUS)sign='-';else sign='+';
	
	
	
	if (misc.lx200format)
	sprintf(buf,"%c%02u:%02u:%02u#",sign,deg,min,sec);
	else
	{
	    
		if( sec > 29)
		{
			min++;
			if( min > 59)
			{
				min = 0;
				deg++;
			}
		}
		sprintf( buf, "%c%02d%c%02d#", sign, deg, DegSym, min);
    }
SendLx200Str( buf);


}
*/
void LX200_Read_Userrate1(int Ix)

{

int IxA;

	send_LX200_OK();

	In.RaHMSH.Sign = PLUS;
	In.RaHMSH.Hr = In.RaHMSH.Min = In.RaHMSH.Sec = In.RaHMSH.HundSec = 0;

	IxA = Ix+3;
	if( LX200Queue[IxA] == '-')
		{In.RaHMSH.Sign = MINUS;
	     }
	IxA++;
	In.RaHMSH.Min = LX200_Read_Int_From_Queue( IxA);
	LX200_Incr_Ix_Until_Terminate_Char( &IxA);
	if( LX200Queue[IxA] == ':')
	{
		IxA++;
		In.RaHMSH.Sec = LX200_Read_Int_From_Queue( IxA);
		LX200_Incr_Ix_Until_Terminate_Char( &IxA);
		if( LX200Queue[IxA] == ':')
		{
			IxA++;
			In.RaHMSH.HundSec = LX200_Read_Int_From_Queue( IxA);
		}
		else
			if( LX200Queue[IxA] == '.')
			{
				IxA++;
				In.RaHMSH.Sec = 6 * LX200_Read_Int_From_Queue( IxA);
			}
	}
	
	userpar[RA].userrate1=time_to_rad(In.RaHMSH.Sign,In.RaHMSH.Hr,In.RaHMSH.Min,In.RaHMSH.Sec,In.RaHMSH.HundSec)/600;
																   
	
	//most jn a dec beolvass
	LX200_Incr_Ix_Until_Terminate_Char( &IxA);
if( LX200Queue[IxA] == ',')
{

 	IxA++;
	In.DecDMS.Deg = In.DecDMS.Min = In.DecDMS.Sec = 0;
	In.DecDMS.Sign = PLUS;

	
	
	if( LX200Queue[IxA] == '-')
		In.DecDMS.Sign = MINUS;
	IxA++;
	In.DecDMS.Deg = LX200_Read_Int_From_Queue( IxA);
	LX200_Incr_Ix_Until_Terminate_Char( &IxA);
	if( LX200Queue[IxA] == DegSym || LX200Queue[IxA] == ':' || LX200Queue[IxA] == '*')
	{
		IxA++;
		In.DecDMS.Min = LX200_Read_Int_From_Queue( IxA);
		LX200_Incr_Ix_Until_Terminate_Char( &IxA);
		if( LX200Queue[IxA] == ':')
		{
			IxA++;
			In.DecDMS.Sec = LX200_Read_Int_From_Queue( IxA);
		}
	}
	else
		if( LX200Queue[IxA] == '#')
		{
			IxA++;
			In.DecDMS.Min = LX200_Read_Int_From_Queue( IxA);
		}

		userpar[DEC].userrate1=deg_to_rad(In.DecDMS.Sign,In.DecDMS.Deg,In.DecDMS.Min,In.DecDMS.Sec)/600;
		
	
}


}


void LX200_Write_Userrate1(void)

{

unsigned char sign,si;
unsigned short deg;
unsigned char hour;
unsigned char min;
unsigned char sec;
unsigned char hundsec;
char buf[20];


rad_to_time2((userpar[RA].userrate1)*600,&sign,&hour,&min,&sec,&hundsec);
       if (sign==MINUS)si='-';else si='+';
	   sprintf(buf,"%c%02u:%02u:%02u,",si,min,sec,hundsec);
	   
 
  SendLx200Str( buf);
  
rad_to_deg((userpar[DEC].userrate1)*600,&sign,&deg,&min,&sec);

	   if (sign==MINUS)si='-';else si='+';  //inverted
	   sprintf(buf,"%c%02u:%02u:%02u#",si,deg,min,sec);  
  
 SendLx200Str( buf);

}



void LX200_Write_Ra( float ra)
{



char buf[20];
unsigned char sign;
unsigned char hour;
unsigned char min;
unsigned char sec;
unsigned char hundsec;
//unsigned int deg;	
char TenthsMin;
float rakij;

/*if (!polecross){rakij=ra;}  //unpair No of polecross adds 12h
  else {rakij=ra+M_PI;}
*/
if (!polecross)rakij=limit_ra(ra);
  else rakij=limit_ra(ra)+M_PI;
	
	rad_to_time(rakij,&sign,&hour,&min,&sec,&hundsec);
    if( misc.lx200format)
	sprintf(buf,"%02d:%02d:%02d",hour,min,sec);
	
	else
	{
		
		TenthsMin = (sec + 3)/6;
		if( TenthsMin > 9)
		{
			TenthsMin = 0;
			min++;
			if( min > 59)
			{
				min = 0;
				hour++;
			}
		}
	
	
	sprintf(buf,"%02d:%02d.%1d",hour,min,TenthsMin);
	}
	SendLx200Str( buf);

//	int Hr, Min, TenthsMin;

	/*if( SlewState != SlewDone)
	{
		SlewCurrent = Current;
		SetCurrentToSlew = True;
		HPEventGetEquat();
	}

	GetHMSH( RadToHundSec*Current.Ra + 0.5, &Current.RaHMSH);

	if( misc.lx200format)
		sprintf( StrBuf, "%02d:%02d:%02d#", Current.RaHMSH.Hr, Current.RaHMSH.Min, Current.RaHMSH.Sec);
	else
	{
		Hr = Current.RaHMSH.Hr;
		Min = Current.RaHMSH.Min;
		TenthsMin = (Current.RaHMSH.Sec + 3)/6;
		if( TenthsMin > 9)
		{
			TenthsMin = 0;
			Min++;
			if( Min > 59)
			{
				Min = 0;
				Hr++;
			}
		}
		sprintf( StrBuf, "%02d:%02d.%1d#", Hr, Min, TenthsMin);
	}
	uartsendbuff(StrBuf);

	if( SetCurrentToSlew)
		Current = SlewCurrent;
	*/	
}


void LX200uartSendBytebuff( char kar)

{
char dbuf[2];
*dbuf=kar;

uartSendBuffer(LX200ComPort,dbuf, 1);

}



void SendLx200Str(char *dbuf)


{


uartSendBuffer(LX200ComPort,dbuf, strlen(dbuf));

/*


for (;;)
{

 	if (*dbuf==0)return;
 	uartSendByte(LX200ComPort,*dbuf++);
	
}

*/


}




void LX200_Write_Dec(float dec)
{
	
	
char buf[20];
unsigned char sign;
//char hour;
unsigned char min;
unsigned char sec;
//char hundsec;
unsigned short deg;	
float deckij;

deckij = calc_valid_pos(dec);
/*

deckij=dec;
if (deckij>M_PI_H)
  {
    deckij=M_PI-dec;
	polecross=1;
  }	
else 
 if (deckij<-M_PI_H)
 {
    deckij=-M_PI-dec;
    polecross=1;
 } 	
 else polecross=0;
*/
	rad_to_deg(deckij,&sign,&deg,&min,&sec);

	if (sign==MINUS)sign='-';else sign='+';
	
	if (misc.lx200format)
	sprintf(buf,"%c%02u:%02u:%02u#",sign,deg,min,sec);
	else
	{
	    
		if( sec > 29)
		{
			min++;
			if( min > 59)
			{
				min = 0;
				deg++;
			}
		}
		sprintf( buf, "%c%02d%c%02d#", sign, deg, DegSym, min);
	
	
	}
	//sprintf(buf,"%c%02u.%02u#",sign,deg,min);
	SendLx200Str( buf);




/*	
int Deg, Min;
	char Sign;


if( SlewState != SlewDone)
	{
		SlewCurrent = Current;
		SetCurrentToSlew = True;
		HPEventGetEquat();
	}

	GetDMS( RadToArcsec*Current.Dec + 0.5, &Current.DecDMS);

	if( Current.DecDMS.Sign == Plus)
		Sign = '+';
	else
		Sign = '-';
	if( misc.lx200format)
		sprintf( StrBuf, "%c%02d%c%02d:02d#", Sign, Current.DecDMS.Deg, DegSym, Current.DecDMS.Min,
		Current.DecDMS.Sec);
	else
	{
		Deg = Current.DecDMS.Deg;
		Min = Current.DecDMS.Min;
		if( Current.DecDMS.Sec > 29)
		{
			Min++;
			if( Min > 59)
			{
				Min = 0;
				Deg++;
			}
		}
		sprintf( StrBuf, "%c%02d%c%02d#", Sign, Deg, DegSym, Min);
	}
	uartsendbuff(StrBuf);

	if( SetCurrentToSlew)
	Current = SlewCurrent;*/
}

void LX200_Write_Alt( void)
{
	
	unsigned char sign;
	unsigned char min;
	unsigned short deg;
	unsigned char sec;
	//static float HoldAlt;
	char StrBuf[17];

	/*if( HoldAlt != Current.Alt)
	{
		GetDMS( RadToArcsec*Current.Alt + 0.5, &V);
		HoldAlt = Current.Alt;
	}*/
	rad_to_deg(scope_ALT,&sign,&deg,&min,&sec);
	if( sign == PLUS)
		sign = '+';
	else
		sign = '-';
	if( misc.lx200format)
		sprintf( StrBuf, "%c%02d%c%02d:%02d#", sign, deg, DegSym, min, sec);
	else
	{
		if( sec > 29)
		{
			min++;
			if( min > 59)
				deg++;
		}
		sprintf( StrBuf, "%c%02d%c%02d#", sign, deg, DegSym, min);
	}
	uartsendbuff(StrBuf);
	
}

void LX200_Write_Az( void)
{
	unsigned char sign;
	unsigned char min;
	unsigned short deg;
	unsigned char sec;
	//static float HoldAz;
	char StrBuf[17];

	/*if( HoldAz != Current.Az)
	{
		GetDMS( RadToArcsec*Current.Az + 0.5, &V);
		HoldAz = Current.Az;
	}*/
	rad_to_deg(scope_AZ,&sign,&deg,&min,&sec);
	if( misc.lx200format)
		sprintf( StrBuf, "%03d%c%02d:%02d#", deg, DegSym, min, sec);
	else
	{
		if( sec > 29)
		{
			min++;
			if( min > 59)
				deg++;
		}
		sprintf( StrBuf, "%03d%c%02d#", deg, DegSym, min);
	}
	uartsendbuff(StrBuf);
	
}





void LX200_Write_SidT( void)
{
char buf[20];
unsigned char sign;
unsigned char hour;
unsigned char min;
unsigned char sec;
unsigned char hundsec;
//unsigned int deg;	
char TenthsMin;

	
	rad_to_time(SidT,&sign,&hour,&min,&sec,&hundsec);
    if( misc.lx200format)
	
	 sprintf(buf,"%02u:%02u:%02u#",hour,min,sec);
	 
	else 
	{
	    
		TenthsMin = (sec + 3)/6;
		if( TenthsMin > 9)
		{
			TenthsMin = 0;
			min++;
			if( min > 59)
			{
				min = 0;
				hour++;
			}
		}
		sprintf( buf, "%02d:%02d.%1d#", hour, min, TenthsMin);
	
	
	
	
	} 
	SendLx200Str( buf);

/*	int Hr, Min, TenthsMin;

	GetHMSH( RadToHundSec*Current.SidT + 0.5, &Current.SidTimeHMSH);
	if( misc.lx200format)
		sprintf( StrBuf, "%02d:%02d:%02d#", Current.SidTimeHMSH.Hr, Current.SidTimeHMSH.Min,
		Current.SidTimeHMSH.Sec);
	else
	{
		Hr = Current.SidTimeHMSH.Hr;
		Min = Current.SidTimeHMSH.Min;
		TenthsMin = (Current.SidTimeHMSH.Sec + 3)/6;
		if( TenthsMin > 9)
		{
			TenthsMin = 0;
			Min++;
			if( Min > 59)
			{
				Min = 0;
				Hr++;
			}
		}
		sprintf( StrBuf, "%02d:%02d.%1d#", Hr, Min, TenthsMin);
	}
	uartsendbuff(StrBuf);
	*/
}

void LX200_Write_LocalT( void)
{
char StrBuf[16];
	//gettime( &t);
	get_time_date();
	sprintf( StrBuf, "%02d:%02d:%02d#", ti.hour, ti.min, ti.sec);
	uartsendbuff(StrBuf);
}

/* gets site name (XYZ): GM GN GO GP correspond to 1 through 4; returns XYZ# */
/*
void LX200_GetSiteName( void)
{
/	sprintf( StrBuf, "SCP#");
	uartsendbuff(StrBuf);
}

/* gets the current minimum quality for the FIND operation, returns  SU#,  EX#,  VG#,  GD#,  FR#,
PR#  or VP# - superior, excellent, very good, good, fair, poor, very poor?
void LX200_Write_MinQualityFind( void)
{
	/*switch( LX200MinQualityFind)
	{
		case 0:
			sprintf( StrBuf, "SU#");
			break;
		case 1:
			sprintf( StrBuf, "EX#");
			break;
		case 2:
			sprintf( StrBuf, "VG#");
			break;
		case 3:
			sprintf( StrBuf, "GD#");
			break;
		case 4:
			sprintf( StrBuf, "FR#");
			break;
		case 5:
			sprintf( StrBuf, "PR#");
			break;
		case 6:
			sprintf( StrBuf, "VP#");
			break;
	}
	uartsendbuff(StrBuf);
}

*/
void LX200_Write_Date( void)
{
char StrBuf[16];
	//getdate( &d);
	sprintf( StrBuf, "%02d/%02d/%02d#", ti.mon, ti.date, ti.year);
	uartsendbuff(StrBuf);
}

void LX200_Write_Clock_Status( void)
{
char StrBuf[16];
	sprintf( StrBuf, "(24)#");
	uartsendbuff(StrBuf);
	
}

void LX200_Write_Lat( void)
{

unsigned char sign;
unsigned char min;
unsigned short deg;
unsigned char sec;

char StrBuf[17];

	
	rad_to_deg(misc.latitude,&sign,&deg,&min,&sec);
	if( sign == PLUS)
		sign = '+';
	else
		sign = '-';
	if( misc.lx200format)
		sprintf( StrBuf, "%c%02d%c%02d:%02d#", sign, deg, DegSym, min, sec);
	else
	{
		if( sec > 29)
		{
			min++;
			if( min > 59)
				deg++;
		}
		sprintf( StrBuf, "%c%02d%c%02d#", sign, deg, DegSym, min);
	}
	uartsendbuff(StrBuf);
	


}

void LX200_Write_Long( void)
{
unsigned char sign;
unsigned char min;
unsigned short deg;
unsigned char sec;
char StrBuf[17];	



	
	rad_to_deg(misc.longitude,&sign,&deg,&min,&sec);
	
	
	if( misc.lx200format)
		sprintf( StrBuf, "%03d%c%02d:%02d#", deg, DegSym, min, sec);
	else
	{
		if( sec > 29)
		{
			min++;
			if( min > 59)
				deg++;
		}
		sprintf( StrBuf,"%03d%c%02d#", deg, DegSym, min);
	}
	uartsendbuff(StrBuf);
	

}

void LX200_Write_Lat_Long( void)
{

float r;
int deg;
unsigned int degres;
char si;
float longi;
char StrBuf[17];

	
r=rad_to_degfloat(misc.latitude,&deg,&degres);
si='+';

if (deg<0)si='-'; 
deg=abs(deg);
sprintf(StrBuf,"%c%02d.%04u,",si,deg,degres);	
uartsendbuff(StrBuf);
	




if (misc.longitude>M_PI)
{
 si='-';
 // si='+';
longi=M2_PI-misc.longitude;
}
else

{
 //si='-';
  si='+';
 longi=misc.longitude;
}	
	
	r=rad_to_degfloat(longi,&deg,&degres);
    sprintf(StrBuf,"%c%03d.%04u#",si,deg,degres);
	uartsendbuff(StrBuf);
	

}

/* gets the timezone and returns sHH# */
void LX200_Write_Tz( void)
{
	//int TZOffset;
	//char s, h1, h2;
	char StrBuf[16];
	
	sprintf( StrBuf, "+00#");
	uartsendbuff(StrBuf);

/*	TZOffset = Tz - DST;
	if( TZOffset < 0)
		s = '-';
	else
		s = ' ';
	if( TZOffset > 9)
		h1 = '0' + TZOffset/10;
	else
	{
		h1 = s;
		s = ' '; 
	}
	h2 = '0' + (TZOffset & 10);

	//sprintf( StrBuf, "%c%c%c#", s, h1, h2);
	sprintf( StrBuf, "%c%c%c#", s, h1, h2);
	uartsendbuff(StrBuf);
	*/
}

/* gets the field radius of the FIELD operation and returns NNN# */

void LX200_Write_Field( void)
{
char buf[20];
	sprintf( buf, "100#");
	uartsendbuff(buf);
}

/* IxQ is the index in LX200 queue to start reading from */
int LX200_Read_Int_From_Queue( int IxQ)
{
	/* max digits expected for integer + terminating char */
	char N[5];

	for( Ix = 0; Ix < 5; Ix++, IxQ++)
	{
		IxQ %= LX200QueueSize;
		N[Ix] = LX200Queue[IxQ];
	}
	// the first unrecognized character ends the conversion 
	return atoi( N);
}

void LX200_Incr_Ix_Until_Terminate_Char( int* Ix)
{
	do
	{
		(*Ix)++;
		(*Ix) %= LX200QueueSize;
	}while(
	LX200Queue[*Ix] != ':' &&
	LX200Queue[*Ix] != DegSym &&
	LX200Queue[*Ix] != '#' &&
	LX200Queue[*Ix] != '*' &&
	LX200Queue[*Ix] != '.' &&
	LX200Queue[*Ix] != '/'&&
	LX200Queue[*Ix] != ',');
	
}

/* set number of chars to increment, starting at Ix+3, stopping at '#';
either call this function or execute IncrIx++ */
void LX200_Set_IncrIx(int Ix, int *IncrIx)
{
	int IxA;

	IxA = Ix+3;
	IxA %= LX200QueueSize;
	*IncrIx = 3;
	while( LX200Queue[IxA] != '#')
	{
		(*IncrIx)++;
		IxA++;
		IxA %= LX200QueueSize;
	}
	
}




void LX200_Read_Alt(int Ix)

{

int IxA;

In.DecDMS.Deg = In.DecDMS.Min = In.DecDMS.Sec = 0;
	In.DecDMS.Sign = PLUS;

	IxA = Ix+3;
	IxA %= LX200QueueSize;
	if( LX200Queue[IxA] == '-')
		In.DecDMS.Sign = MINUS;
	IxA++;
	In.DecDMS.Deg = LX200_Read_Int_From_Queue( IxA);
	LX200_Incr_Ix_Until_Terminate_Char( &IxA);
	if( LX200Queue[IxA] == DegSym || LX200Queue[IxA] == ':' || LX200Queue[IxA] == '*')
	{
		IxA++;
		In.DecDMS.Min = LX200_Read_Int_From_Queue( IxA);
		LX200_Incr_Ix_Until_Terminate_Char( &IxA);
		if( LX200Queue[IxA] == ':')
		{
			IxA++;
			In.DecDMS.Sec = LX200_Read_Int_From_Queue( IxA);
		}
	}
	else
		if( LX200Queue[IxA] == '#')
		{
			IxA++;
			In.DecDMS.Min = LX200_Read_Int_From_Queue( IxA);
		}

		In.Alt=deg_to_rad(In.DecDMS.Sign,In.DecDMS.Deg,In.DecDMS.Min,In.DecDMS.Sec);
}


void LX200_Read_Az(int Ix)

{
int IxA;

	In.DecDMS.Deg = In.DecDMS.Min = In.DecDMS.Sec = 0;
	In.DecDMS.Sign = PLUS;

	IxA = Ix+3;
	IxA %= LX200QueueSize;
	
	In.DecDMS.Deg = LX200_Read_Int_From_Queue( IxA);
	LX200_Incr_Ix_Until_Terminate_Char( &IxA);
	if( LX200Queue[IxA] == DegSym || LX200Queue[IxA] == ':' || LX200Queue[IxA] == '*')
	{
		IxA++;
		In.DecDMS.Min = LX200_Read_Int_From_Queue( IxA);
		LX200_Incr_Ix_Until_Terminate_Char( &IxA);
		if( LX200Queue[IxA] == ':')
		{
			IxA++;
			In.DecDMS.Sec = LX200_Read_Int_From_Queue( IxA);
		}
	}
	else
		if( LX200Queue[IxA] == '#')
		{
			IxA++;
			In.DecDMS.Min = LX200_Read_Int_From_Queue( IxA);
		}

		In.Az=deg_to_rad(In.DecDMS.Sign,In.DecDMS.Deg,In.DecDMS.Min,In.DecDMS.Sec);


}





void Lx200_Read_Lat(int Ix)

{

int IxA;

In.DecDMS.Deg = In.DecDMS.Min = In.DecDMS.Sec = 0;
	In.DecDMS.Sign = PLUS;

	IxA = Ix+3;
	IxA %= LX200QueueSize;
	if( LX200Queue[IxA] == '-')
		In.DecDMS.Sign = MINUS;
	IxA++;
	In.DecDMS.Deg = LX200_Read_Int_From_Queue( IxA);
	LX200_Incr_Ix_Until_Terminate_Char( &IxA);
	if( LX200Queue[IxA] == DegSym || LX200Queue[IxA] == ':' || LX200Queue[IxA] == '*')
	{
		IxA++;
		In.DecDMS.Min = LX200_Read_Int_From_Queue( IxA);
		LX200_Incr_Ix_Until_Terminate_Char( &IxA);
		if( LX200Queue[IxA] == ':')
		{
			IxA++;
			In.DecDMS.Sec = LX200_Read_Int_From_Queue( IxA);
		}
	}
	else
		if( LX200Queue[IxA] == '#')
		{
			IxA++;
			In.DecDMS.Min = LX200_Read_Int_From_Queue( IxA);
		}

		misc.latitude=deg_to_rad(In.DecDMS.Sign,In.DecDMS.Deg,In.DecDMS.Min,In.DecDMS.Sec);
}



void Lx200_Read_Long(int Ix)

{
int IxA;

	In.DecDMS.Deg = In.DecDMS.Min = In.DecDMS.Sec = 0;
	In.DecDMS.Sign = PLUS;

	IxA = Ix+3;
	IxA %= LX200QueueSize;
	
	if( LX200Queue[IxA] == '-')
	    {
		 In.DecDMS.Sign = MINUS;
	     IxA++;
		}
	
	In.DecDMS.Deg = LX200_Read_Int_From_Queue( IxA);
	LX200_Incr_Ix_Until_Terminate_Char( &IxA);
	if( LX200Queue[IxA] == DegSym || LX200Queue[IxA] == ':' || LX200Queue[IxA] == '*')
	{
		IxA++;
		In.DecDMS.Min = LX200_Read_Int_From_Queue( IxA);
		LX200_Incr_Ix_Until_Terminate_Char( &IxA);
		if( LX200Queue[IxA] == ':')
		{
			IxA++;
			In.DecDMS.Sec = LX200_Read_Int_From_Queue( IxA);
		}
	}
	else
		if( LX200Queue[IxA] == '#')
		{
			IxA++;
			In.DecDMS.Min = LX200_Read_Int_From_Queue( IxA);
		}

		misc.longitude=deg_to_rad(In.DecDMS.Sign,In.DecDMS.Deg,In.DecDMS.Min,In.DecDMS.Sec);
		if (misc.longitude<0)misc.longitude=M2_PI+misc.longitude;

}

void Lx200_Read_Lat_Long(int Ix)

{

int IxA;
int deg;
unsigned int degres;
char si;

	

	IxA = Ix+3;
	IxA %= LX200QueueSize;
	si='+';
	if (LX200Queue[IxA]=='+')
	{
	 si='+';	
	 IxA++;
	} 
	else
	if (LX200Queue[IxA]=='-')
	{
	 si='-';	
	 IxA++;
	} 
	
	deg= LX200_Read_Int_From_Queue( IxA);
	LX200_Incr_Ix_Until_Terminate_Char( &IxA);
	if( LX200Queue[IxA] =='.')
	{
		IxA++;
		degres = LX200_Read_Int_From_Queue( IxA);
		if (si=='-')deg=-deg;
		if ((deg<=90)&&(deg>=-90))
		{
		 misc.latitude=degfloat_to_rad(deg,degres);
		} 
	}	



LX200_Incr_Ix_Until_Terminate_Char( &IxA);
if( LX200Queue[IxA] ==',')
	
{
	IxA++;
	
	si='+';
	if (LX200Queue[IxA]=='-')
	{
	 si='-';	
	 IxA++;
	} 
	if (LX200Queue[IxA]=='+')
	{
	 si='+';	
	 IxA++;
	} 
	
	
	deg= LX200_Read_Int_From_Queue( IxA);
	LX200_Incr_Ix_Until_Terminate_Char( &IxA);
	if( LX200Queue[IxA] =='.')
	{
		IxA++;
		degres= LX200_Read_Int_From_Queue( IxA);
		if (deg<=180)
			{
			// if (si=='+')
			   if (si=='-')
			  {
			   deg=360-deg;
			   degres=10000-degres;
			   if (degres)deg--;
			  }
			 
			  
			  
			 
			  
			  
			 
	 		 misc.longitude=degfloat_to_rad(deg,degres);
			
			} 
		}
 }
}


/* 012345678901   01234567890
	  _HH:MM:SS# or  _HH:MM.T# ; values may be 1 or 2 chars long */
void LX200_Read_Ra( int Ix)
{
	int IxA;

	send_LX200_OK();

	In.RaHMSH.Sign = PLUS;
	In.RaHMSH.Hr = In.RaHMSH.Min = In.RaHMSH.Sec = In.RaHMSH.HundSec = 0;

	IxA = Ix+3;
	In.RaHMSH.Hr = LX200_Read_Int_From_Queue( IxA);
	LX200_Incr_Ix_Until_Terminate_Char( &IxA);
	if( LX200Queue[IxA] == ':')
	{
		IxA++;
		In.RaHMSH.Min = LX200_Read_Int_From_Queue( IxA);
		LX200_Incr_Ix_Until_Terminate_Char( &IxA);
		if( LX200Queue[IxA] == ':')
		{
			IxA++;
			In.RaHMSH.Sec = LX200_Read_Int_From_Queue( IxA);
		}
		else
			if( LX200Queue[IxA] == '.')
			{
				IxA++;
				In.RaHMSH.Sec = 6 * LX200_Read_Int_From_Queue( IxA);
			}
	}
	In.Ra=time_to_rad(In.RaHMSH.Sign,In.RaHMSH.Hr,In.RaHMSH.Min,In.RaHMSH.Sec,In.RaHMSH.HundSec);
	if (In.Ra>M2_PI)In.Ra-=M2_PI;    //ha nagyobb mint 24 ra																   
	//CalcRadFromHMSH( &In.Ra, In.RaHMSH);
	//DisplayIn( "from LX200", NameBlanks);
	//Response = MenuResetEquat;
	//GetNewMenuCatSubFromResponse();
	//UpdateMenuCatSub();
	
}

/* 012345678901    01234567890
	  _sDD*MM:SS# or  _sDD*MM# ; ':' and DegSym (223) may substitude for '*', and values may be 1 or
2 chars long */
void LX200_Read_Dec( int Ix)
{
	int IxA;
    
	send_LX200_OK();

	In.DecDMS.Deg = In.DecDMS.Min = In.DecDMS.Sec = 0;
	In.DecDMS.Sign = PLUS;

	IxA = Ix+3;
	IxA %= LX200QueueSize;
	if( LX200Queue[IxA] == '-')
		In.DecDMS.Sign = MINUS;
	IxA++;
	In.DecDMS.Deg = LX200_Read_Int_From_Queue( IxA);
	 
	LX200_Incr_Ix_Until_Terminate_Char( &IxA);
	if( LX200Queue[IxA] == DegSym || LX200Queue[IxA] == ':' || LX200Queue[IxA] == '*')
	{
		IxA++;
		In.DecDMS.Min = LX200_Read_Int_From_Queue( IxA);
		
		LX200_Incr_Ix_Until_Terminate_Char( &IxA);
		
		if( LX200Queue[IxA] == ':')
		{
			IxA++;
			In.DecDMS.Sec = LX200_Read_Int_From_Queue( IxA);
			
		}
	}
	else
		if( LX200Queue[IxA] == '#')
		{
			IxA++;
			In.DecDMS.Min = LX200_Read_Int_From_Queue( IxA);
		}

		In.Dec=deg_to_rad(In.DecDMS.Sign,In.DecDMS.Deg,In.DecDMS.Min,In.DecDMS.Sec);

		
//	CalcRadFromDMS( &In.Dec, In.DecDMS);
//	DisplayIn( "from LX200", NameBlanks);
//	Response = MenuResetEquat;
//	GetNewMenuCatSubFromResponse();
//	UpdateMenuCatSub();
	
}

/* _HH:MM:SS# (always use 24 hr format) */
void LX200_Read_SidT(  int Ix)
{
	/*int IxA;
	float SidTDiff, TDiff, CurrentSolarTimeRad, NewCurrentSolarTimeRad;

	uartSendByte( LX200ComPort, LX200_OK);

	In.SidTimeHMSH.Sign = Plus;
	In.SidTimeHMSH.Hr = In.SidTimeHMSH.Min = In.SidTimeHMSH.Sec =
	In.SidTimeHMSH.HundSec = 0;

	IxA = Ix+3;
	In.SidTimeHMSH.Hr = LX200_Read_Int_From_Queue( IxA);
	LX200_Incr_Ix_Until_Terminate_Char( &IxA);
	if( LX200Queue[IxA] == ':')
	{
		IxA++;
		In.SidTimeHMSH.Min = LX200_Read_Int_From_Queue( IxA);
		LX200_Incr_Ix_Until_Terminate_Char( &IxA);
		if( LX200Queue[IxA] == ':')
		{
			IxA++;
			In.SidTimeHMSH.Sec = LX200_Read_Int_From_Queue( IxA);
		}
	}
	CalcRadFromHMSH( &In.SidT, In.SidTimeHMSH);

	// get sidereal time difference 
	SidTDiff = Current.SidT - In.SidT;
	//convert time difference to solar time 
	TDiff = SidTDiff / SidRate;
	CurrentSolarTimeRad = (float) t.ti_hour * HrToRad + (float) t.ti_min * MinToRad +
	(float) t.ti_sec * SecToRad + (float) t.ti_hund * HundSecToRad;
	// calculate new solar time 
	NewCurrentSolarTimeRad = CurrentSolarTimeRad - TDiff;
	while( NewCurrentSolarTimeRad < 0)
		NewCurrentSolarTimeRad += OneRev;
	while( NewCurrentSolarTimeRad > OneRev)
		NewCurrentSolarTimeRad -= OneRev;
	 change system time 
	t.ti_hour = (int) (NewCurrentSolarTimeRad * RadToHr);
	t.ti_min = (int) ((NewCurrentSolarTimeRad - (float) t.ti_hour * HrToRad) * RadToMin);
	t.ti_sec = (int) ((NewCurrentSolarTimeRad - (float) t.ti_hour * HrToRad - (float) t.ti_min * MinToRad) * RadToSec);
	t.ti_hund = 0;
	settime( &t);
	NewSidT();
	*/
}

/* _HH:MM:SS# (always use 24 hr format) */
void LX200_Read_LocalT(  int Ix)
{
	int IxA;
//	long Yr;
//	int M;
//	int D;
	int hr, min, sec;

	send_LX200_OK();

	IxA = Ix+3;
	hr = min = sec = 0;
	hr = LX200_Read_Int_From_Queue( IxA);
	LX200_Incr_Ix_Until_Terminate_Char( &IxA);
	if( LX200Queue[IxA] == ':')
	{
		IxA++;
		min = LX200_Read_Int_From_Queue( IxA);
		LX200_Incr_Ix_Until_Terminate_Char( &IxA);
		if( LX200Queue[IxA] == ':')
		{
			IxA++;
			sec = LX200_Read_Int_From_Queue( IxA);
		}
	}
	tis.hour=hr;
	tis.min=min;
	tis.sec=sec;
//	log_DISK(LOG_LX200,"SET TIME",0,0,tis.hour,tis.min);
	set_LX200_time();
	
	
	/*
	getdate( &d);
	 set century for Y2K problem with CMOS clock 
	Century = d.da_year / 100;
	Yr = (long) d.da_year;
	M = (int) d.da_mon;
	D = (int) d.da_day;

	SetRealTimeClock( hr, min, sec);
	SetDOSToCMOS_RTC_f_ptr();
	SetStartBiosClockAndSidTime( Yr, M, D, hr, min, sec, Tz, DST, LongitudeDeg);
	
	*/
}

/* _MM/DD/YY# */
void LX200_Read_CurrentDate(  int Ix)
{
	int IxA;
//	int h;
//	int m;
//	float s;
	long year;
	int mon, day;

	send_LX200_OK();

	year = 0;
	mon = day = 0;
	// _MM/DD/YY# 

	IxA = Ix+3;
	mon = LX200_Read_Int_From_Queue( IxA);
	LX200_Incr_Ix_Until_Terminate_Char( &IxA);
	if( LX200Queue[IxA] == '/')
	{
		IxA++;
		day = LX200_Read_Int_From_Queue( IxA);
		LX200_Incr_Ix_Until_Terminate_Char( &IxA);
		if( LX200Queue[IxA] == '/')
		{
			IxA++;
			year = LX200_Read_Int_From_Queue( IxA);
		}
	}
	tis.year=year;
	tis.mon=mon;
	tis.date=day;
//	log_DISK(LOG_LX200,"SET DATE",0,0,tis.mon,tis.date);
	set_date();
	
	/*
	if( year > 80)
		Century = 19;
	else
		Century = 20;

	gettime( &t);
	h = (int) t.ti_hour;
	m = (int) t.ti_min;
	s = ((float) t.ti_sec) + (t.ti_hund / 100.);

	SetDateofRealTimeClock( Century, (int) year, mon, day);
	SetDOSToCMOS_RTC_f_ptr();
	SetStartBiosClockAndSidTime( year, mon, day, h, m, s, Tz, DST, LongitudeDeg);
	*/
}

void LX200_Read_PulseGuide (int Ix){

	int inttemp;
	int IxA;								//Mgw1234#

	IxA = Ix+1;

	inttemp = LX200_Read_Int_From_Queue(IxA);
 //   printf("C:%c,pulseg:%d\r\n",LX200Queue[Ix],inttemp);
    pulse_guide(LX200Queue[Ix],inttemp);

}


char Lx200_set_reduction(void)


{

int inttemp;
int IxA;

IxA=IIx+3;
inttemp=LX200_Read_Int_From_Queue(IxA);
LX200_Incr_Ix_Until_Terminate_Char( &IxA);
if( LX200Queue[IxA] == ',')
		{
			IxA++;
			mot[RA].reduction=inttemp;
			inttemp=LX200_Read_Int_From_Queue(IxA);
			mot[DEC].reduction=inttemp;
			send_LX200_OK();
			initallparam=1;
		}
return(0);



}

char Lx200_set_int_param(unsigned short *a,unsigned short *b,short sp)

{
int inttemp;
int IxA;
unsigned char mul=1;

if (sp >= 0x100){					// speeds count with a 10x factor

	sp = sp & 0x100;
	mul = 10;

}

IxA=IIx+3;
inttemp=LX200_Read_Int_From_Queue(IxA);
LX200_Incr_Ix_Until_Terminate_Char( &IxA);
if( LX200Queue[IxA] == ',')
		{
			IxA++;
			*a=inttemp*mul;
			inttemp=LX200_Read_Int_From_Queue(IxA);
			*b=inttemp*mul;
			send_LX200_OK();
			if (sp)saveparams=sp;
		}
return(0);
}

char Lx200_set_char_param(unsigned char *a,unsigned char *b,char sp)

{
int inttemp;
int IxA;

IxA=IIx+3;
inttemp=LX200_Read_Int_From_Queue(IxA);
LX200_Incr_Ix_Until_Terminate_Char( &IxA);
if( LX200Queue[IxA] == ',')
		{
			IxA++;
			if (sp == 'n'){*a &= ~ 0x01; *a |= inttemp & 0x01 ; } // rotatione is interpreted on several bits
			else *a=inttemp;
			inttemp=LX200_Read_Int_From_Queue(IxA);
			if (sp == 'n'){*b &= ~ 0x01; *b |= inttemp & 0x01 ; }
			else *b=inttemp;
			send_LX200_OK();
			if (sp)saveparams=sp;
		}
return(0);
}

void sendpr10(unsigned short sp1,unsigned short sp2){
	char StrBuf[17];
	sprintf(StrBuf,conststr_4_4,sp1/10,sp2/10);
	uartsendbuff(StrBuf);
}

void sendpr_int(unsigned int sp1,unsigned short sp2){
	char StrBuf[17];
	sprintf(StrBuf,conststr_4_4,sp1,sp2);
	uartsendbuff(StrBuf);
}


void ProcessLX200Cmds( void)
{
	int Ix, IxA, Ix1, Ix2, IncrIx;
//	int HoldButtons = Buttons;
	int inttemp;
	char temp;
	char StrBuf[17];
	unsigned short deg;
	unsigned char min;
	unsigned char sec;
	unsigned short mini;
    unsigned short seci;
    unsigned short red_ra;
    unsigned short red_dec;
	
    unsigned char sign;

	Ix = Beg_LX200_Ix;
	IxA = LX200_Ix+1;
	IxA %= LX200QueueSize;
    //printf("%s",LX200Queue[Ix]);
	while( Ix != IxA)
	{
		IncrIx = 1;
		/* all commands start with a ':' */
		
		
		
		
		if( LX200Queue[Ix] == ':')
		{
			/* set Ix to first letter of LX200 command following the ':' */
			Ix++;
			Ix %= LX200QueueSize;
			Ix1 = Ix+1;
			Ix1 %= LX200QueueSize;
			Ix2 = Ix1+1;
			Ix2 %= LX200QueueSize;
//			printf("-%c%c%c%c%c%c",LX200Queue[Ix],LX200Queue[Ix+1],LX200Queue[Ix+2]+LX200Queue[Ix+3],LX200Queue[Ix+4],LX200Queue[Ix+5]);
			switch( LX200Queue[Ix])
			{
			
			    case 'Y':		   	  //            extended commands
				    IIx=Ix;
				    IncrIx++;
					//LX200uartSendBytebuff( LX200ComPort, '2');
					switch( LX200Queue[Ix1])
					{
/*					    case 'A':
					    	//no_synctest=0;
					    	//estiteszt=0;
					    	//sprintf(StrBuf,"synctest off  ");
					    	inc_enc_propo();
					    	uartsendbuff(StrBuf);
					    break;

					    case 'B':
							//no_synctest=1;
					    	//estiteszt=1;

							//sprintf(StrBuf,"synctest on");
					    	dec_enc_propo();
							uartsendbuff(StrBuf);
						break;

					    case '9':
							no_synctest=0;
							//estiteszt=0;
							sprintf(StrBuf,"no_synctest off  ");
							uartsendbuff(StrBuf);
						break;

						case '8':
							no_synctest=1;
							//estiteszt=1;

							sprintf(StrBuf,"no_synctest on");
							uartsendbuff(StrBuf);
						break;










					    case '1':
							///no_synctest=1;
							inc_enc_prop();
							sprintf(StrBuf,"prop +");
							uartsendbuff(StrBuf);
						break;

					    case '2':
							///no_synctest=1;

					    	dec_enc_prop();
							sprintf(StrBuf,"prop -");
							uartsendbuff(StrBuf);
						break;

*/



					 	case 'C':			//catalogue handling
					    IncrIx++;
						//LX200( LX200ComPort, '2'); //KOMPATIBILITS
						
						//LX200_enabled=0;
						//LX200uartSendBytebuff( LX200ComPort, '3'); //KOMPATIBILITS
						//LX200_port(CAT_WRITE);
						temp=LX200Queue[Ix1+1]-'0';
	//					printf("\n\rkatal=%d\n\r",temp);
	//					no_synctest=1;
						cat_write_start(temp);  //hogy melyik kat.
						/*	   
							   if (write_cat_file(1))
							    uartSendByte( LX200ComPort, LX200_OK);
							else uartSendByte( LX200ComPort, 99);	//faulty comm
						
						
						 LX200_enabled=1;*/
						  switch( LX200Queue[Ix1])
						  {
						     case 'D':			  //download
							   
							   send_LX200_OK();
							   
							 //  if (write_cat_file(1))
							 //   uartSendByte( LX200ComPort, LX200_OK);
							//else uartSendByte( LX200ComPort, 99);	//faulty comm
							 break;
							 case 'U':			  //upload
						  	  
							 break; 

/*
							 case 'S':
							  no_synctest=1;
							  LX200uartSendBytebuff( LX200ComPort, 'x');
							  LX200uartSendBytebuff( LX200ComPort, '#');
							 break;

							 case 's':
							  no_synctest=0;
							  LX200uartSendBytebuff( LX200ComPort, '0');
						      LX200uartSendBytebuff( LX200ComPort, '#');
							 break;*/
						  }
						
						break;
						
						
						case 'G':				  //:YGx ask
						IncrIx++;
						  switch( LX200Queue[Ix2])
						  {
						  
						   case 'a':			  //austostop local/global
						    IncrIx++;

							sprintf(StrBuf,"%01d,%01d#",autostop_local_enable,misc.autostop_global_enable);
							uartsendbuff(StrBuf);
						   break;
						   
						   case 'b':			  //backlash
						    IncrIx++;

							rad_to_deg(userpar[DEC].backlash,&sign,&deg,&min,&sec);
							//if (min>9)min=9;
							sprintf(StrBuf,"%01u:%02u#",min,sec);				    
							uartsendbuff(StrBuf);
						   break;
						   
						   
						   case 'd':			//display tartalom		  
						    IncrIx++;
							uartSendBuffer( LX200ComPort, Display_mem, 32);
							sprintf(StrBuf,"#");				    
							uartsendbuff(StrBuf);
							
						   break;
						   case 'e':			  //motres
						    IncrIx++;
							//sprintf(StrBuf,conststr_4_4,mot[RA].motres,mot[DEC].motres);
							//uartsendbuff(StrBuf);
						    sendpr_int(mot[RA].motres,mot[DEC].motres);
						   break;
						   
						   case 'g':			  //gotocurr
						    IncrIx++;
							//sprintf(StrBuf,conststr_4_4,mot[RA].gotocurr,mot[DEC].gotocurr);
							//uartsendbuff(StrBuf);
						    sendpr_int(mot[RA].gotocurr,mot[DEC].gotocurr);

						   break;
						   
						   case 'h':			  //IsHomeSet
						    IncrIx++;
							if (userpar[RA].home||userpar[DEC].home)
							
		                    sprintf(StrBuf,"1#"); else sprintf(StrBuf,"0#");
							uartsendbuff(StrBuf);
						   break;
						   
						   case 'i':			  //IsSlewing
						    IncrIx++;
							
							sprintf(StrBuf,"%01d#",IsSlewing||swappingtube);
							uartsendbuff(StrBuf);
						   break;
						   
						   case 'j':			  //IsMountParking
						    IncrIx++;
							
							sprintf(StrBuf,"%01d#",IsParking);
							uartsendbuff(StrBuf);
						   break;
						   
						   case 'k':			  //IsMountParked
						    IncrIx++;
							
							sprintf(StrBuf,"%01d#",IsParked);
							uartsendbuff(StrBuf);
						   break;
						   
						   
						   case 'l':				//latlong	  
							IncrIx++;							
							LX200_Write_Lat_Long();
							break;
						   
						   case 'm':				 //maingear
						    IncrIx++;
						    //sprintf(StrBuf,conststr_4_4,mot[RA].maingear,mot[DEC].maingear);
							//uartsendbuff(StrBuf);
						    sendpr_int(mot[RA].maingear,mot[DEC].maingear);
						   break;
						   
						   case 'n':			  //rotation
						    IncrIx++;
							sprintf(StrBuf,"%01d,%01d#",mot[RA].rotation & 0x01 ,mot[DEC].rotation & 0x01);
							uartsendbuff(StrBuf);
						   break;
						   
						   
						   case 'p':			  //ramp
						    IncrIx++;
							sprintf(StrBuf,"%01d,%01d#",userpar[RA].ramp,userpar[DEC].ramp);
							uartsendbuff(StrBuf);
						   break;
						  
						  
						  
						   
						  
						   case 'r':			  //reduction
						    IncrIx++;
							//sprintf(StrBuf,conststr_4_4,(unsigned int)mot[RA].reduction,(unsigned int)mot[DEC].reduction);
							//uartsendbuff(StrBuf);
						    sendpr_int((unsigned int)mot[RA].reduction,(unsigned int)mot[DEC].reduction);

						   break;
						   
						   case 's':			  //stopcurr
						    IncrIx++;
							//sprintf(StrBuf,conststr_4_4,mot[RA].stopcurr,mot[DEC].stopcurr);
							//uartsendbuff(StrBuf);
						    sendpr_int((unsigned int)mot[RA].stopcurr,(unsigned int)mot[DEC].stopcurr);
						   break;
						   
						   case 't':			  //track
						    IncrIx++;
							//sprintf(StrBuf,conststr_4_4,mot[RA].trackcurr,mot[DEC].trackcurr);
							//uartsendbuff(StrBuf);
						    sendpr_int((unsigned int)mot[RA].trackcurr,(unsigned int)mot[DEC].trackcurr);
						   break;
						   
						   
						   
						   case 'u':
							IncrIx++;		//Destinationsideofpier ascom   
							//sprintf(StrBuf,"%01d#",get_dest_meridian());
							//uartsendbuff(StrBuf);
						    break;
						   
						   //nagybetk
						  
						   
						   case 'A':
						    IncrIx++;
							//sprintf(StrBuf,conststr_4_4,userpar[RA].guidingspeed,userpar[DEC].guidingspeed);
							//uartsendbuff(StrBuf);
						    sendpr_int(userpar[RA].guidingspeed,userpar[DEC].guidingspeed);
						   break;
						   
						   case 'B':
						    IncrIx++;
						    sendpr10(userpar[RA].slew1,userpar[DEC].slew1);
						//	sprintf(StrBuf,conststr_4_4,userpar[RA].slew1/10,userpar[DEC].slew1/10);
						//	uartsendbuff(StrBuf);
						   break;
						   
						   case 'C':
						    IncrIx++;
						    sendpr10(userpar[RA].slew2,userpar[DEC].slew2);
						//	sprintf(StrBuf,conststr_4_4,userpar[RA].slew2/10,userpar[DEC].slew2/10);
						//	uartsendbuff(StrBuf);
						   break;
						   
						   case 'D':
						    IncrIx++;
						    sendpr10(userpar[RA].slew3,userpar[DEC].slew3);
						//	sprintf(StrBuf,conststr_4_4,userpar[RA].slew3/10,userpar[DEC].slew3/10);
						//	uartsendbuff(StrBuf);
						   break;
						   
						   case 'E':
						    IncrIx++;
						    sendpr10(userpar[RA].gotospeed,userpar[DEC].gotospeed);
						//	sprintf(StrBuf,conststr_4_4,userpar[RA].gotospeed/10,userpar[DEC].gotospeed/10);
						//	uartsendbuff(StrBuf);
						   break;
						   
						   case 'H':
						    IncrIx++;
							sprintf(StrBuf,"%01d#",misc.motorfreq);
							uartsendbuff(StrBuf);
						   break;	
						   case 'M':
						    IncrIx++;
							sprintf(StrBuf,"%01d#",misc.mounttype);
							uartsendbuff(StrBuf);
						   break;	
						   
						   case 'N':
						    IncrIx++;
							sprintf(StrBuf,"%01d#",misc.meridian);
							uartsendbuff(StrBuf);
						   break;	
						   
						   
						   
						   
						   
						   case 'P':					  //PEC corr
						    IncrIx++;
							sprintf(StrBuf,"%01d,%01d#",userpar[RA].PEC_corr,userpar[DEC].PEC_corr);
							uartsendbuff(StrBuf);
						   break;
						   case 'Q':
						    IncrIx++;
							sprintf(StrBuf,"%01d#",(misc.polecross & 0x01));
							uartsendbuff(StrBuf);
						   break;	
						   
						   case 'R':					  //refract corr
						    IncrIx++;
							sprintf(StrBuf,"%01d,%01d#",userpar[RA].refract_corr,userpar[DEC].refract_corr);
							uartsendbuff(StrBuf);
						   break;
						   
						   
						   
						   case 'S':					  //Rate sel
						    IncrIx++;
							sec=userpar[RA].rate_sel_1;
							if (sec==7)sec=0;		   //still rate should be '0'
							sprintf(StrBuf,"%01d,%01d#",sec,sec);
							uartsendbuff(StrBuf);
						   break;
						   
						   case 'U':					  //user Rare1 RA,DEC /min
						    IncrIx++;
						    LX200_Write_Userrate1();
						    
						   
						   break;
						   
						   case 'W':
						    IncrIx++;
							sprintf(StrBuf,"%02d#",misc.swapdelay);
	//						sprintf(StrBuf,"%01d#",misc.home_meridian);
							uartsendbuff(StrBuf);
						   break;	
						   
						   case 'X':
						    IncrIx++;
						    LX200_Write_homepos();
							 
						   break;
						   
						  }
						break;
						
						
						case 'S': 				  //:YSx set
						IncrIx++;
						 switch( LX200Queue[Ix2])
						 {
						   
						   
						   
						   case 'u':			 //upgrade  u1
						    IncrIx++;
							inttemp=LX200_Read_Int_From_Queue(Ix+3);
							if (inttemp==1)LX200_upgrade=1; 
								//do_upgrade();					   
						   break;
						   
						   case 'a':
						   IncrIx++;
						   Lx200_set_char_param(&autostop_local_enable,&misc.autostop_global_enable,'a');
						   break;
						 
						   case 'b':			  //backlash
						    IncrIx++;
							//rad_to_deg(userpar[DEC].backlash,&sign,&deg,&min,&sec);
							//if (min>9)min=9;
							//sprintf(StrBuf," %01u:%02u",min,sec);		
							Lx200_set_int_param(&mini,&seci,'b');
							if (mini>9)mini=9;	    
							userpar[DEC].backlash=deg_to_rad(PLUS,0,mini,seci);
						   break;
						   
						   case 'd':				//key simulation						   
						   IncrIx++;
						  // if (LX200Queue[Ix+4]=='#')
						   PutKeyBuf(LX200Queue[Ix+3]);
						  // send_LX200_OK();
						   case 'e':				 //motres
						    IncrIx++;
						    Lx200_set_int_param(&mot[RA].motres,&mot[DEC].motres,'e');
						   break;
						   
						   break;
						   
						   case 'g':				 //gotocurr
						    IncrIx++;
						    Lx200_set_int_param(&mot[RA].gotocurr,&mot[DEC].gotocurr,'g');
						   break; 
						  
						   case 'i':
						    LX200_setlimit_base();
							//saveparams='i';
							send_LX200_OK();
						  break;
						   

     					
							
						   
						   
						 
						
						
									 
						 
						  
						  case 'l':
						    Lx200_Read_Lat_Long(Ix);
							saveparams='l';
							send_LX200_OK();
						  break;
						  
						  case 'm':				 //maingear
						   IncrIx++;
						   Lx200_set_int_param(&mot[RA].maingear,&mot[DEC].maingear,'m');
						  break; 
						  
						  
						  case 'n':				 //rotation
						   IncrIx++;
						   Lx200_set_char_param(&mot[RA].rotation,&mot[DEC].rotation,'n');
						  break; 
						  
						  case 'p':			  //ramp
						   IncrIx++;
							Lx200_set_int_param(&userpar[RA].ramp,&userpar[DEC].ramp,'p');
						   break;
						   
						  case 'r':				 //reduction
						   IncrIx++;
						   Lx200_set_int_param(&red_ra,&red_dec,'r');  //lx200 recognises integer total red only
						   mot[RA].reduction=red_ra;
						   mot[DEC].reduction=red_dec;
						   Lx200_set_reduction();				 
						  break; 
						  
						  
						   
						  
						  
						  case 's':				 //stopcurr
						   IncrIx++;
						   Lx200_set_int_param(&mot[RA].stopcurr,&mot[DEC].stopcurr,'s');
						  break;
						   
						  case 't':				 //trackcurr
						   IncrIx++;
						   Lx200_set_int_param(&mot[RA].trackcurr,&mot[DEC].trackcurr,'t');
						  break; 
						  
						  
						   
						   				 
						
						  
						
						
												 
						 
						  
						  
						  case 'A':				 //guidingspeed
						   IncrIx++;
						   Lx200_set_int_param(&userpar[RA].guidingspeed,&userpar[DEC].guidingspeed,'A');
						  break; 
						  case 'B':				 //slew1
						   IncrIx++;
						   Lx200_set_int_param(&userpar[RA].slew1,&userpar[DEC].slew1,'B'|0x100);
						  break; 
						  case 'C':				 //slew2
						   IncrIx++;
						   Lx200_set_int_param(&userpar[RA].slew2,&userpar[DEC].slew2,'C'|0x100);
						  break; 
						  case 'D':				 //slew3
						   IncrIx++;
						   Lx200_set_int_param(&userpar[RA].slew3,&userpar[DEC].slew3,'D'|0x100);
						  break; 
						  case 'E':				 //gotospeed
						   IncrIx++;
						   Lx200_set_int_param(&userpar[RA].gotospeed,&userpar[DEC].gotospeed,'E'|0x100);
						  break; 
						  case 'H':				//Hemisphere //Motorfreq							 
						   IncrIx++;						   
						   inttemp=LX200_Read_Int_From_Queue(Ix+3);
						   misc.hemisphere=inttemp;
						   saveparams='H';
						   send_LX200_OK();
						  break;
						  case 'M':			 //mount type
						   IncrIx++;						   
						   inttemp=LX200_Read_Int_From_Queue(Ix+3);
						   misc.mounttype=inttemp;
						   saveparams='M';
						   send_LX200_OK();
						  break;
						  
						  case 'N':  //meridian
						   IncrIx++;						   
						   inttemp=LX200_Read_Int_From_Queue(Ix+3);
						   misc.meridian=inttemp;
						   saveparams='N';
						   send_LX200_OK();
						  break;
						  
						  case 'Q':  //polecross
						   IncrIx++;						   
						   inttemp=LX200_Read_Int_From_Queue(Ix+3);
						   misc.polecross &= ~0x01;
						   misc.polecross |=(inttemp & 1);
						   saveparams='Q';
						   send_LX200_OK();
						  break;
						  
						  case 'W':     //swap
						   IncrIx++;						   
						   inttemp=LX200_Read_Int_From_Queue(Ix+3);
						   misc.swapdelay=inttemp;
						   //misc.home_meridian=inttemp;
						   saveparams='W';
						   send_LX200_OK();
						  break;
						  
						  
						  
						  
						  case 'R':				 //refract
						   IncrIx++;
						   Lx200_set_char_param(&userpar[RA].refract_corr,&userpar[DEC].refract_corr,'R');
						  break; 
						  
						  case 'P':				 //PEC
						   IncrIx++;
						   {
						   unsigned char kamu; 	   
//						   Lx200_set_char_param(&userpar[RA].PEC_corr,&userpar[DEC].PEC_corr);	
						   Lx200_set_char_param(&userpar[RA].PEC_corr,&kamu,'P');  //mert DEC Pec mr nincs
						   }
						  break; 
						  
						  case 'S':				 //rate sel
						   IncrIx++;
						   //Lx200_set_char_param(&userpar[RA].rate_sel,&userpar[DEC].rate_sel);
						   Lx200_set_char_param(&min,&sec,0);
						   set_rate_type(min);	
						//   log_DISK(LOG_LX200,"RATE SEL",0,0,min,sec);
						   saveparams='S';
						  break;
						  
						  case 'U':				//User rate 1 RA,DEC
						   IncrIx++;
						   LX200_Read_Userrate1(Ix);
						   saveparams='U';
						  break;
						  
						  case 'X':				//set Home pos.												
						   IncrIx++;
						   
						   LX200_Read_homepos(Ix);
	//					   set_home_pos(0);
						   saveparams='X';
						   
						  break;
						  
						 
						  
						 }
						break;
						
						
						case 'H':		  //Goto Home
						IncrIx++;
						 if (!IsParked){
						 LX200_gohome=1;
						 send_LX200_OK();
						 }
						 else 
						 LX200uartSendBytebuff('0');
						 LX200uartSendBytebuff('#');
						break;
						
//#ifdef REDUCED
						
						case 'L':		  //Live , Wake up from Home
						 IncrIx++;
						 
						  
						 if (LX200_wake_up())
						 send_LX200_OK();
						 else
						 LX200uartSendBytebuff('0');
						 
						 LX200uartSendBytebuff('#');
						 
						break;
				
//#endif						
						case 'V':
						
						  
						  {
						  
						  
						  unsigned char i;
						    IncrIx++;

                            for (i=0;i<16;i++){
							StrBuf[i]=VER_str[i];
							}
							StrBuf[i]=0;
							uartsendbuff(StrBuf);
							sprintf(StrBuf,",");
							uartsendbuff(StrBuf);
							for (i=0;i<16;i++){
							StrBuf[i]=DATE_str[i];
							}
							StrBuf[i]=0;
							uartsendbuff(StrBuf);
							LX200uartSendBytebuff('#');
							
						   }	
							break;
						
						case 'W':             //swap tube
						   IncrIx++;
						   LX200_swap_tube=1;
						   send_LX200_OK();
						   LX200uartSendBytebuff('#');
						break;
						
						case 'P':			//PEC handling
						IncrIx++;
						 switch( LX200Queue[Ix2])
						 {
						  case 'R':			//record	
						  
						   LX200_pec_start(); 
						   send_LX200_OK();
						   break;
						   case 'S':			//stop	 
						    LX200_pec_Save();
							send_LX200_OK();
						   break;	  	
						   
						  case 'L':			//stop	 
						    LX200_pec_Load();
							send_LX200_OK();
						   break;	   
							   
						  case 'T':			//stop	 
						    LX200_pec_stop();
							send_LX200_OK();
						   break;	   
						  
						  case 'U':			//upload    from PC
						   cat_write_start(PEC_MEM);
						   
						   break;
						   
						  case 'D':			//download	 to PC
						   cat_read_start(PEC_MEM); 
						    
						   break; 
						
						  case 'C':			//Syncronize 
						   LX200_Sync_pec();
						   send_LX200_OK();
						   
						   break; 
						   
						  case 'G':			//get counters 
						    sprintf(StrBuf,"%03d#",debug_int);
							uartsendbuff(StrBuf);
						   			   
						   break;  
						   
						 }
						break;
						
						
						
									
					}
				
			    break;
#ifdef lxexten			    
				case 'A':
					IncrIx++;
					switch( LX200Queue[Ix1])
					{
						case 'A':
							IncrIx++;
//							InsertLX200CmdIntoArray( AlignAltaz);
//							InitConvertAltaz();
							break;
						case 'L':
							IncrIx++;
//							InsertLX200CmdIntoArray( AlignLand);
							/* conclude with tracking off: following function reverses the TrackFlag */
							TrackFlag = On;
//							ProcessMenuTrack();
							break;
						case 'P':
							IncrIx++;
//							InsertLX200CmdIntoArray( AlignPolar);
//							InitConvertEquat();
							break;
						default:
//							InsertLX200CmdIntoArray( LX200_Unknown_Cmd1);
							;
					}
					break;
				/* increases (B+) or decreases (B-) reticle brightness, or sets to one of the flashing
				modes (B0, B1, B2 or B3) */
				case 'B':
					IncrIx++;
					switch( LX200Queue[Ix1])
					{
						case '+':
						case '-':
						case '0':
						case '1':
						case '2':
						case '3':
							IncrIx++;
//							InsertLX200CmdIntoArray( ReticleCommand);
							break;
						default:
//							InsertLX200CmdIntoArray( LX200_Unknown_Cmd1);
							;
					}
					break;
#endif					
				case 'C':
					IncrIx++;
					switch( LX200Queue[Ix1])
					{
						case 'M':   //inicializl
							IncrIx++;   
//							InsertLX200CmdIntoArray( Sync);
//							Response = MenuResetEquat;
//							GetNewMenuCatSubFromResponse();
//							UpdateMenuCatSub();
//							ProcessMenuSelection();
							if (!IsParked)do_LX200_sync();
							else {
							//LX200_init_coords(In.Ra,In.Dec);
							LX200_Write_Ra(mot_pos[RA]);
							 LX200uartSendBytebuff('#'); //RA does not send #
							LX200_Write_Dec(mot_pos[DEC]);}
							break;
						default:
//							InsertLX200CmdIntoArray( LX200_Unknown_Cmd1);
							;
					}
					break;
#ifdef lxexten					
				case 'F':
					IncrIx++;
					switch( LX200Queue[Ix1])
					{
						case '+':
							IncrIx++;
//							InsertLX200CmdIntoArray( FocusOut);
//							LX200_Focus_Cmd = FocusOut;
//							ProcessLX200FocusByMethod();
							break;
						case '-':
							IncrIx++;
//							InsertLX200CmdIntoArray( FocusIn);
//							LX200_Focus_Cmd = FocusIn;
//							ProcessLX200FocusByMethod();
							break;
						case 'Q':
							IncrIx++;
//							InsertLX200CmdIntoArray( FocusQuit);
//							LX200_Focus_Cmd = FocusQuit;
							ProcessLX200FocusByMethod();
							break;
						case 'F':
							IncrIx++;
//							InsertLX200CmdIntoArray( FocusSetFast);
//							LX200_Focus_Speed_Cmd = FocusSetFast;
							break;
						case 'S':
							IncrIx++;
//							InsertLX200CmdIntoArray( FocusSetSlow);
//							LX200_Focus_Speed_Cmd = FocusSetSlow;
							;
							break;
						default:
								;
//							InsertLX200CmdIntoArray( LX200_Unknown_Cmd1);
					}
					break;
#endif					
				case 'G':
					IncrIx++;
					switch( LX200Queue[Ix1])
					{
						case 'A':
							IncrIx++;
//							InsertLX200CmdIntoArray( GetAlt);
							LX200_Write_Alt();
							break;
						case 'a':
							IncrIx++;
//							InsertLX200CmdIntoArray( GetLocalT12);
							LX200_Write_LocalT();
							break;
						case 'C':
							IncrIx++;
//							InsertLX200CmdIntoArray( GetDate);
							LX200_Write_Date();
							break;
						case 'c':
							IncrIx++;
//							InsertLX200CmdIntoArray( GetClockStatus);
							LX200_Write_Clock_Status();
							break;
						case 'D':
						    
							IncrIx++;
//							InsertLX200CmdIntoArray( GetDec);
							LX200_Write_Dec(mot_pos[DEC]);
							break;
						
						case 'd':                 //the last sent Sd parameter must be returned
							IncrIx++;
//							InsertLX200CmdIntoArray( GetDec);
							LX200_Write_Dec(In.Dec);
							break;
						/* command is either GF or GVF for get FIELD radius of the field operation */
						case 'F':
						case 'V':
							IncrIx++;
//							InsertLX200CmdIntoArray( GetField);
							LX200_Write_Field();
							break;
						case 'G':
							IncrIx++;
//							InsertLX200CmdIntoArray( GetTz);
							LX200_Write_Tz();
							break;
						case 'g':
							IncrIx++;
//							InsertLX200CmdIntoArray( GetLongitude);
							LX200_Write_Long();
							break;
						/* :GL# is get time in 24 hr format while :Ga# is get time in 12 hr format, but
						tests	with LX200 scopes show that both return 24 hr format */
						case 'L':
							IncrIx++;
//							InsertLX200CmdIntoArray( GetLocalT24);
							LX200_Write_LocalT();
							break;
						/* site name */
						case 'M':
						case 'N':
						case 'O':
						case 'P':
							IncrIx++;
//							InsertLX200CmdIntoArray( GetSiteName);
//							LX200_GetSiteName(); //todo
							break;
						case 'q':
							IncrIx++;
//							InsertLX200CmdIntoArray( GetMinQualityFind);
//							LX200_Write_MinQualityFind();  //todo??
							break;
						case 'R':
						    IncrIx++;
//							InsertLX200CmdIntoArray( GetRa);
							LX200_Write_Ra(mot_pos[RA]);
							   LX200uartSendBytebuff('#'); //az ra nem kld #-ot
							break;
						
						case 'r':                              //the last sent Sr parameter must be returned 
							IncrIx++;
//							InsertLX200CmdIntoArray( GetRa);
							LX200_Write_Ra(In.Ra);
							   LX200uartSendBytebuff('#'); //Ra does not send #
							break;
						case 'S':
							IncrIx++;
//							InsertLX200CmdIntoArray( GetSidT);
							LX200_Write_SidT();
							break;
						case 't':
							IncrIx++;
//							InsertLX200CmdIntoArray( GetLat);
							LX200_Write_Lat();
							break;
						case 'Z':
							IncrIx++;
//							InsertLX200CmdIntoArray( GetAz);
							LX200_Write_Az();
							break;
						default:
//							InsertLX200CmdIntoArray( LX200_Unknown_Cmd1);
							;
					}
					break;
#ifdef lxexten					
				case 'L':
					IncrIx++;
					switch( LX200Queue[Ix1])
					{
					/* library object information - might expect (from ACP):
					' Read the scope's current object info and display in
					' "friendly" format. The format of s.ObjectInformation() is:
					' 00000000011111111112222222223333
					' 12345678901234567890123456789012
					' --------------------------------
					'  NGC4594 VG GAL MAG 8.3 SZ  8.9'
					'  NGC0           Coordinates Only
					' STAR100     STARMAG 1.4
					'  JUPITER        MAG-2.7 SZ   46"
					'    M1    EX PNEBMAG 8.4 SZ  6.0'
					'    M20   EX OPNBMAG 6.3 SZ 29.0'
					'    M21   GD OPENMAG 5.9 SZ 13.0'
					'    M28   GD GLOBMAG 6.9 SZ 11.2'
					'    M78   VG DNEBMAG11.3 SZ  8.0'*/
						case 'I':
							IncrIx++;
//							InsertLX200CmdIntoArray( LI_command);
							LX200uartSendBytebuff( LX200ComPort, '#');
							
							break;
						/* sets the NGC object library:  0 is the NGC library, 1 is the IC library and 2
						is the UGC library; value ignored */
						case 'o':
//							InsertLX200CmdIntoArray( SetNGCLibrary);
							send_LX200_OK();
							LX200_Set_IncrIx( Ix, &IncrIx);
							break;
						/* sets the STAR object library type: 0 is the STAR library; 1 is the SAO library,
						and 2 is the GCVS library; value ignored */
						case 's':
//							InsertLX200CmdIntoArray( SetStarLibrary);
							send_LX200_OK();
							LX200_Set_IncrIx( Ix, &IncrIx);
							break;
						default:
//							InsertLX200CmdIntoArray( LX200_Unknown_Cmd1);
							;
					}
					break;
#endif					
				case 'M':
					IncrIx++;
					switch( LX200Queue[Ix1])
					{
						case 'A':
							IncrIx++;
//							
						    motor_goto_ALT_AZ(In.Alt,In.Az);
							
							break;
						case 'n':
							IncrIx++;
//							InsertLX200CmdIntoArray( MoveDirRateNorth);
//							LX200_Motor_Cmd = MoveDirRateNorth;
							LX200_motormove(UP);
							break;
						case 's':
							IncrIx++;
//							InsertLX200CmdIntoArray( MoveDirRateSouth);
//							LX200_Motor_Cmd = MoveDirRateSouth;
							;
							LX200_motormove(DOWN);
							break;
						case 'e':
							IncrIx++;
//							InsertLX200CmdIntoArray( MoveDirRateEast);
//							LX200_Motor_Cmd = MoveDirRateEast;
							//PutKeyBuf(RIGHT);
							LX200_motormove(LEFT);
							break;
						case 'w':
							IncrIx++;
//							InsertLX200CmdIntoArray( MoveDirRateWest);
//							LX200_Motor_Cmd = MoveDirRateWest;
							//PutKeyBuf(LEFT);
							LX200_motormove(RIGHT);
							break;
						case 'G':
						case 'S':
							IncrIx++;
//							InsertLX200CmdIntoArray( StartSlew);
						//	LX200uartSendBytebuff( LX200ComPort, '0');
//							LX200_Speed_Cmd = LX200_Motor_Cmd = StartSlew;
							
							//mot_offset[RA]=In.Ra;
							//mot_offset[DEC]=In.Dec;
						    //motor_goto_RA_DEC(In.Ra,In.Dec,POLECROSS_C,GOTO_MODE_AUTO);
							if (!IsParked){

								//LX200uartSendBytebuff('0');
								//LX200uartSendBytebuff('0');
								LX200_goto_ra_dec=1;
								//LX200uartSendBytebuff('1');
								//LX200uartSendBytebuff('#');
							}
							else LX200uartSendBytebuff('0');
							break;

						case 'g':							//pulse guide
							IncrIx++;
															//:MgwDDDD#
															//Guide telescope in the commanded direction (nsew) for the number of milliseconds indicated by the unsigned number
															//passed in the command. These commands support serial port driven guiding.
															//Returns  Nothing
															//IncrIx++;
							switch( LX200Queue[Ix2])
								{

									case 'e':
									case 'w':
									case 'n':
									case 's':
										IncrIx++;
										LX200_Read_PulseGuide(Ix2);
									//	send_LX200_OK();
										break;

								}
							break;
															//pulse guide end
						default:
//							InsertLX200CmdIntoArray( LX200_Unknown_Cmd1);
							;
					}
					break;
				case 'Q':
					IncrIx++;
					switch( LX200Queue[Ix1])
					{
						case '#':
//							InsertLX200CmdIntoArray( StopSlew);
//							LX200_Motor_Cmd = StopSlew;
//							AbortLX200_IRQ8Slew();
						/*	PutKeyBuf(ESC);		  //stops all
							PutKeyBuf(ESC+0x80);
							PutKeyBuf(ESC);		  //stops all
							PutKeyBuf(ESC+0x80);
							PutKeyBuf(ESC);		  //stops all
							PutKeyBuf(ESC+0x80);*/
//							mot_stop();
						    LX200_motormove(ESC+0x80);
							break;
						case 'n':
							IncrIx++;
//							InsertLX200CmdIntoArray( StopMotionNorth);
//							LX200_Motor_Cmd = StopMotionNorth;
//							AbortLX200_IRQ8Slew();
							LX200_motormove(UP+0x80);
							break;
						case 's':
							IncrIx++;
//							InsertLX200CmdIntoArray( StopMotionSouth);
//							LX200_Motor_Cmd = StopMotionSouth;
//							AbortLX200_IRQ8Slew();
							LX200_motormove(DOWN+0x80);
							break;
						case 'e':
							IncrIx++;
//							InsertLX200CmdIntoArray( StopMotionEast);
//							AbortLX200_IRQ8Slew();
//							LX200_Motor_Cmd = StopMotionEast;
							LX200_motormove(RIGHT+0x80);
							break;
						case 'w':
							IncrIx++;
//							InsertLX200CmdIntoArray( StopMotionWest);
//							LX200_Motor_Cmd = StopMotionWest;
//							AbortLX200_IRQ8Slew();
							LX200_motormove(LEFT+0x80);
							break;
						default:
//							InsertLX200CmdIntoArray( LX200_Unknown_Cmd1);
							;
					}
					break;
				case 'R':
					IncrIx++;
					switch( LX200Queue[Ix1])
					{
						case 'G':
							IncrIx++;
//							InsertLX200CmdIntoArray( SetMotionRateGuide);
//							LX200_Speed_Cmd = SetMotionRateGuide;
//							if( !GuideFlag)
//								InitGuide();
							userpar[RA].activespeed=GUIDE;	
							userpar[DEC].activespeed=GUIDE;
							break;
						case 'C':
							IncrIx++;
//							InsertLX200CmdIntoArray( SetMotionRateCenter);
//							LX200_Speed_Cmd = SetMotionRateCenter;
//							if( GuideFlag)
//								StopGuide();
							userpar[RA].activespeed=SLEW1;	
							userpar[DEC].activespeed=SLEW1;	
							break;
						case 'M':
							IncrIx++;
//							InsertLX200CmdIntoArray( SetMotionRateFind);
//							LX200_Speed_Cmd = SetMotionRateFind;
//							if( GuideFlag)
//								StopGuide();
							userpar[RA].activespeed=SLEW2;	
							userpar[DEC].activespeed=SLEW2;
							break;
						case 'S':
							IncrIx++;
//							InsertLX200CmdIntoArray( SetMotionRateSlew);
//							LX200_Speed_Cmd = SetMotionRateSlew;
//							if( GuideFlag)
//								StopGuide();
							userpar[RA].activespeed=SLEW3;	
							userpar[DEC].activespeed=SLEW3;	
							break;
						default:
//							InsertLX200CmdIntoArray( LX200_Unknown_Cmd1);
							;
					}
					break;
				case 'S':
					IncrIx++;
					switch( LX200Queue[Ix1])
					{
					
					 		//set ALT sDD.MM
					 	case 'a':
							 LX200_Read_Alt( Ix);
							 LX200_Set_IncrIx( Ix, &IncrIx);
							break;	
						/* sets the brighter magnitude limit for the FIND operation; example is Sb+08.2
						value ignored */
						case 'b':
//							InsertLX200CmdIntoArray( SetBrightMagLimitFindOperation);
							send_LX200_OK();
							LX200_Set_IncrIx( Ix, &IncrIx);
							break;
						case 'C':
//							InsertLX200CmdIntoArray( SetDate);
							LX200_Read_CurrentDate( Ix);
							LX200_Set_IncrIx( Ix, &IncrIx);
							break;
						case 'd':
//							InsertLX200CmdIntoArray( SetDec);
							LX200_Read_Dec( Ix);
							LX200_Set_IncrIx( Ix, &IncrIx);
							break;
						/* sets the field radius of the FIELD operation; example SF 010 value ignored */
						case 'F':
//							InsertLX200CmdIntoArray( SetField);
							send_LX200_OK();
							LX200_Set_IncrIx( Ix, &IncrIx);
							break;
						/* sets the fainter magnitude limit for the FIND operation; example is Sf-02.0
						value ignored */
						case 'f':
//							InsertLX200CmdIntoArray( SetFaintMagLimitFindOperation);
							send_LX200_OK();
							LX200_Set_IncrIx( Ix, &IncrIx);
							break;
						/* set GMT offset; ignored */
						case 'G':
//							InsertLX200CmdIntoArray( SetGMTOffset);
							send_LX200_OK();
							LX200_Set_IncrIx( Ix, &IncrIx);
							break;
						/* set longitude;*/
						case 'g':

							Lx200_Read_Long(Ix);
							saveparams='g';
							send_LX200_OK();
							LX200_Set_IncrIx( Ix, &IncrIx);						
							break;
						/* Sh DD# sets the current 'higher' limit; value ignored */
						case 'h':
//							InsertLX200CmdIntoArray( SetCurrentHigherLimit);
							send_LX200_OK();
							LX200_Set_IncrIx( Ix, &IncrIx);
							break;
						case 'L':
//							InsertLX200CmdIntoArray( SetLocalT);
//							printf("mus:%d:%d:%d-",ti.year,ti.mon,ti.date);
//							printf("mus:%d:%d:%d\n\r",ti.hour,ti.min,ti.sec);
							LX200_Read_LocalT( Ix);
							LX200_Set_IncrIx( Ix, &IncrIx);
							break;
						/* sets the larger size limit for the FIND operation */
						case 'l':
//							InsertLX200CmdIntoArray( LargeSizeLimitFindOperation);
							send_LX200_OK();
							LX200_Set_IncrIx( Ix, &IncrIx);
							break;
						/* set site number; ignored */
						case 'M':
						case 'N':
						case 'O':
						case 'P':
//							InsertLX200CmdIntoArray( SetSiteNumber_S);
							send_LX200_OK();
							LX200_Set_IncrIx( Ix, &IncrIx);
							break;
						/* steps to the next minimum quality for the FIND operation */
						case 'q':
							IncrIx++;
//							InsertLX200CmdIntoArray( NextMinQualityFind);
//							LX200MinQualityFind++;
//							if( LX200MinQualityFind > 6)
//								LX200MinQualityFind = 0;
							break;
						case 'r':
//							InsertLX200CmdIntoArray( SetRa);
							LX200_Read_Ra( Ix);
							LX200_Set_IncrIx( Ix, &IncrIx);
							break;
						case 'S':
//							InsertLX200CmdIntoArray( SetSidT);
							LX200_Read_SidT( Ix);
							LX200_Set_IncrIx( Ix, &IncrIx);
							break;
						/* sets the smaller size limit for the FIND operation */
						case 's':
//							InsertLX200CmdIntoArray( SmallSizeLimitFindOperation);
							send_LX200_OK();
							LX200_Set_IncrIx( Ix, &IncrIx);
							break;
						/* set latitude; */
						case 't':
//							
							Lx200_Read_Lat(Ix);
							saveparams='t';
							send_LX200_OK();
							LX200_Set_IncrIx( Ix, &IncrIx);
							break;
						/* max slew rate in deg/sec */
						case 'w':
							IncrIx++;
//							InsertLX200CmdIntoArray( Sw_command);
							send_LX200_OK();
							break;
						/* command is 'SyGPDCO' and gets the type' string for the FIND operation:
						capitalized means on, small letters means off: galaxy, planetary nebula, diffuse,
						globular cluster,	open cluster: ACP sends SyGPdco */
						case 'y':
							IncrIx++;
//							InsertLX200CmdIntoArray( SetTypeStringForFind);
							send_LX200_OK();
							break;
							//set AZ DDD.MM
						case 'z':						 
							 LX200_Read_Az( Ix);
							 LX200_Set_IncrIx( Ix, &IncrIx);
							 break;	
							
						default:
//							InsertLX200CmdIntoArray( LX200_Unknown_Cmd1);
							;
					}
					break;
					
				case 'U':
					IncrIx++;
						//	InsertLX200CmdIntoArray( ToggleLongFormat);
					misc.lx200format = !misc.lx200format;
				//	printf("formatum:%d,misc.lx200format)");
					saveparams='U';
					break;
					
#ifdef lxexten					
				case 'T':
					IncrIx++;
					switch( LX200Queue[Ix1])
					{
						case 'Q':
//							IncrIx++;
//							InsertLX200CmdIntoArray( TimeQuartz);
							break;
						default:
//							InsertLX200CmdIntoArray( LX200_Unknown_Cmd1);
							;
					}
					break;
					
					

					
				case 'W':
					IncrIx++;
					switch( LX200Queue[Ix1])
					{
						/* set current site number */
						case '1':
						case '2':
						case '3':
						case '4':
							IncrIx++;
//							InsertLX200CmdIntoArray( SetSiteNumber_W);
							break;
						default:
//							InsertLX200CmdIntoArray( LX200_Unknown_Cmd1);
							;
					}
					break;
					
					
				/* customized extensions to the LX200 protocol */
				case 'X':
					IncrIx++;
					switch( LX200Queue[Ix1])
					{
						case 'G':
							IncrIx++;
							switch( LX200Queue[Ix2])
							{
								case 'G':
									IncrIx++;
//									InsertLX200CmdIntoArray( SendGuideArcsecSec);
//									sprintf( StrBuf, "%04d#", GuideArcsecSec);
//									uartsendbuff(StrBuf);
									break;
								case 'M':
									IncrIx++;
//									InsertLX200CmdIntoArray( SendMsArcsecSec);
//									sprintf( StrBuf, "%04d#", MsArcsecSec);
//									uartsendbuff(StrBuf);
									break;
								default:
//									InsertLX200CmdIntoArray( LX200_Unknown_Cmd2);
									;
							}
							break;
						case 'H':
							IncrIx++;
							if( LX200Queue[Ix2] >= 'a' && LX200Queue[Ix2] < 'a'+ MaxHandpadFlag)
							{
								IncrIx++;
//								HandpadFlag = LX200Queue[Ix2] - 'a';
//								InsertLX200CmdIntoArray( SetHandpadMode);
//								WriteHandpadStatus();
							}
							else
								if( LX200Queue[Ix2] == 'L')
								{
									IncrIx++;
//									InsertLX200CmdIntoArray( HandpadLeftKey);
//									Buttons = LeftKey;
//									DisplayButtonsStatus();
//									ProcessHPEventsModeSwitch();
//									Buttons = HoldButtons;
//									LX200LeftButton = True;
								}
								else
									if( LX200Queue[Ix2] == 'R')
									{
										IncrIx++;
//										InsertLX200CmdIntoArray( HandpadRightKey);
//										Buttons = RightKey;
//										DisplayButtonsStatus();
//										ProcessHPEventsModeSwitch();
//										Buttons = HoldButtons;
//										LX200RightButton = True;
									}
									else
//										InsertLX200CmdIntoArray( LX200_Unknown_Cmd2);
							break;
						case 'I':
							IncrIx++;
							switch( LX200Queue[Ix2])
							{
								case '1':
									IncrIx++;
//									InsertLX200CmdIntoArray( SetInit1);
									/* use Current altaz and In equat coordinates to init with */
//									Current.Ra = In.Ra;
//									Current.Dec = In.Dec;
//									strcpy( WhyInit, WHY_INIT_LX200);
//									KBEventInitMatrix( 1);
									break;
								case '2':
									IncrIx++;
//									InsertLX200CmdIntoArray( SetInit2);
//									if( One.Init)
									if (1)

									{
										/* use Current altaz and In equat coordinates to init with */
//										Current.Ra = In.Ra;
//										Current.Dec = In.Dec;
//										strcpy( WhyInit, WHY_INIT_LX200);
//										KBEventInitMatrix( 2);
									}
									else
//										PressKeyToContMsg( "LX200 Init2 command received but no init 1");
									break;
								case '3':
									IncrIx++;
//									InsertLX200CmdIntoArray( SetInit3);
//									if( One.Init && Two.Init)
									if (1)
									{
										/* use Current altaz and In equat coordinates to init with */
//										Current.Ra = In.Ra;
//										Current.Dec = In.Dec;
//										strcpy( WhyInit, WHY_INIT_LX200);
//										KBEventInitMatrix( 3);
									}
									else
//										PressKeyToContMsg( "LX200 Init3 command received but no init 2");
									break;
								default:
//									InsertLX200CmdIntoArray( LX200_Unknown_Cmd2);
									;
							}
							break;
						case 'S':
							IncrIx++;
							switch( LX200Queue[Ix2])
							{
								case 'G':
//									InsertLX200CmdIntoArray( ReadGuideArcsecSec);
//									GuideArcsecSec = LX200_Read_Int_From_Queue( Ix+3);
									LX200_Set_IncrIx( Ix, &IncrIx);
//									WriteGuideArcsecSec();
									break;
								case 'M':
//									InsertLX200CmdIntoArray( ReadMsArcsecSec);
//									MsArcsecSec = LX200_Read_Int_From_Queue( Ix+3);
									LX200_Set_IncrIx( Ix, &IncrIx);
//									InitMsTickVars( MsArcsecSec);
//									WriteMsArcsecSec();
									break;
								default:
//									InsertLX200CmdIntoArray( LX200_Unknown_Cmd2);
									;
							}
							break;
						case 'X':
							IncrIx++;
//							InsertLX200CmdIntoArray( LX200_Clear_Display);
//							BlankOutLX200DisplayAreas();
							break;
						default:
//							InsertLX200CmdIntoArray( LX200_Unknown_Cmd1);
							;
					}
#endif					
					break;
				default:
//					InsertLX200CmdIntoArray( LX200_Unknown_Cmd0);
					;
			}
			
		}
		Ix += IncrIx;
		Ix %= LX200QueueSize;
	}
}


/*
void ProcessLX200_Motor_Cmd( void)
{
	struct AZLong HoldSteps;
	static LX200_COMMAND_TYPE LX200_Hold_Motor_Cmd;
	int timer = 0;

	if( LX200_Motor_Cmd == StartSlew)
	{
		if( LX200DisplayFlag)
			DisplayLX200CommandsAndCharBuffer();
		LX200_Motor_Cmd = NoAck;
		Response = MenuMoveEquat;
		GetNewMenuCatSubFromResponse();
//		UpdateMenuCatSub();
		// this function sets Current to In (it is assumed that just prior to issuing the StartSlew
		//command, Ra and Dec coordinates were read in from the LX200 port), and turns on tracking 
//		ProcessMenuSelection();
		// if no intervention, MoveToCurrentRaDec() eventually called from CheckMiscEvents() which
		//is eventually called from ProcessHPEvents() which is eventually called every bios clock tick
		//from main() 
	}
	else
		if( LX200_Speed_Cmd == SetMotionRateCenter || LX200_Speed_Cmd == SetMotionRateFind)
		{
			Steps.A = Steps.Z = 0;

			// can move in one direction only at a time 
			switch( LX200_Motor_Cmd)
			{
				case MoveDirRateNorth:
					Steps.A = MsTick.A;
					Dir.A = CW;
					break;
				case MoveDirRateSouth:
					Steps.A = MsTick.A;
					Dir.A = CCW;
					break;
				case MoveDirRateEast:
					Steps.Z = MsTick.Z;
					Dir.Z = CCW;
					break;
				case MoveDirRateWest:
					Steps.Z = MsTick.Z;
					Dir.Z = CW;
			}
			// keeps control until Ms mvmt ends; limited in time 
			HoldSteps = Steps;
			LX200_Hold_Motor_Cmd = LX200_Motor_Cmd;
			while( LX200_Hold_Motor_Cmd == LX200_Motor_Cmd
			&& timer++ < LX200MotionTimeoutSec * ClockTicksSec)
			{
				HPEventMoveMs();
				HPEventGetEquat();
				 ReadLX200Input() calls ProcessLX200Cmds(): resetting of LX200_Motor_Cmd done in
				ProcessLX200Cmds() 
				ReadLX200Input();
				SequentialTaskController();
				 add undone steps to steps to do for next clock tick 
				Steps.A += HoldSteps.A;
				Steps.Z += HoldSteps.Z;
			}
			AlignMs_f_ptr();
			SetCurrentAltazToAccumMs();
			HPEventGetEquat();
		}
		else
			if( LX200_Speed_Cmd == SetMotionRateGuide)
			{
				if( HandpadFlag == GuideStayRotateOn)
					switch( LX200_Motor_Cmd)
					{
						case MoveDirRateNorth:
							AccumGuide.A -= cos( GuideFRAngle) * GuideRadTick;
							AccumGuide.Z -= sin( GuideFRAngle) * GuideRadTick;
							break;
						case MoveDirRateSouth:
							AccumGuide.A += cos( GuideFRAngle) * GuideRadTick;
							AccumGuide.Z += sin( GuideFRAngle) * GuideRadTick;
							break;
						case MoveDirRateWest:
							AccumGuide.Z -= cos( GuideFRAngle) * GuideRadTick;
							AccumGuide.A += sin( GuideFRAngle) * GuideRadTick;
							break;
						case MoveDirRateEast:
							AccumGuide.Z += cos( GuideFRAngle) * GuideRadTick;
							AccumGuide.A -= sin( GuideFRAngle) * GuideRadTick;
					}
				else
					switch( LX200_Motor_Cmd)
					{
						 GuideFlag must be set to Yes for guiding corrections to work 
						case MoveDirRateNorth:
							AccumGuide.A -= GuideRadTick;
							break;
						case MoveDirRateSouth:
							AccumGuide.A += GuideRadTick;
							break;
						case MoveDirRateWest:
							AccumGuide.Z -= GuideRadTick;
							break;
						case MoveDirRateEast:
							AccumGuide.Z += GuideRadTick;
					}
				if( TrackByRateFlag)
					TrackByRate();
				else
					MoveToCurrentRaDec();
			}
			else
				if( LX200_Speed_Cmd == SetMotionRateSlew && LX200_OpenEndedSlewOn == False)
				{
					Steps.A = Steps.Z = 0;
					switch( LX200_Motor_Cmd)
					{
						case MoveDirRateNorth:
							Steps.A = LX200SlewHs;
							Dir.A = CW;
							break;
						case MoveDirRateSouth:
							Steps.A = LX200SlewHs;
							Dir.A = CCW;
							break;
						case MoveDirRateEast:
							Steps.Z = LX200SlewHs;
							Dir.Z = CCW;
							break;
						case MoveDirRateWest:
							Steps.Z = LX200SlewHs;
							Dir.Z = CW;
					}
					if( Steps.A > 0 || Steps.Z > 0)
					{
						LX200_OpenEndedSlewOn = True;
						KBEventMoveHs();
						PauseUntilNewSidTime();
						HPEventGetEquat();
						LX200_OpenEndedSlewOn = False;
					}
					else
						if( TrackByRateFlag)
							TrackByRate();
						else
							MoveToCurrentRaDec();
					LX200_Motor_Cmd = NoAck;
				}

}

void ProcessLX200FocusByMethod( void)
{
	InitiatedType = LX200Initiated;

	if( LX200_Focus_Cmd == FocusIn)
		FocusControl = FocusMinus;
	else
		if( LX200_Focus_Cmd == FocusOut)
			FocusControl = FocusPlus;
		else
			FocusControl = FocusStop;

	if( FocusMethod == FocusMethod_OnOff_16_17)
		ProcessLX200Focus_OnOff_16_17();
	else
		if( FocusMethod == FocusMethod_OnOff_16_17_Slow1_14)
			ProcessLX200Focus_OnOff_16_17_Slow1_14();
		else
			if( FocusMethod == FocusMethod_Pulse_1_14 || FocusMethod == FocusMethod_Pulse_16_17)
				 if tracking on, control of focus motor handled by MoveMs() 
				if( TrackFlag)
					;
				else
					if( !InsideProcessHPEventsFocusMethod_Pulse_Dir)
						ProcessHPEventsFocusMethod_Pulse_Dir();

}

void ProcessLX200Focus_OnOff_16_17( void)
{
//	FocusControl_OnOff_16_17();
}

void ProcessLX200Focus_OnOff_16_17_Slow1_14( void)
{
	if( LX200_Focus_Speed_Cmd == FocusSetFast)
		ProcessLX200Focus_OnOff_16_17();
	else
		FocusControl_OnOff_16_17_Slow1_14();

}

*/
