#include <stdio.h>
#include <pwmc/pwmc.h>
#include <dbgu/dbgu.h>
#include <tc/tc.h>
#include "math1.h"
#include <float.h>
#include <board.h>
#include <pio/pio.h>
#include <pio/pio_it.h>
#include <adc/adc.h>
#include <pmc/pmc.h>
#include <aic/aic.h>
#include <string.h>


#include "stepper.h"
#include "puls.h"
#include "data_base.h"
#include "misc_calc.h"
#include "timers.h"

#define NEW_ENCODER_PINOUT 1         // the same UTP socket hosts incremental encoder input and index signal
#define ENC_CNT_DIV 1                //encoder pulse divider for tests
#define CORR_ENC_CNT 10              //  x100ms= RA encoder control loop cycle
#define NOSYNCTEST
//encode eloszts idmrshez
//#define ENCODER_TEST_DIV 30        //encoder pulse divider for tests !!!!
//#define MOT_OFF_DEBUG              //ha motor kikapcsolt l. ban is akarunk debugot, Vigyzat visszakapcsolja a motort!!
#define PID_SYNC                     // syn_mot PID control loop

//LED nem ghet SPI alatt mert kikapcsolja az SD krtyt!!!!!  todo
#define RAMFUNC __attribute__ ((long_call, section (".ramfunc")))

#define NOSTEP


#define NODECPEC 1

void beep(void);		//Lcd.h

extern struct  motor_par mot[2] ;
extern struct  user_par userpar[2];

extern unsigned char lx200_busy;

extern struct adc adc_buffer[ADC_ARRAY_SIZE];
extern struct  misc_par misc;
char first_stop[2]={0,0};

extern float scope_ALT;
extern float scope_AZ;
float last_AZ;
static signed char corr_AZ_pos=0;


static float sin_t[POS_MAX+5];
static float cos_t[POS_MAX+5];
unsigned int encoder_prop = 128;

static signed short sintab_u_RA[POS_MAX+5];   //+5 volt everywhere
static signed short costab_u_RA[POS_MAX+5];
static signed short sintab_u_DEC[POS_MAX+5];
static signed short costab_u_DEC[POS_MAX+5];

static signed short sintab_i_RA[POS_MAX+5];
static signed short costab_i_RA[POS_MAX+5];
static signed short sintab_i_DEC[POS_MAX+5];
static signed short costab_i_DEC[POS_MAX+5];

static unsigned char dir_cos[POS_MAX+4];
static unsigned char dir_sin[POS_MAX+4];


volatile unsigned char no_sync[2]={1,1};
unsigned char no_synctest=0;
unsigned int estiteszt=0;

//signed long encoder[]={0,0,0,0};;
/*static signed long encoder[2][2]={
									{ 0,0 },
									{ 0,0 }
									};

*/
unsigned int track_presc[2]={1,1};
unsigned int track_presc_h[2]={1,1};
//static unsigned int adin[] = {0,0,0,0,0,0,0,0,1};	
unsigned long mul1[2]={1,1};
unsigned long mul2=1;
unsigned int  ustep_per_step=POS_MAX/2;
int oszt=POS_MAX;  //todo POS_MAX -OSZT ustep_per_step ???

float last_s_error=0;
float corr_ra_encoder=0;
char first_enc_it=0;

static char drive_mode[2]={IMODE,IMODE};			//stepper motor drive mode, current or voltage
static char drive_mode_count[2]={0,0};
static unsigned int presc_tab[] = {2, 8, 32, 128,1024};

volatile static char sid_chng=0;     //todo kell egy fv
//static unsigned int mot_timer_base[2];
int accel[2]={ACCEL,ACCEL};
unsigned int mot_speed[]={10,10};
unsigned int mot_speeed[]={10,10};
unsigned int mot_speed_a[2]={10,10};
static unsigned int mot_speed_b[2]={10,10};
//static signed short mot_servo_speed[2]={0,0};


static unsigned char mot_dir_ch[2]={0,0};
unsigned char mot_dir[4]={0,0,0,0};
unsigned char mot_dir_a[2]={0,0};


volatile float mot_backlash[2]={0,0};								//backlash compensation
char   last_backlash_dir[2]={0,0};						//last saved direction of rotation

char stop_c_count[2]={STOPCURR_WAIT*2,STOPCURR_WAIT*2};

 int step[4]={0,0,0,0};
 int step_corr[4]={0,0,0,0};
 signed long stepcount[4]={0,0,0,0};
//static int step_stop[2]={0,0};
//static long stepcount_stop[2]={0,0};


float off_pec[2]={0,0};								// ???
float mot_offset_pec[2]={0,0};					   		//PEC offset (an experimentally defined value) 	  		  		  		  
float mot_last_offset_pec[2]={0,0};						
float rate_offset[2]={0,0};									//special tracking rates
volatile float mot_offset[2]={0,0};								//motor offset in radians
float mot_offset1[2]={0,0};								// offset=offset_pec+offset_refr+offset1
float mot_offset_refr[2]={0,0};	  						//offset from refraction

float mot_ustep_rad[4]={1,1,1,1};						//1 ustep in radians

//static char 		mot_jump[]={1,1};
char 		mot_stat[2]={M_GOTO,M_GOTO};
static char mot_st[4]={1,1,1,1};			//motor microstep increment (less microstep with increasing speed)

static unsigned int mot_period[2]={MAX_DUTY_CYCLE/2,MAX_DUTY_CYCLE/2};
//static signed char  mot_i[2]={0,0}; 

unsigned char reset_ra_enc_corr=1;

static unsigned int mot_track_timer[2]={1000,1000};
static unsigned int mot_track_timer_h[2]={1000,1000};

static int track_timer[2]={1000,1000};
static int track_timer_base[2]={1000,1000};

float mot_pos[2]={0,0};									//Ra Dec position on display
volatile float mot_rot[2]={0,0};									// motor pos. default
signed long mot_encoder_w[2]={0,0};						//the valuse supposed to be on the encoder
signed long mot_encoder_w_last[2]={0,0};
//static float mot_rot_last[2]={0,0};
static float mot_err[2]={0,0};									//the actual error signal for the control loop
static int moterr[2]={0,0};										//mire kelll???? todo
static int moterr1[2]={0,0};
static int mot_err_i[2]={0,0};
static int mot_err_p[2]={0,0};
static int mot_err_d[2]={0,0};
static int mot_err_in[2]={0,0};
//static  char mot_preci[2]={1,1};
static  char motw_ok=0;
char motors_enabled=0;							//motors on or off

static float last_mot_rot[]={0,0};
static signed int stepper_integ[2]={0,0};
static char ecoder_0_mark[]={0,0,0,0};


extern unsigned char mot_arrive[2];
extern unsigned char mot_arrive_speed[2];

static int U_in=120;
int i_RA1=0;//100;
int i_RA2=0;//100;
int i_DEC1=0;//100;
int i_DEC2=0;//100;

static unsigned int peek_curr[]={0,0};

int ampl[2]={AMPL,AMPL};
char ALTAZ_can_start=0;


volatile unsigned  int i_RA=0;
volatile unsigned  int i_DEC=0;

volatile char initialized=0;


volatile unsigned int enc_dir=0;
static char step_disable[2]={0,0};

//unsigned int mot_curr_a[0x101];
//unsigned int mot_curr_b[0x101];
//unsigned int mot_curr_c[0x101];
//unsigned int mot_curr_d[0x101];


#define PIN_DBGU_TXD     {1 << 28, AT91C_BASE_PIOA, AT91C_ID_PIOA, PIO_PERIPH_A, PIO_DEFAULT}
//#define PIN_MOTOR_ENABLE {1 << 28, AT91C_BASE_PIOA, AT91C_ID_PIOA, PIO_OUTPUT_0, 1}
#define PIN_MOTOR_ENABLE {1 << 28, AT91C_BASE_PIOA, AT91C_ID_PIOA, PIO_INPUT, PIO_DEFAULT}    //makes sure it cannot be switched on

#define PIN_PX_IT_A12    {1 << 23, AT91C_BASE_PIOB, AT91C_ID_PIOB, PIO_INPUT, PIO_DEFAULT}
#define PIN_PX_IT_A34    {1 << 25, AT91C_BASE_PIOB, AT91C_ID_PIOB, PIO_INPUT, PIO_DEFAULT}
#define PIN_PX_IT_B12    {1 << 24 ,AT91C_BASE_PIOB, AT91C_ID_PIOB, PIO_INPUT, PIO_DEFAULT}
#define PIN_PX_IT_B34    {1 << 26 ,AT91C_BASE_PIOB, AT91C_ID_PIOB, PIO_INPUT, PIO_DEFAULT}




#define PIN_PX_UD_A12    {1 << 7 , AT91C_BASE_PIOA, AT91C_ID_PIOA, PIO_INPUT, PIO_DEFAULT}
#define PIN_PX_UD_A34    {1 << 9 , AT91C_BASE_PIOA, AT91C_ID_PIOA, PIO_INPUT, PIO_DEFAULT}
#define PIN_PX_UD_B12    {1 << 8 , AT91C_BASE_PIOA, AT91C_ID_PIOA, PIO_INPUT, PIO_DEFAULT}
#define PIN_PX_UD_B34    {1 << 14, AT91C_BASE_PIOA, AT91C_ID_PIOA, PIO_PERIPH_B, PIO_DEFAULT}  //FIQ - IRQ1




#define PIN_MODE_ADIR    {1 << 23, AT91C_BASE_PIOA, AT91C_ID_PIOA, PIO_OUTPUT_0, PIO_DEFAULT}
#define PIN_MODE_BDIR    {1 << 25, AT91C_BASE_PIOA, AT91C_ID_PIOA, PIO_OUTPUT_0, PIO_DEFAULT}
#define PIN_MODE_AB_IM   {1 << 24, AT91C_BASE_PIOA, AT91C_ID_PIOA, PIO_OUTPUT_0, 1}

#define PIN_MODE_CDIR    {1 << 26, AT91C_BASE_PIOA, AT91C_ID_PIOA, PIO_OUTPUT_0, PIO_DEFAULT}
#define PIN_MODE_DDIR    {1 << 29, AT91C_BASE_PIOA, AT91C_ID_PIOA, PIO_OUTPUT_0, PIO_DEFAULT}
#define PIN_MODE_CD_IM   {1 << 30, AT91C_BASE_PIOA, AT91C_ID_PIOA, PIO_OUTPUT_0, 1}


#define PIN_PWM_CLK     {1 << 29, AT91C_BASE_PIOB, AT91C_ID_PIOB, PIO_PERIPH_A, PIO_DEFAULT}  //PCK1 clock out


#define PIN_WP_SD     	{1 << 28, AT91C_BASE_PIOB, AT91C_ID_PIOB, PIO_OUTPUT_0, 1}   //ezen van a LED is
//#define PIN_CP_SD     	{1 << 19, AT91C_BASE_PIOA, AT91C_ID_PIOB, PIO_OUTPUT_0, PIO_DEFAULT}   //to SD card
#define PIN_CP_SD     	{1 << 19, AT91C_BASE_PIOA, AT91C_ID_PIOA, PIO_INPUT, PIO_DEFAULT}   //to SD card
//#define PIN_IRQ1        PIN_PX_UD_B34 	//{1 << 14, AT91C_BASE_PIOA, AT91C_ID_PIOB, PIO_PERIPH_B, PIO_DEFAULT}   //??



#define     U_MES   (AT91C_BASE_ADC->ADC_CDR3)
#define 	I_DEC_A	(AT91C_BASE_ADC->ADC_CDR4)
#define		I_DEC_B	(AT91C_BASE_ADC->ADC_CDR5)
#define 	I_RA_A 	(AT91C_BASE_ADC->ADC_CDR6)
#define		I_RA_B 	(AT91C_BASE_ADC->ADC_CDR7)


static const Pin DBGU_txd     = PIN_DBGU_TXD;
static const Pin Motor_enable = PIN_MOTOR_ENABLE;

static const Pin Mode_ADIR = PIN_MODE_ADIR;
static const Pin Mode_BDIR = PIN_MODE_BDIR;
static const Pin Mode_AB_IM = PIN_MODE_AB_IM;

static const Pin Mode_CDIR = PIN_MODE_CDIR;
static const Pin Mode_DDIR = PIN_MODE_DDIR;
static const Pin Mode_CD_IM = PIN_MODE_CD_IM;


static const Pin Px_It_A12 = PIN_PX_IT_A12;
static const Pin Px_It_A34 = PIN_PX_IT_A34;
static const Pin Px_It_B12 = PIN_PX_IT_B12;
static const Pin Px_It_B34 = PIN_PX_IT_B34;

static const Pin Px_Ud_A12 = PIN_PX_UD_A12;
static const Pin Px_Ud_A34 = PIN_PX_UD_A34;
static const Pin Px_Ud_B12 = PIN_PX_UD_B12;
static const Pin Px_Ud_B34 = PIN_PX_UD_B34;




static const Pin Cp_Sd =  PIN_CP_SD;
static const Pin Wp_Sd =  PIN_WP_SD;
//static const Pin Irq1  =  PIN_IRQ1;


static const Pin Pwm_Clk = PIN_PWM_CLK;

/// Pio pins to configure.
static const Pin pins[] = {
	
    PIN_PWMC_PWM0,
    PIN_PWMC_PWM1,
    PIN_PWMC_PWM2,
    PIN_PWMC_PWM3,
    PIN_MODE_ADIR,
    PIN_MODE_BDIR,
    PIN_MODE_AB_IM,
    PIN_MODE_CDIR,
    PIN_MODE_DDIR,
    PIN_MODE_CD_IM,
    
    
    PIN_PX_IT_A12,
    PIN_PX_IT_A34,
    PIN_PX_IT_B12,
    PIN_PX_IT_B34,
    PIN_PX_UD_A12,
    PIN_PX_UD_A34,
    PIN_PX_UD_B12,
    PIN_PX_UD_B34,
    
    
    
    
    
    
    PIN_PWM_CLK,
    
    PIN_CP_SD,
    PIN_WP_SD
    
    
};

unsigned int ra_mes_tick=0;
int servo_prop_const=399;
unsigned char lassul[]={0,0};

unsigned short servo_diff_const=30;
unsigned short servo_integ_const=40;
signed  short spee=0;

#ifdef PID_SYNC

signed short stepper_diff_const=300;    //2010.10.31 ig 20
signed short stepper_integ_const=100;    //4
signed short stepper_prop_const=130;   //  60
#else
signed short stepper_diff_const=20;    //2010.10.31 ig 20
signed short stepper_integ_const=4;    //4
signed short stepper_prop_const=60;   //  60

#endif


int ALTAZ_prop_const  =12;
int ALTAZ_diff_const  =10;
int ALTAZ_integ_const =10;


unsigned char set_sin_timer_e(unsigned char m,unsigned int sp,unsigned char dir);
void RA_timer_init_t(unsigned char presc,unsigned int timer,unsigned char jump);

unsigned char current_set(unsigned char mot, short curr);
void stepper_parinit (void);
void enable_encoder_IT(char en);




//**********************************************************************
// Parameter setting auxiliary functions, only for development 
//**********************************************************************

void incdec_speed(signed char dir){
if (!dir){spee=0;return;}	
if (dir<0)spee--;
else spee++;
	
}


void ra_enc_corr_res(void){
 reset_ra_enc_corr=1;
}

//**********************************************************************
//
//**********************************************************************

void incdec_prop(signed char dir){
/*	
if (dir<0){if (servo_prop_const)servo_prop_const--;}
else servo_prop_const++;

*/
if (dir<0){if (stepper_prop_const)stepper_prop_const--;}
else stepper_prop_const++;


printf("prop=%d",stepper_prop_const);

/*
	if (dir<0){if (ALTAZ_prop_const)ALTAZ_prop_const--;}
	else ALTAZ_prop_const++;
//	printf("prop=%d",ALTAZ_prop_const);
	
*/
	
//	mot_st[AZ]=ALTAZ_prop_const;
//	settimer_AZ(ALTAZ_diff_const);
//	mot_dir[AZ]=1;
//	set_sin_timer_e(RA,ALTAZ_diff_const,dir);
//	RA_timer_init(2,1000+ALTAZ_diff_const*10,2);
}


//**********************************************************************
//
//**********************************************************************

void incdec_diff(signed char dir){
/*	
if (dir<0){if (servo_diff_const)servo_diff_const--;}
else servo_diff_const++;
*/
if (dir<0){if (stepper_diff_const)stepper_diff_const--;}
else stepper_diff_const++;
printf("diff=%d",stepper_diff_const);
	
/*
	if (dir<0){if (ALTAZ_diff_const)ALTAZ_diff_const--;}
	else ALTAZ_diff_const++;
*/
//	printf("diff=%d",ALTAZ_diff_const);	
	
	
//	mot_st[AZ]=ALTAZ_prop_const;
//	settimer_AZ(ALTAZ_diff_const);
//	mot_dir[AZ]=1;
//	set_sin_timer_e(RA,ALTAZ_diff_const,dir);
//	RA_timer_init(8,1000+ALTAZ_diff_const*10,2);
	
}

//**********************************************************************
//
//**********************************************************************

void incdec_integ(signed char dir){
/*	
if (dir<0){if (servo_integ_const)servo_integ_const--;}
else servo_integ_const++;
*/
if (dir<0){if (stepper_integ_const)stepper_integ_const--;}
else stepper_integ_const++;
printf("integ=%d",stepper_integ_const);
/*
	
	if (dir<0){if (ALTAZ_integ_const)ALTAZ_integ_const--;}
	else ALTAZ_integ_const++;
//	printf("integ=%d",ALTAZ_integ_const);	
*/
}




//**********************************************************************
// This will increase speed
//**********************************************************************

void inc_speed(unsigned char mot){
	
	
mot_speed_a[mot]+=10;	
	
	
}

void dec_speed(unsigned char mot){
	
	
mot_speed_a[mot]-=10;	
	
	
}



void set_drive_mode (unsigned char mot,char mode){
	
drive_mode[mot]=mode;

	
	
}

void set_sync_mode(unsigned char mot,char mode){
	
	
no_sync[mot]=mode;	
	
}



//---------------------------------------------------------------------
// Returns motor position in steps
// input: motor
//        motor radian
//		  &motor step
//        &motor microstep
//---------------------------------------------------------------------

char rad_to_step(unsigned char m,float posr, signed long *step, int *mstep)

{
	float h;
	float hh;
    signed long tt;
//	if (posr<0)posr = M2_PI-posr;
	
	//h=(unsigned long)mot[m].reduction*mot[m].motres*ustep_per_step;
	h=(float)mot[m].reduction*mot[m].motres*ustep_per_step;
	if (h)h=2*M_PI/h;	 							//1 microstep in radians	
	
	hh=posr/(h*4);
	
	*step=(signed long)(hh/ustep_per_step);
	if (posr<0){  //printf("-minus-");
//	printf("x:%d",(int)(*step*ustep_per_step));
	tt=	(signed long)(hh-((float)*step*ustep_per_step));
	*mstep=0x100+tt;   //todo
	*step=*step-1;
	}
	else *mstep=hh-*step*ustep_per_step;
	
//	printf("st:%d,stc:%d",*mstep,*step);
	
	
	
return 0;	
}



char init_ALT_AZ_mot(void){
	calc_altaz();
	rad_to_step(DEC,scope_ALT,&stepcount[ALT],&step[ALT]);
	
	rad_to_step(RA,scope_AZ,&stepcount[AZ],&step[AZ]);
	
//	printf("altst:%d,atc:%d",stepcount[ALT],stepcount[AZ]);
	ALTAZ_can_start=1;
	last_AZ=scope_AZ;
	corr_AZ_pos=0;
return 0;	
}

void disable_stepper(void){
	ALTAZ_can_start=0;
	initialized=0;
	
}

//---------------------------------------------------------------------
// Returns motor position in radians
// input: motor
//        motor step
//        motor microstep
//		  	
//---------------------------------------------------------------------

float step_to_rad(unsigned char m,signed long step,unsigned int mstep )

{
float h;
float hh;
//unsigned char i;
/*
//h=(unsigned long)mot[m].reduction*mot[m].motres*ustep_per_step;
h=(float)mot[m].reduction*mot[m].motres*ustep_per_step;
//if (h)h=2*M_PI/h;
if (h)h=M2_PI/h;//egy mstep radinban
*/
h=mot_ustep_rad[m];

hh=step;
hh=((hh*ustep_per_step)+mstep+step_corr[m]);	        //todo: is it possible to accelerate this???
//h=h*hh*0x200/POS_MAX;
h=h*hh*4;
//h=h+mstep;

//h=h+(float)step_corr[m]*(mot_ustep_rad[m]*4);      //slip correction factor in case of a friction drive

return(h);
}

//-------------------------------------------------------------------------------
// calculates telescope position on given axis, based on the incremental encoder
// input: motor
//        motor encoder
//        motor encoder position
//-------------------------------------------------------------------------------

float encoder_to_rad(unsigned char m,unsigned char enc,signed long enc_pos){
	
	
float h;




h=(float)mot[m].reduction*(float)mot[m].encoderres[enc] ;
if (h)h=2*M_PI/h;	 										//1 encoder increment in radians

h=h*(float)enc_pos;

return h;
	
}


//---------------------------------------------------------------------
//
// Calculates steps of teh given encoder
// input: motor
//        motor encoder
//        motor encoder position
//---------------------------------------------------------------------

signed long rad_to_encoder(unsigned char m,unsigned char enc,float mot_pos){
	
	
float h;
signed long enc_pos;

h=(float)mot[m].reduction*(float)mot[m].encoderres[enc] ;
if (h)h=2*M_PI/h;	 									//1 encoder increment in radians

enc_pos=mot_pos/h;

return enc_pos;
	
}


//--------------------------------------------------------------------------
//
// Calculates mot_pos based on the incremental encoder
//
//--------------------------------------------------------------------------

float get_mot_pos_enc(unsigned char motor){

	signed long encoder[2][2]={
									{ 0,0 },
									{ 0,0 }
									};

	float ff;
	float temp;
	float r_motor=0;
	float rate_t=0;
	float h;

	get_encoders(&encoder[MOUNT_ENC][RA],&encoder[MOUNT_ENC][DEC],&encoder[MOTOR_ENC][RA],&encoder[MOTOR_ENC][DEC]);
/*
	printf("\n\r");
	printf_float (mot_pos[motor]);
	printf("\n\r");
*/
	h=(float)mot[motor].encoderres[MOUNT_ENC] ;
	if (h==0) return -1;                                //encoder resolution is not set
	r_motor=-(M2_PI*(float)encoder[MOUNT_ENC][motor])/h;


	temp=+mot_offset1[motor]+(mot_offset_refr[motor]+mot_backlash[motor]);			  //+mot_offset_pec[mot]);
	rate_t=get_mot_rate(motor);

	off_pec[motor]=(rate_t-r_motor)-temp;

	if (motor && NODECPEC)
	;
	else
	{
	  if (userpar[motor].PEC_corr!=0)
	    temp=temp+mot_offset_pec[motor]; 											//when PEC is active
		else temp=temp+mot_last_offset_pec[motor];

	}

    ff=rate_t-r_motor-temp;
/*
    printf_float (mot_pos[motor]);
    printf("-\n\r");
	printf_float (ff);
	printf("\n\r");
*/

    return ff;

}





unsigned long get_step (unsigned char m){

	unsigned long st;

	st=stepcount[m];

	return st;
}


unsigned long get_enc (unsigned char m){

	unsigned long st;

	signed long encoder[2][2]={
								{ 0,0 },
								{ 0,0 }
								};

	get_encoders(&encoder[MOUNT_ENC][RA],&encoder[MOUNT_ENC][DEC],&encoder[MOTOR_ENC][RA],&encoder[MOTOR_ENC][DEC]);
	st=encoder[MOUNT_ENC][m] ;


	return st;
}


//----------------------------------------------------------------------------------------------------------------
// A motor step-et korriglja drzshajts esetn ,
//     az encoderek felhasznlsval
//
// Ehhez inicializlskor meg kell llaptani a motorok s az encoderek relatv helyzett
// lehetsgek :
// hiba < encoder felbonts 				- nem kell semmit se csinlni
//        encoder fb. < hiba < max. hiba 	- korriglni kell a motort az enkoderhez, mert az enkoder a biztos.
//		  hiba > max. hiba					- lell a motor, s korriglni kell a motort
// mode : SYNC_MODE_GOTO   -goto utn odamegy a motor a j helyre
//        SYNC_MODE_SLOW   -kzi vezrlsnl az encoder alapjn aktualizlj a pozicit, de nem mozog sehova
// max_error:SYNC_MODE_GOTO esetn max ekkora hibt korrigl
//-----------------------------------------------------------------------------------------------------------------

char corr_motor_slip(unsigned char motor, unsigned char mode, float max_error ){
	
static signed long last_enc[2];

 signed long encoder[2][2]={
							{ 0,0 },
							{ 0,0 }							
							};

float enc_rad=0;
float mot_rad=0;

float h,hh;
char sign;
signed long stc;
unsigned int st;
//unsigned int eg,tiz;
//printf("\n\rhiba:");
//printf_float(max_error);

if (max_error>ENC_ERR_MAX)max_error=ENC_ERR_MAX;
if (ENC_ERR_MIN>max_error)max_error=ENC_ERR_MIN;

	
get_encoders(&encoder[MOUNT_ENC][RA],&encoder[MOUNT_ENC][DEC],&encoder[MOTOR_ENC][RA],&encoder[MOTOR_ENC][DEC]);


h=(float)mot[motor].encoderres[MOUNT_ENC] ;
if (h==0) return -1;                                //encoder felbonts nincs belltva
/*
h=2*M_PI/h;	 										//ez okozta szmolsi hibt??? 2011.04.18
hh=h;
enc_rad=-h*(float)encoder[MOUNT_ENC][motor];
*/



if (encoder[MOUNT_ENC][motor]>last_enc[motor]){					// taln ez javt a hibn, hogy ksik kt encoder oszts kztt lehetnk
 last_enc[motor]=encoder[MOUNT_ENC][motor];
 encoder[MOUNT_ENC][motor]++;
}
else if (encoder[MOUNT_ENC][motor]<last_enc[motor]){
 last_enc[motor]=encoder[MOUNT_ENC][motor];
 encoder[MOUNT_ENC][motor]--;
}
else last_enc[motor]=encoder[MOUNT_ENC][motor];



hh=2*M_PI/h;                                        //egy encoder lps radinban
enc_rad=-(M2_PI*(float)encoder[MOUNT_ENC][motor])/h;

//if (enc_rad>0)enc_rad+=0.00007;
//else if (enc_rad>0)enc_rad-=0.00007;

//if (mot[motor].encoder_dir[MOUNT_ENC]==LEFT)h=-h;   ez nem kell????

st=step[motor] ;                                      //lehet, hogy a motor most nvel !!!!!
while (st!=step[motor])
  st=step[motor];

stc=stepcount[motor];
while (stc!=stepcount[motor])
  stc=stepcount[motor];

h=step_to_rad(motor,stc,st);        	//mekkora az eltrs?
mot_rad=h;
if (h>enc_rad){h=h-enc_rad;sign='-';}else {h=enc_rad-h;sign='+';}

//if (h<ENC_ERR_MIN)return(0);
if ((h<hh*4) &&  (mode==SYNC_MODE_SLOW))return(0);        								//az encoder felbonts 4 * szerese
if (h<hh*2)return(0); 																	//gotonl lehet ponosabb is taln
if ((h<max_error)|| (mode==SYNC_MODE_SLOW)){
  //printf ("\n\renc_corr:%c",sign);
  //printf_float(h);
/*
	printf("\n\r** m=%d h=",motor);
	printf_float(h);

	printf("\n\renc:");
	printf_float(enc_rad);
	printf("\n\renc c:%d",(int)encoder[MOUNT_ENC][motor]);

	printf("\n\rmot:");
	printf_float(mot_rad);
	printf("\n\rmot s:%d,%d",(int)stepcount[motor],(int)step[motor]);

	printf("\n\renc step:");
	printf_float(hh);
	printf("\n\r");

*/

 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 //ha tl nagy az eltrs nem csinlja a korrekcit


	rad_to_step(motor,enc_rad,&stc,&st);

    no_sync[motor]=1;
	step_disable[motor]=1;										//a motor pozcit korriglja
	stepcount[motor]=stc;
//	step[motor]=st;   											//a ustepet elvesztjk, de a step_corr megoldja
	step_corr[motor]=(st-step[motor]);                         // a korrekcis vltoz rtke ne vesszen el!!

	if (step_corr[motor]>POS_MAX){
		step_corr[motor]-=POS_MAX;
		stepcount[motor]++;
	}
	if (step_corr[motor]<0){
			step_corr[motor]+=POS_MAX;
			stepcount[motor]--;
		}

	step_disable[motor]=0;
	hh=(mot_offset[motor]-((mot_pos[motor]-rate_offset[motor])));//1.5;
	no_sync[motor]=0;

//    printf("stc:%d,st:%d,c:%d,s:%d\n\r",stc,st,step_corr[motor],step[DEC]);
	if (mode == SYNC_MODE_SLOW){                               // a kijelzst is igaztjuk,gy nem megy sehova
		sync_mot(motor);
		mot_offset[motor]=mot_pos[motor]-rate_offset[motor]+hh;   //mot stop valjban
//		mot_offset[motor]=mot_pos[motor]-hh;   //mot stop valjba
//		if (sign=='-')mot_offset[motor]+=0.0000025;
//		else mot_offset[motor]-=0.0000025;
		sync_mot(motor);
//		printf("slow_corr");
		printf("Slow corr");
	}else printf("Goto corr");




	return ENC_GOTO_CORR_OK;
   }
   else {
//    beep();
//	rad_to_step(motor,enc_rad,&stepcount[motor],&step[motor]);
	return ENC_GOTO_CORR_ERROR;
   }

	
return 0;	
}


char sync_encoder_servo(unsigned char enc_type,unsigned char motor){


signed long l;

 signed long encoder[2][2]={
							{ 0,0 },
							{ 0,0 }
							};
 	if (mot[motor].encoder[enc_type] == 0) return -2;    //nincs is ez az encoder
    get_encoders(&encoder[MOUNT_ENC][RA],&encoder[MOUNT_ENC][DEC],&encoder[MOTOR_ENC][RA],&encoder[MOTOR_ENC][DEC]);


	if (mot[motor].encoderres[enc_type] == 0)return -1 ;


	calc_encoder_wanted();
	if (enc_type == MOUNT_ENC){							//enkoder az llvnyon van, drzshajts
//		if (motor==RA)set_encoders(l,encoder[MOUNT_ENC][DEC],encoder[MOTOR_ENC][RA],encoder[MOTOR_ENC][DEC]);
//		else set_encoders(encoder[MOUNT_ENC][RA],l,encoder[MOTOR_ENC][RA],encoder[MOTOR_ENC][DEC]);
    }
    else
    {
    	l=mot_encoder_w[motor];
//    	printf("e:%d,c:%d\r\n",encoder[MOTOR_ENC][motor],l);
    	if (motor==RA)set_encoders(encoder[MOUNT_ENC][RA],encoder[MOUNT_ENC][DEC],l,encoder[MOTOR_ENC][DEC]);
    	else set_encoders(encoder[MOUNT_ENC][RA],encoder[MOUNT_ENC][DEC],encoder[MOTOR_ENC][RA],l);
    	servo_var_reset();
    }


return 0;
}


//-----------------------------------------------------------------
//
//		Szinkronizlja a Mount encodert a motorhoz init_nl
//
//-----------------------------------------------------------------


char sync_encoder_stepper(unsigned char enc_type,unsigned char motor){

float h;
signed long l;

 signed long encoder[2][2]={
							{ 0,0 },
							{ 0,0 }
							};
 	if (mot[motor].encoder[enc_type] == 0) return -2;    //nincs is ez az encoder
    get_encoders(&encoder[MOUNT_ENC][RA],&encoder[MOUNT_ENC][DEC],&encoder[MOTOR_ENC][RA],&encoder[MOTOR_ENC][DEC]);


	h=(float)mot[motor].encoderres[enc_type] ;
	if ( h == 0 )  return -1;

	if (enc_type == MOUNT_ENC){							//enkoder az llvnyon van, drzshajts
		h=-h*(step_to_rad(motor,stepcount[motor],step[motor]))/M2_PI;
		l=(signed long)h;

		if (motor==RA)set_encoders(l,encoder[MOUNT_ENC][DEC],encoder[MOTOR_ENC][RA],encoder[MOTOR_ENC][DEC]);
		else set_encoders(encoder[MOUNT_ENC][RA],l,encoder[MOTOR_ENC][RA],encoder[MOTOR_ENC][DEC]);
    }
    else
    {
    	h= h * mot[motor].reduction;
    	h=-h*(step_to_rad(motor,stepcount[motor],step[motor]))/M2_PI;
    	l=(signed long)h;
//    	printf("e:%d,c:%d\r\n",encoder[MOTOR_ENC][RA],l);
    	if (motor==RA)set_encoders(encoder[MOUNT_ENC][RA],encoder[MOUNT_ENC][DEC],l,encoder[MOTOR_ENC][DEC]);
    	else set_encoders(encoder[MOUNT_ENC][RA],encoder[MOUNT_ENC][DEC],encoder[MOTOR_ENC][RA],l);
    }


return 0;
}



//-----------------------------------------------------------------
//
//		Szinkronizlja az encodereket a motorhoz, init_nl
//
//-----------------------------------------------------------------

char sync_encoder(unsigned char motor){

	char res = 0;
    if (get_motortype() == SERVO_MODE){
    	res = sync_encoder_servo(MOUNT_ENC,motor);
    	res |= sync_encoder_servo(MOTOR_ENC,motor);

    }
    else {

    	res = sync_encoder_stepper(MOUNT_ENC,motor);
    	res |= sync_encoder_stepper(MOTOR_ENC,motor);
    }


return res;
}


/*
//---------------------------------------------------------------------------------
// szinkronizlja a tvcs kijelzett pozicijt az encoderhez
//---------------------------------------------------------------------------------


char sync_to_encoder_pos(unsigned char motor,unsigned char enc){

float r_motor;
float r_enc;
float err;
float h;
unsigned int st, stc;

signed long encoder[2][2]={
								{ 0,0 },
								{ 0,0 }
							};


	get_encoders(&encoder[0][RA],&encoder[0][DEC],&encoder[1][RA],&encoder[1][DEC]);
	h=(float)mot[motor].encoderres[MOUNT_ENC] ;
	if (h)h=2*M_PI/h;	 										//egy encoder lps radinban

	r_enc=-h*(float)encoder[MOUNT_ENC][motor];
	st=step[motor] ;
	while (st!=step[motor])
	  st=step[motor];

	stc=stepcount[motor];
	while (stc!=stepcount[motor])
	  stc=stepcount[motor];

	r_motor=step_to_rad(motor,stc,st);
    err=r_motor-r_enc;
    if (err<0) err = -err;
	if (err>ENC_ERR_MIN){                         //megcsszorr a motor, az encodert vesszk alapnak, hozz lltjuk a tvcs pozcit, de a motor marad ott ahol van

		mot_offset1[motor]-=err;
		mot_offset[motor]+=err;

	}
//	mot_offset1[RA]+=mot_offset[RA]-ra;			   //hogy ne menjen a motor
//	mot_offset[RA]=ra;
return 0;
}

*/
//---------------------------------------


//***********************************************
//
// Megforditja  motor forgst fziscservel
//
//***********************************************

void change_rotation(unsigned char mot){
	
	
	int x;
	int oszt=POS_MAX;
	
	for (x=0;x<=oszt+1;x++)
	{
		
		if (mot==RA){
			dir_cos[x]=dir_cos[x]^MDIR_RA;
			costab_u_RA[x]=-costab_u_RA[x];
		}	
		else{
			dir_cos[x]=dir_cos[x]^MDIR_DEC;
			costab_u_DEC[x]=-costab_u_DEC[x];
		}
			
		
		
	}

	
	
}

//********************************************************************************************
// A kt teketcs rama (sin, cos)
//********************************************************************************************

void make_sin_cos(void){
	
	int x;
	int oszt=POS_MAX;


	float RX=(2*3.1415)/oszt;
	
	for (x=0;x<=oszt+1;x++)
	{
	sin_t[x]=sin(x*RX);
	cos_t[x]=cos(x*RX);
	}	
	
	
	
	
}

//********************************************************************************************
//
//     Kiszmolja a szinustblt	feszltsg vezrelt mdhoz
// 
// 												  
//********************************************************************************************


void make_sintab_u(unsigned char moti,unsigned short ampl)


{

int x;
int oszt=POS_MAX;
signed char dd;
static unsigned short ampl_buf[2]={0,0};

//float RX=(2*3.1415)/oszt;

if (ampl<10)ampl=10;
if (ampl>255)ampl=255;


if (ampl==ampl_buf[moti])return;              //hogy feleslegesen ne csinlja...
 else ampl_buf[moti]=ampl;

//if (moti==0)printf("*ampl:%d\n\r",ampl);

if (moti==RA){
if	((mot[RA].rotation & 0x01) == LEFT_TURN)dd=-1; else dd=1;
if	((mot[RA].rotation & 0x02) == 0x02) dd *=-1;	 // a base bit tfordtja
for (x=0;x<=oszt+1;x++)
{
sintab_u_RA[x]=ampl*sin_t[x];  //+1 volt
costab_u_RA[x]=ampl*cos_t[x]*dd;  //+1 volt
}

}

if (moti==DEC){

if	((mot[DEC].rotation & 0x01) == LEFT_TURN)dd=-1; else dd=1;
if	((mot[DEC].rotation & 0x02) == 0x02) dd *=-1;	// a base bit tfordtja
for (x=0;x<=oszt+1;x++)
{
sintab_u_DEC[x]=ampl*sin_t[x];  //+1 volt
costab_u_DEC[x]=ampl*cos_t[x]*dd;  //+1 volt
}

}




}



//********************************************************************************************
//
//     Kiszmolja a szinusztblt ram vezrelt mdhoz
//
//********************************************************************************************
//const
//SOFF=0.01;
//dir vltoz 1 bit RA 0x10 bit DEC irnyok
void make_sintab_i(unsigned char mot,unsigned short ampl)


{

int x;
int oszt=POS_MAX;

//float RX=(2*3.1415)/oszt;
//printf("Ampl:%d ",ampl);
if (ampl<10)ampl=10;
if (ampl>500)ampl=500;

if (mot==RA){
	

for (x=0;x<=oszt+1;x++)
{
	sintab_i_RA[x]=fabs2(((ampl/4)*sin_t[x]))+0;  //+1 volt	
	costab_i_RA[x]=fabs2(((ampl/4)*cos_t[x]))+0;  //+1 volt
	
	
}
}
else{
	

	for (x=0;x<=oszt+1;x++)
	{
	sintab_i_DEC[x]=fabs2(((ampl/4)*sin_t[x]))+0;  //+1 volt	
	costab_i_DEC[x]=fabs2(((ampl/4)*cos_t[x]))+0;  //+1 volt
	
	
	}
	
	

}




}


void make_sintab_i_dir(unsigned char mot,unsigned char dir)
{
	
	int x;
	int oszt=POS_MAX;

	float RX=(2*3.1415)/oszt;

if (mot==RA){
	
	for (x=0;x<=oszt+1;x++){	
	if (sin(x*RX)>0)dir_sin[x]|=MDIR_RA;else dir_sin[x]&=~MDIR_RA;		
	if (cos(x*RX)>0)dir_cos[x]|=MDIR_RA;else dir_cos[x]&=~MDIR_RA;
	}
}
else{
	for (x=0;x<=oszt+1;x++){
	if (sin(x*RX)>0)dir_sin[x]|=MDIR_DEC;else dir_sin[x]&=~MDIR_DEC;
	if (cos(x*RX)>0)dir_cos[x]|=MDIR_DEC;else dir_cos[x]&=~MDIR_DEC;
	}
}

}


#define TIMER_MAX_V  1000
#define TIMER_MIN_V  20

//******************************************************************************
//*
//*  motor sebessg s irny alapjn belltja a timereket, s a ustep felbontst 
//*
//*
//******************************************************************************

unsigned char set_sin_timer_h(unsigned char m,unsigned int sp,unsigned char dir)


{
unsigned long i;
unsigned char jump;
unsigned long l;
unsigned int speed;
unsigned char presc;
char sc;
char sk;

static unsigned int spm[]={0,0};
static unsigned char sin_busy=0;
const unsigned int presc_tab[] = {1, 2, 4, 8,16};


//if (get_motortype()== SERVO_MODE)return 0;

//*************************************
mot_speeed[m]=sp;
if (sp>userpar[m].gotospeed)sp=userpar[m].gotospeed;


sk=0;
if (sp>spm[m])
{
 if ((sp-spm[m])>30)sk=1;
}

else{

 if ((spm[m]-sp)>0x300)sk=2;
}

if (sk==2)
sk=sk-1;

spm[m]=sp;
//**************************************


sin_busy=1;


{									//hogy ksleltesse a track current kivlasztst
static int m_track_count=20;

if (sp>TRACK_CURR_LIMIT){mot_stat[m]=M_GOTO;m_track_count=300;}
  else if (sp>1){
	  if (m_track_count>1)m_track_count--;
	  else mot_stat[m]= M_TRACK;
	  }
}
if (sp==0){
	/*mot_stat[m]=M_STOP;*/mot_st[m]=0;speed=1;}  //lell a motor ,kis sebessg
else speed=sp;

if (sp<2)
{ //mot_stat[m]=M_STOP;   //nem kattog ha ll a dec, de lehet hogy kis seb nl szorul
 if (stop_c_count[m]==0)
   stop_c_count[m]=STOPCURR_WAIT;
}
 else 
   stop_c_count[m]=0;

jump=1;
presc=0;

for (sc=0;sc<20;sc++)
{

 l=(unsigned int)mot_track_timer_h[m];
 l=l*10*jump*presc_tab[track_presc_h[m]];
 
 i=(l/(unsigned long)(speed*presc_tab[presc]));							   //presc_tab[presc]
 if ((TIMER_MIN_V<i)&&(i<TIMER_MAX_V))break;					   	   	   	   //megvan a timer
  else if (TIMER_MIN_V>i)
   { 
    if (jump<=0x20){jump=(jump*2);presc=0;};			//0x4		   			   //ha gyors, akkor cskken a ustep 0x40 volt
   }
//  else if (presc<4){presc++;}				  						       //noveli az osztst egy lpcsvel
 
}



if (sc<8)  															   //csak ha megvan a j megolds, klnben marad a rgi

{
//	i=i/4;
  if (m){
	  //DEC_timer_init(presc,(unsigned int)i,jump); 					   	   //inicializlja a timert
	  settimer_ALT(i);
//	  printf("pr:%d - i:%d\0x0a\0x0d",presc,(i/presc_tab[presc]));
   }
   else  {
	  //RA_timer_init(presc,(unsigned int)i,jump);
	   settimer_AZ(i); 
//	   printf("pr:%d - i:%d\0x0a\0x0d",jump,i);
   }
    
  if (sp)mot_st[m]=jump;

  mot_speed[m]=sp;							  	  						   //ez is az
//  printf("%d",jump);
  
}
else{ 
//sc=sc+1;
////printf("%d-Set_sin_timer error",sc);			//ha erre jut az bajjjjjjjjj!!!!!!!

}


sin_busy=0;


return(0);
}



//--------------------------------------------------------------------------------



unsigned char set_sin_timer_e(unsigned char m,unsigned int sp,unsigned char dir)


{
unsigned long i;
//char cc;
unsigned char jump;
//char ss;
unsigned long l;
unsigned int speed;
unsigned char presc;
char sc;
//char sk;

//static unsigned int spm[]={0,0};
//static unsigned char sin_busy=0;
const unsigned int presc_tab[] = {2, 8, 32, 128,1024};

//printf("..%d-Set_sin_timer -tr:%d,pr:%d",sp,mot_track_timer[m],track_presc[m]);			//ha erre jut az bajjjjjjjjj!!!!!!!

//if (sp>1000)sp=1000;
if (sp==0){
	/*mot_stat[m]=M_STOP;*/
	if (m)
	mot_st[ALT]=0;
	else
	mot_st[AZ]=0;
	
	
	
	
	
	speed=1;}  //lell a motor ,kis sebessg
else speed=sp;



jump=1;
presc=0;

for (sc=0;sc<20;sc++)
{

 l=(unsigned int)mot_track_timer[m];
 l=l*10*jump*presc_tab[track_presc[m]];
 
 i=(l/(unsigned long)(speed*presc_tab[presc]));							   //presc_tab[presc]
 if ((TIMER_MIN<i)&&(i<TIMER_MAX))break;					   	   	   	   //megvan a timer
  else if (TIMER_MIN>i)
   { 
    if (jump<=0x4){jump=(jump*2);presc=0;};					   			   //ha gyors, akkor cskken a ustep 0x40 volt
   }
  else if (presc<4){presc++;}				  						       //noveli az osztst egy lpcsvel
 
}



//if (sc<10)  															   //csak ha megvan a j megolds, klnben marad a rgi

{
	
  if (m){
	  DEC_timer_init(presc,(unsigned int)i,jump); 					   	   //inicializlja a timert
	  if (sp)mot_st[ALT]=jump;
       }
   else  {
	   RA_timer_init(presc,(unsigned int)i,jump);
	   if (sp)mot_st[AZ]=jump;
//	   printf("pr:%d - i:%d\0x0a\0x0d",presc,i);
   }
 
}
if (sc>12){ 

printf("..%d-Set_sin_timer error1-tr:%d,pr:%d",sp,mot_track_timer[m],track_presc[m]);			//ha erre jut az bajjjjjjjjj!!!!!!!

}





return(0);
}

#define CURR_INC 6
void select_ui_mode (void){
	
 if (mot_speed[RA]>userpar[RA].umode_limit_up){
	 drive_mode[RA]=IMODE;
	 drive_mode_count[RA]=2;
 }
 
 if (mot_speed[RA]<userpar[RA].umode_limit_down){
	 if (drive_mode_count[RA])drive_mode_count[RA]--;
	 else drive_mode[RA]=UMODE;
 }
 
 if (mot_speed[DEC]>userpar[DEC].umode_limit_up){
 	 drive_mode[DEC]=IMODE;
 	 drive_mode_count[DEC]=2;
  }
  
  if (mot_speed[DEC]<userpar[DEC].umode_limit_down){
 	 if (drive_mode_count[DEC])drive_mode_count[DEC]--;
 	 else drive_mode[DEC]=UMODE;
  } 
 
 
 
// if (mot_speed[DEC]>userpar[DEC].umode_limit_up) drive_mode[DEC]=IMODE;
// if (mot_speed[DEC]<userpar[DEC].umode_limit_down)	drive_mode[DEC]=UMODE;
	
}


//******************************************************************************
//*
//*  motor sebessg s irny alapjn belltja a timereket, s a ustep felbontst 
//*
//*
//******************************************************************************


unsigned char set_sin_timer_m(unsigned char m,unsigned int sp,unsigned char dir)


{
unsigned long i;
//char cc;
unsigned char jump;
//char ss;
unsigned long l;
unsigned int speed;
unsigned char presc;
char sc;
char sk;

static unsigned int spm[]={0,0};
static unsigned char sin_busy=0;
const unsigned int presc_tab[] = {2, 8, 32, 128,1024};


//if (get_motortype()== SERVO_MODE)return 0;

//*************************************
//AT91C_BASE_DBGU->DBGU_THR='s';
//mot_speeed[m]=sp;
if (sp>userpar[m].gotospeed)sp=userpar[m].gotospeed;
mot_speeed[m]=sp;   //2013.07.02

sk=0;
if (sp>spm[m])
{
 if ((sp-spm[m])>30)sk=1;
}

else{

 if ((spm[m]-sp)>0x300)sk=2;
}

if (sk==2)
sk=sk-1;

spm[m]=sp;
//**************************************


sin_busy=1;


{									//hogy ksleltesse a track current kivlasztst
static int m_track_count=20;

if (sp>TRACK_CURR_LIMIT){mot_stat[m]=M_GOTO;m_track_count=300;}
  else if (sp>1){
	  if (m_track_count>1)m_track_count--;
	  else mot_stat[m]= M_TRACK;
	  }
}
if (sp==0){
	/*mot_stat[m]=M_STOP;*/mot_st[m]=0;speed=1;}  //lell a motor ,kis sebessg
else speed=sp;

if (sp<2)
{ //mot_stat[m]=M_STOP;   //nem kattog ha ll a dec, de lehet hogy kis seb nl szorul
 if (stop_c_count[m]==0)
   stop_c_count[m]=STOPCURR_WAIT;
}
 else 
   stop_c_count[m]=0;

jump=1;
presc=0;

for (sc=0;sc<20;sc++)
{

 l=(unsigned int)mot_track_timer[m];
 l=l*10*jump*presc_tab[track_presc[m]];
 
 i=(l/(unsigned long)(speed*presc_tab[presc]));							   //presc_tab[presc]
 if ((TIMER_MIN<i)&&(i<TIMER_MAX))break;					   	   	   	   //megvan a timer
  else if (TIMER_MIN>i)
   { 
    if (jump<=0x4){jump=(jump*2);presc=0;};					   			   //ha gyors, akkor cskken a ustep 0x40 volt
   }
  else if (presc<4){presc++;}				  						       //noveli az osztst egy lpcsvel
 
}



if (sc<10)  															   //csak ha megvan a j megolds, klnben marad a rgi

{
	
  if (m)
	  DEC_timer_init(presc,(unsigned int)i,jump); 					   	   //inicializlja a timert
   else  {
	   RA_timer_init(presc,(unsigned int)i,jump);
//	   printf("pr:%d - i:%d\0x0a\0x0d",presc,i);
   }
    
  if (sp)mot_st[m]=jump;

  mot_speed[m]=sp;							  	  						   //ez is az
//  printf("%d",jump);
  
}
else{ 
//sc=sc+1;
printf("%d-Set_sin_timer error",sc);			//ha erre jut az bajjjjjjjjj!!!!!!!

}


sin_busy=0;


return(0);
}


unsigned char set_sin_timer(unsigned char m,unsigned int sp,unsigned char dir){

unsigned char rr;	
	
//	if (misc.mounttype!=GERMAN)
	if (misc.mounttype==ALTAZ){
		
	 rr=set_sin_timer_h(m,sp,dir);	
	 	
	}else rr=set_sin_timer_m(m,sp,dir);	
		
	
	
return rr;	
}



static char last_mot_stat[]={0,0};
void set_mot_current(void)

{

unsigned char m;
unsigned int curr=0;
unsigned int ii;
int mered;
unsigned int icc=0;


static char iminimum[]={50,50};
//static char last_mot_stat_u[]={0,0};

//if (!motors_enabled)return;				//kikapcsolt motornl marad az utols beltott PWM


 for (m=0;m<2;m++){
	
	switch (mot_stat[m])
	{
	 case M_STOP:
	   curr=mot[m].stopcurr+200; 
	 break;
	 case M_GOTO:
		 curr=mot[m].gotocurr+200;
	 break;
	 case M_TRACK:
		 curr=mot[m].trackcurr+200;
		
	 break;
	 
	 default:
		 curr=mot[m].gotocurr+200;
	 break;
	 
	}	
	
#ifdef MOTOR_DOUBLE_CURRENT
	curr = curr / 2;
#endif
	
if (m)ii=i_DEC;else ii=i_RA;

if (drive_mode[m]==UMODE)            //a mrt ramot sszehasonltjuk a kvnttal, s korriglunk
	{

#ifdef REGIFESZ_SZAB

/*	if ((mot_stat[m]!=M_STOP)&&(last_mot_stat_u[m]==M_STOP)){
				ampl[m]=ampl[m]*4;
		        if (ampl[m]>255)ampl[m]=255;
				make_sintab_u(m, ampl[m]);
				printf("indul -%d",ampl[m]);
			}
			else*/
	
	//itt kne a sebessg vltozs meredeksgt figyelembe venni mot_speed-mot_speed_a
	mered=mot_speed_a[m]-mot_speed[m]; //ha 0 akkor nincs gyorsuls	
	if (mot_speed[m]>10)mered=mered/8;	//indulsi lket..
	curr=curr+mered;
//	printf("mot:%d mered:%d-curr:%d\n\r",m,mered,curr);
	if (ii<curr){
		ampl[m]+=(curr-ii)/32;            //20  2009.11.19
		if (ampl[m]>255)ampl[m]=255;
		make_sintab_u(m, ampl[m]);
	  }
	
	
	
	
	if (ii>(curr+10)){		//+100 
			ampl[m]-=(ii-curr)/16;       //20 //16
			if (mot_stat[m]==M_GOTO){ 
			 if (ampl[m]<iminimum[m]*1.2)ampl[m]=iminimum[m]*1.2;}
			  else if (ampl[m]<10)ampl[m]=10;
			make_sintab_u(m, ampl[m]);
		  }	
	
//	last_mot_stat_u[m]=mot_stat[m];
//	printf("m -%d ram -%d , imin -%d \n\r",m,ampl[m],iminimum[m]);
//	printf("mot:%d mered:%d-curr:%d m=%d\n\r",m,mered,curr,ii);
	
					//minimum ramokat bellt
	if (mot_stat[m]==M_TRACK){
	  if (iminimum[m]>ampl[m]){if(iminimum[m]>10)iminimum[m]--;}
	   else if (iminimum[m]<128)iminimum[m]=iminimum[m]++;
		
	  

	}
#else    //uj feszmd, ezt hasznljuk
	{

mered=0;

//	if   (mot_speed[m]>50)icc=peek_curr[m]*2; else icc=ii;
//if   (mot_speed[m]<30)icc=peek_curr[m]*2; else icc=ii;
icc=ii;
//	icc=peek_curr[m]*2;
			if (icc<curr){
			//	mered=(mot_speed_a[m]-mot_speed[m])/100;
			//	if (mered<0)mered=0;
				ampl[m]+=((curr-icc)+mered)/250;
				if (ampl[m]>255)ampl[m]=255;
				make_sintab_u(m, ampl[m]);
			  }




			if (icc>(curr+10)){		//+100
                float curr_f,icc_f;

			//	    printf ("icc=%d,%d",icc,curr);
			//	    mered=(mot_speed[m]-mot_speed_a[m])/100;
			//	    if (mered<0)mered=0;

                	curr_f=curr;
                	icc_f=icc;

					if ((icc_f > (curr_f * 1.1)) ) {
						ampl[m]-=((icc-curr)+mered)/100;
					//	printf ("mo=%d,ampl=%d",m,ampl[m]);
					}
					else ampl[m]-=((icc-curr)+mered)/250;
					if (ampl[m]<10)ampl[m]=10;
					make_sintab_u(m, ampl[m]);
				  }


		  if (iminimum[m]>ampl[m]){if(iminimum[m]>10)iminimum[m]--;}
		  	   else if (iminimum[m]<128)iminimum[m]=iminimum[m]++;

	  }

	 // make_sintab_u(m, ampl[m]);
	//if (m==0)printf("-iii-:%d,ampl:%d,m:%d.",icc,ampl[m],m);

#endif
//*/	
}
else
 {      //ez az ram md, itt magtl szablyozza a belltott ramot akkor is csinlni kell, ha UMODE!!! hogy j legyen a vlts
     //printf(".%d.",mot_stat[m]);
 	 if (mot_stat[m]!=last_mot_stat[m]){
 		 make_sintab_i(m, (AMPL_I*curr)/500);
 		// if (mot[m].rotation==LEFT_TURN)change_rotation(m);
 		// printf(" \n\r-------- Aram :%d\n\r",curr);
 		 last_mot_stat[m]=mot_stat[m];
 	 }



}

	

 }
 
/*
if (drive_mode[DEC]==UMODE)
{
	if (i_DEC<mot[DEC].gotocurr){
		ampl[DEC]+=(mot[DEC].gotocurr-i_DEC)/20;
		if (ampl[DEC]>255)ampl[DEC]=255;
		make_sintab_u(DEC, ampl[DEC]);
	  }		
				
			
						
	if (i_DEC>mot[DEC].gotocurr+100){
		ampl[DEC]-=(i_DEC-mot[DEC].gotocurr)/20;
		if (ampl[DEC]<10)ampl[DEC]=10;
		make_sintab_u(DEC, ampl[DEC]);			
	  }
}	
//	i_DEC=0;	
	
*/	
	
	
}


//********************************************************************************************************
//mot_speed 			- az aktulis sebessg
//mot_speed_a 			- a kvnt sebessg
//mot_dir				- az aktulis irny
//mot_dir_a				-a kvnt irny
//ha mot_dir!=mot_dir_a -akkor lelasst 0 ra s onnan nveli a sebessget ha kell az ellenkez irnyba
//ha megvan a szmtott seb. akkor belltja a step timereket.
//********************************************************************************************************
void accelerate(void)
{

unsigned char i;
unsigned int m_sp;
unsigned int acceli;
static unsigned char corr_cnt=0;

select_ui_mode();
set_mot_current();
if (corr_cnt>0)corr_cnt--;
else {
// mot_offset1[RA]+=corr_ra_encoder;
 corr_cnt=CORR_ENC_CNT;
}
 // irny vlts
 
///////if (lx200_busy)return;	 	   //todo



for (i=0;i<=1;i++)	 
	 
{	 
	 
	if (no_sync[i]==1)continue;  //2009.09.3 return; volt 	
	
	if  (mot_dir[i]!=mot_dir_a[i])
		{
		 if (!mot_dir_ch[i])
		   {
		    mot_dir_ch[i]=1;
		    mot_speed_b[i]=mot_speed_a[i];
		    mot_speed_a[i]=0;  //0 volt 1
			
		   }	 
		 
		}	 
 //printf("accel");//
   if ((mot_speeed[i]==0)&&mot_dir_ch[i]) //==0 volt   most megllt
		    {
		     mot_dir[i]=mot_dir_a[i];      //most vlt irnyt
			 mot_speed_a[i]=mot_speed_b[i];
			 mot_dir_ch[i]=0;

		   }

}
////////
//gyorsuls -lassuls


for (i=0;i<=1;i++)
{
    m_sp=0;
    int aca=1;
    int aca_slow=1;

    if (no_sync[i]==1)continue;  //2010.06.20  
    //		aca=2+(1000/mot[i].reduction);
    aca=(4000/mot[i].reduction);
    if (aca < 1 ) aca = 1;
    aca_slow=(25000/mot[i].reduction);
 //   if (mot[i].reduction > 3000) aca_slow = aca_slow + ((mot[i].reduction - 3000) / 2000);
        if (aca_slow < 8 ) aca_slow = 8;
//    if (first_stop[i])aca=1;  //marc
 //   if (i == 0) printf("aca: %d,",aca);

	 acceli=accel[i];   

	if (mot_speed_a[i]<mot_speeed[i])             //lassuls a cltol val tvolsggal arnyosan kell
   	   {

	    if ((mot_speeed[i]>1)&&((mot_speeed[i]-mot_speed_a[i])>(accel[i]*aca_slow)))
		 {
//	     printf("a:%d:",aca_slow);
         set_sin_timer(i,mot_speeed[i]-(acceli*aca_slow),mot_dir[i]); //acceli*2 volt
		  lassul[i]=10;
		 }
		  else 
		  {

				  
			set_sin_timer(i,mot_speed_a[i],mot_dir[i]);
		  }  

   	   }
    if (mot_speed_a[i]>mot_speeed[i])
   	   {
    	first_stop[i]=0;
	    if ((mot_speed_a[i]-mot_speeed[i])>((accel[i]*aca)))          //gyorsuls
		 {


	      set_sin_timer(i,mot_speeed[i]+((acceli*aca)),mot_dir[i]);
		   	  
		 }
		  else 
		  {

			  	
			  set_sin_timer(i,mot_speed_a[i],mot_dir[i]);	   			  //mr csak egy lps...  
		  }
   	   }
	
	
  
  
	 
   
}	 
/////////////////////////



	
/*
if (mot_speed_a[RA]<6)
 i=1;

if (mot_speed_a[RA]>14)
 i=1;
 */
}





//*****************************************************************************************************
//* kiszmolja a kvetsi sebessghez tartoz timer rtkeket
//* melyik motor
//* *presc = eloszts
//* *timer = timer register
//* return = 1 
//*****************************************************************************************************


 
unsigned char  calc_track_timer (unsigned char motor,unsigned int *pres, unsigned int *timer )

{
 
 unsigned long timreg;
 unsigned int prescale;
 unsigned int mstep;
// unsigned char motor;
 long osc_Hz;
// const unsigned int presc_tab[] = {1, 2, 4, 8,16};
 
// for (motor=0;motor<=1;motor++)      //a mul1-2 a sync_mot szablyz paramtere lesz
 {

   mul1[motor]=(float)mot[motor].reduction*(unsigned long)mot[motor].motres*ERR_MUL;
  if (mul1[motor]>220000)mul1[motor]=220000; 
 //  if (mul1[motor]>300000)mul1[motor]=300000;
 mul1[motor]=mul1[motor] / (POS_MAX/oszt);								  			 
   
 }  
 
 mul2=mul1[RA]*1000;
// if (mul2>220000000)mul2=220000000;
 
// printf("mul1=%d,mul2=%d\n\r",(int)mul1[RA],(int)mul2);
 
// motor=RA;
 *pres=0;
 mstep=oszt>>2;
 
// if (misc.mounttype==GERMAN)
 if (misc.mounttype!=ALTAZ)
  		osc_Hz=BOARD_MCK;
  	 
  	 else {
  		osc_Hz=10000; //100us
  		
  		presc_tab[0]=1;
  		presc_tab[1]=2;
  		presc_tab[2]=4;
  		presc_tab[3]=8;
  		presc_tab[4]=16;
  		
  	    }
 
 for (;;){
     float v;
	 float h;
	 prescale=presc_tab[(*pres)];
     h=(float)mot[motor].reduction*mot[motor].motres*mstep;
 	 v=(float) (h)/CICLE_CONST; //egy kr
 	 	 
 	 timreg=(osc_Hz/(v*prescale));
 	 if (timreg>TIMER_MAX)       									//ff00
	  {
	   *pres=(*pres)+1;	   
	  }															//2,8,32,128,1024
 else break;
 }
 
 //if (*pres>1)*pres=(*pres)-1;
 *timer=(unsigned int)timreg;
// printf("t:%d,p:%d, p*:%d %c%c",(unsigned int)timreg,prescale,*pres,0x0d,0x0a);
 return(1);
}

//*****************************************************************************************************
//* kiszmolja a kvetsi sebessghez tartoz timer rtkeket
//* melyik motor
//* *presc = eloszts
//* *timer = timer register
//* return = 1 
//*****************************************************************************************************


 
unsigned char  calc_track_timer_e (unsigned char motor,unsigned int *pres, unsigned int *timer )

{
 
 unsigned long timreg;
 unsigned int prescale;
 unsigned int mstep;
// unsigned char motor;
 long osc_Hz;
// const unsigned int presc_tab[] = {1, 2, 4, 8,16};
 unsigned int presc_tab[] = {2, 8, 32, 128,1024};
 
 oszt=POS_MAX;
 
// for (motor=0;motor<=1;motor++)      //a mul1-2 a sync_mot szablyz paramtere lesz
 {

   mul1[motor]=(float)mot[motor].reduction*(unsigned long)mot[motor].motres*ERR_MUL;
  if (mul1[motor]>220000)mul1[motor]=220000; 
 //  if (mul1[motor]>300000)mul1[motor]=300000;
 mul1[motor]=mul1[motor] / (POS_MAX/oszt);								  			 
   
 }  
 
 mul2=mul1[RA]*1000;
// if (mul2>220000000)mul2=220000000;
 
// printf("mul1=%d,mul2=%d\n\r",(int)mul1[RA],(int)mul2);
 
// motor=RA;
 *pres=0;
 mstep=oszt>>2;
 

 osc_Hz=BOARD_MCK;
  	 
  
 
 for (;;){
     float v;
	 float h;
	 prescale=presc_tab[(*pres)];
     h=(float)mot[motor].reduction*mot[motor].motres*mstep;
 	 v=(float) (h)/CICLE_CONST; //egy kr
 	 	 
 	 timreg=(osc_Hz/(v*prescale));
 	 if (timreg>TIMER_MAX)       									//ff00
	  {
	   *pres=(*pres)+1;	   
	  }															//2,8,32,128,1024
 else break;
 }
 
 //if (*pres>1)*pres=(*pres)-1;
 *timer=(unsigned int)timreg;
// printf("t:%d,p:%d, p*:%d %c%c",(unsigned int)timreg,prescale,*pres,0x0d,0x0a);
 return(1);
}

//--------------------------------------------------------------------------------------


//egyelre csak irq -bl lehet hvni??



//***********************************************************************************************************
//
// Visszadja a 4 enkoder pozcijt
//
//***********************************************************************************************************




#ifdef ENCODER_TEST_DIV     														//leoszthat az encoder bemenet, tesztelsi clokra

unsigned char get_encoders_1(signed long *e1,signed long *e2,signed long *e3,signed long *e4 ){


#else
unsigned char get_encoders(signed long *e1,signed long *e2,signed long *e3,signed long *e4 ){
#endif

	
	
//unsigned long ibuf;	
//signed long ee1;	

/*
__asm__( 
			//"DisIRQ:\n\t "
			//	"ldr r1,#0x80\n\t "
			//	"b DisInt\n\t "
			"DisFIQ:\n\t "
			//	"ldr r1,#0x40\n\t " 
				"mov r1,#0x40|0x80\n\t "
			"DisInt:\n\t "
				"mrs r0,CPSR\n\t "
				"orr r0,r0,r1\n\t "
				"msr CPSR,r0\n\t "
				"mrs r0,CPSR\n\t "
				"ands r0,r0,r1\n\t "
				"beq DisInt\n\t "
				:
				:
				: "r0","r1"
		);



*/

	
//	__asm__(	   "push {r0, r1, r2, r3} ");
	                //ibuf=AT91C_BASE_AIC->AIC_IMR;
					//AT91C_BASE_AIC->AIC_IDCR = 0xffffffff;          //Fiq disable
//	 __asm__(      " msr  cpsr_c, #Mode_FIQ|I_Bit|F_Bit\n\t ");	   
	 __asm__(      
/*			       " mrs  r0,CPSR\n\t "
			 	   " and  r1,r0,#0x13\n\t "	
			       " bic  r0,r0,#0x13\n\t"	
			 	   " orr  r0,r0,#0x11\n\t "
			       " msr  cpsr_c,r0\n\t "
*/			 
		//	       " msr  cpsr_c, #0x11|0x80|0x40\n\t "   //Fiq regiszterek kivlasztsa	 
			    //   " mov  r8,#33\n\t "
			   
			 
			 		" mrs r0,CPSR\n\t "
			 		" mrs r2,CPSR\n\t "
			 		" mov r1,#0x1F\n\t"
			 		" bics r0,r0,r1\n\t "
			 	 
			 		" mov r1,#0x11|0x40|0x80\n\t "
			 		" orr r0,r0,r1\n\t "			        
			 		" msr cpsr_c,r0\n\t "	
			 
				   " mov  r0,r8\n\t "  //ENCODER 1
				   " mov  r1,r9\n\t "  //ENC 2
				   " mov  r6,r10\n\t " //ENC 3
				   " mov  r7,r11\n\t " //ENC 4				  				   			   
	//			   " msr  cpsr_c, #Mode_IRQ\n\t "         //mert irqban vagyunk!!!!
	//			   " msr  cpsr_c, #0x12\n\t "
	//		       " mrs  r0,CPSR\n\t "
	//		 	   " bic  r0,r0,#0x13\n\t"	
	//		 	   " orr  r0,r1\n\t "
			 	   " msr  cpsr_c,r2\n\t "
			 
			       " mov  %0,r0\n\t "  //ENCODER 1
			 	   " mov  %1,r1\n\t "  //ENC 2
			 	   " mov  %2,r6\n\t " //ENC 3
			 	   " mov  %3,r7\n\t " //ENC 4
//			 	 " mov  %2,r0\n\t " //ENC 3			//csak 2 encodert hasznlunk, a motor bemenetek mr '0' pozcit adnak
//			 	 " mov  %3,r1\n\t " //ENC 4
			       
			       :"=r" (*e2),
			        "=r" (*e1),
			        "=r" (*e4),
			        "=r" (*e3)
			       
			       
			       :
	 			   :"r0","r1","r2","r6","r7"
			        
			       
		 );	
	
/*	
			//		AT91C_BASE_AIC->AIC_IECR = ibuf;         //Fiq enable
	 
	 __asm__( 
	 			
	 				"mrs r0,CPSR\n\t "
	 				"bic r0,r0,#0x40|0x80\n\t "
	 				"msr CPSR_c,r0\n\t "
	 				
			 
			        :
			        :
	                :"r0"

	 		);
	*/
	 
	 /*
	 __asm__( 
	 				"pop {r0, r1, r2, r3} "
			 		"str  r0, [r2]"
			 		"str  r1, [r3]"
			 		"str  r6, [r4]"
			 		"str  r7, [r5]"
			 				   :
			 			       :
			 	 			   :"r0","r1","r6","r7","r2","r3","r4","r5"
			     
			 );

	 __asm__(      
			 	   
			   
				   " mov  %0,r0\n\t "  //ENCODER 1
				   " mov  %1,r1\n\t "  //ENC 2
				   " mov  %2,r6\n\t " //ENC 3
				   " mov  %3,r7\n\t " //ENC 4				  				   			   
	
			       
			       : "=r" (*e1),
			         "=r" (*e2),
			         "=r" (*e3),
			         "=r" (*e4)
			       
			      
		 );	
*/
return 0;	
}

#ifdef ENCODER_TEST_DIV

unsigned char get_encoders(signed long *e1,signed long *e2,signed long *e3,signed long *e4 ){

	get_encoders_1(e1,e2,e3,e4);

*e1=*e1/ENCODER_TEST_DIV;
*e2=*e2/ENCODER_TEST_DIV;
*e3=*e3/ENCODER_TEST_DIV;
*e4=*e4/ENCODER_TEST_DIV;

return 0;
}

#endif

#ifdef ENCODER_TEST_DIV
//Csak irq-n kvlrl lehet hvni???
unsigned char set_encoders_1(signed long e1,signed long e2,signed long e3,signed long e4 ){

#else
unsigned char set_encoders(signed long e1,signed long e2,signed long e3,signed long e4 ){
#endif

	
	/*
	__asm__(      
					       
					  //     " msr  cpsr_c, #0x11|0x80|0x40\n\t "   //Fiq regiszterek kivlasztsa	 
						   " mov  r4,%0\n\t "  //ENCODER 1
						   " mov  r5,%1\n\t "  //ENC 2
						   " mov  r6,%2\n\t " //ENC 3
						   " mov  r7,%3\n\t " //ENC 4				  				   			   
			//			   " msr  cpsr_c, #Mode_USR\n\t "
					//	   " msr  cpsr_c, #0x10\n\t "
					       :					       
					       : "r" (e1),
					         "r" (e2),
					         "r" (e3),
					         "r" (e4)
					       
					       
				 );	
	
	
	
	__asm__( 
				//"DisIRQ:\n\t "
				//	"ldr r1,#0x80\n\t "
				//	"b DisInt\n\t "
//					"DisFIQ1:\n\t "        todo
				//	"ldr r1,#0x40\n\t " 
					"mov r1,#0x40|0x80\n\t "
//					"DisInt1:\n\t "        todo
					"mrs r0,CPSR\n\t "
					"orr r0,r0,r1\n\t "
					"msr CPSR,r0\n\t "
					"mrs r0,CPSR\n\t "
					"ands r0,r0,r1\n\t "
//					"beq DisInt1\n\t "     todo
			     :
			     :
	             :"r0","r1"
			);





		                //ibuf=AT91C_BASE_AIC->AIC_IMR;
						//AT91C_BASE_AIC->AIC_IDCR = 0xffffffff;          //Fiq disable
	//	 __asm__(      " msr  cpsr_c, #Mode_FIQ|I_Bit|F_Bit\n\t ");	   
		 __asm__(      
				       " mrs  r0,CPSR\n\t "
				 	   " and  r1,r0,#0x13\n\t "	
				       " bic  r0,r0,#0x13\n\t"	
				 	   " orr  r0,r0,#0x11\n\t "
				       " msr  cpsr_c,r0\n\t "
				 
			//	       " msr  cpsr_c, #0x11|0x80|0x40\n\t "   //Fiq regiszterek kivlasztsa	 
				    //   " mov  r8,#33\n\t "
					   " mov  r8,r4\n\t "  //ENCODER 1
					   " mov  r9,r5\n\t "  //ENC 2
					   " mov  r10,r6\n\t " //ENC 3
					   " mov  r11,r7\n\t " //ENC 4				  				   			   
		//			   " msr  cpsr_c, #Mode_IRQ\n\t "         //mert irqban vagyunk!!!!
		//			   " msr  cpsr_c, #0x12\n\t "
				       " mrs  r0,CPSR\n\t "
				 	   " bic  r0,r0,#0x13\n\t"	
				 	   " orr  r0,r1\n\t "
				 	   " msr  cpsr_c,r0\n\t "
				       :
				       :
		 			   :"r0","r1"
				      
				       
			 );	
		
		
				//		AT91C_BASE_AIC->AIC_IECR = ibuf;         //Fiq enable
		 
		 __asm__( 
		 			
		 				"mrs r0,CPSR\n\t "
		 				"bic r0,r0,#0x40|0x80\n\t "
		 				"msr CPSR_c,r0\n\t "
		 				:
				        :
				        :"r0"

		 		);
		 
		*/ 
//----------------------------------------------------------------------------------
		 
	__asm__(	 					

							" mov  r4,%1\n\t "  //ENCODER 1
					 		" mov  r5,%0\n\t "  //ENC 2
					 		" mov  r6,%3\n\t " 	//ENC 3
					 		" mov  r7,%2\n\t " 	//ENC 4
			
		 					" mrs r0,CPSR\n\t "
		 			 		" mrs r2,CPSR\n\t "
		 			 		" mov r1,#0x1F\n\t"
		 			 		" bics r0,r0,r1\n\t "
		 			 	 
		 			 		" mov r1,#0x11|0x40|0x80\n\t "
		 			 		" orr r0,r0,r1\n\t "			        
		 			 		" msr cpsr_c,r0\n\t "	
		 			 
		 				   " mov  r8,r4\n\t "  //ENCODER 1
		 				   " mov  r9,r5\n\t "  //ENC 2
		 				   " mov  r10,r6\n\t " //ENC 3
		 				   " mov  r11,r7\n\t " //ENC 4

		 			 	   " msr  cpsr_c,r2\n\t "
		 			 
		 			       
		 			       
		 			       :		 			       
		 			       : "r" (e1),
					         "r" (e2),
					         "r" (e3),
					         "r" (e4)
		 	 			   :"r0","r1","r2","r4","r5","r6","r7"
		 			        
		 			       
		 		 );	
		 
		 
		 
		 
		 
		 
		
	return 0;	
}


#ifdef ENCODER_TEST_DIV

unsigned char set_encoders(signed long e1,signed long e2,signed long e3,signed long e4 ){


set_encoders_1(e1*ENCODER_TEST_DIV,e2*ENCODER_TEST_DIV,e3*ENCODER_TEST_DIV,e4*ENCODER_TEST_DIV);
return 0;
}

#endif


//static int mot_splimit[2]={0,0};
//------------------------------------------------------------------------------------------
//
// Kiszmolja , hol kell lenni az encodereknek;
//
//------------------------------------------------------------------------------------------
void calc_encoder_wanted(void){

	static float r_motor;	
	static float rate_t;
	static float temp;
	unsigned char mot;

	signed long encoder[2][2]={
								{ 0,0 },
								{ 0,0 }							
							};


get_encoders(&encoder[MOUNT_ENC][RA],&encoder[MOUNT_ENC][DEC],&encoder[MOTOR_ENC][RA],&encoder[MOTOR_ENC][DEC]);
	
for (mot=0;mot<=1;mot++){	
	
	r_motor=encoder_to_rad(mot,MOTOR_ENC,encoder[MOTOR_ENC][mot]);
	//encoder[mot][ENC]=rad_to_encoder(mot,ENC,r_motor);                   //visszaellenrzm
	
	rate_t=0;
	rate_t=get_mot_rate(mot);
//	if (mot&&NODECPEC)temp=+mot_offset1[mot];									  //+mot_offset_pec[mot]);///teszt

//		 else  
		temp=+mot_offset1[mot]+(mot_offset_refr[mot]+mot_backlash[mot]);       //+mot_offset_pec[mot]);

	//	off_pec[mot]=(rate_t-r_motor)-temp;        //todo 

		if (mot&&NODECPEC)
		;
		else
		{  
		  if (userpar[mot].PEC_corr!=0)
		    temp=temp+mot_offset_pec[mot]; 											//ha be van kapcsolva a PEC
			else temp=temp+mot_last_offset_pec[mot];
		
		}

		

		mot_pos[mot]=rate_t-r_motor-temp;

	//	if ((no_sync[mot])||lx200_busy){s_m_busy=0;return;}							//mindg kell a szinkron

		


		if (sid_midnight()&&(userpar[mot].rate_sel==SID)){
			mot_offset[mot]-=M2_PI;sid_midnight_corr(0);
			}																		   //sid jflkor ne tekerjen

																					   // "s"  a hiba 
		r_motor=rate_t-mot_offset[mot]-rate_offset[mot]-temp;                      //-SidT;			ha s=0 akkor szinkronban van!										   //ez a hiba amit ki kell szablyozni
		 				
	
	
		
	    motw_ok=0;
	    mot_encoder_w[mot]= rad_to_encoder(mot,MOTOR_ENC,r_motor);
	    //mot_encoder_w[mot]= rad_to_encoder(mot,ENC,rate_t);
	    motw_ok=1;
	    
	    if(mot==DEC)
	    	
	    	{
//	    	printf("IS=%d Wa=%d Sp=%d SP=%d ERR=%d pro=%d dif=%d int=%d p=%d d=%d i=%d \n\r",(int)encoder[MOTOR_ENC][mot],(int)mot_encoder_w[mot],mot_servo_speed[mot],
//	    			mot_speed[mot],mot_err_i[mot],servo_prop_const,servo_diff_const,servo_integ_const,
//	    			mot_err_p[mot],mot_err_d[mot],mot_err_in[mot]); 
	    	}
	
	    
	    
 }	
	
}





signed short LowPass_filter (signed short in){
	
#define FILTER_SHIFT 4 // Parameter K
	

signed short filter_reg=0; 	// Delay element  32 bits
//signed short filter_input; 	// Filter input  16 bits
//signed short filter_output; // Filter output  16 bits
							// Update filter with current sample.
//filter_reg = filter_reg - (filter_reg >> FILTER_SHIFT) + filter_input;
							// Scale output for unity gain.
return filter_reg >> FILTER_SHIFT;
	
	
	
}




#define SPLIM    0x7f
#define INTEG_LIMIT 3000000
#define DIFF_LIMIT  20000

#define INTEG_LIMIT_STEPPER 300

//****************************************************************************************************************
//
//  A szerv szinkronizlsa. A sync_mot ltal szmolt hibnak megfelel sebessg rvenystse.
//  Ha kicsi a hiba kicsi a sebessg, ha nagy akkor nagy a sebessg is
//
//****************************************************************************************************************

#ifdef SERVO_MODE_ENABLED







static signed int integ[2]={0,0};
static signed int last_corr[2]={0,0};
static int cc[2]={0,0};
static signed long encoder_last[2][2]={
							{ 0,0 },
							{ 0,0 }
						};
static signed long encoder[2][2]={
							{ 0,0 },
							{ 0,0 }
						};


void servo_var_reset(void){

	integ[RA]=integ[DEC]=0;
	last_corr[RA]=last_corr[DEC]=0;

	get_encoders(&encoder[MOUNT_ENC][RA],&encoder[MOUNT_ENC][DEC],&encoder[MOTOR_ENC][RA],&encoder[MOTOR_ENC][DEC]);
	cc[RA]=-encoder[MOTOR_ENC][RA]*48;
	cc[DEC]=-encoder[MOTOR_ENC][DEC]*48;


	encoder_last[0][0]=encoder[0][0];
	encoder_last[1][0]=encoder[1][0];
	encoder_last[0][1]=encoder[0][1];
	encoder_last[1][1]=encoder[1][1];

}

char check_encoder(unsigned char mot){

static unsigned char encoder_err_cnt[2] ={0,0};
int current;

if ( mot ) current = I_RA_B;   //I_RA_A+I_RA_B az RA motor kt tekercse
else current = I_RA_A;


if ((current > 100) && (encoder[MOTOR_ENC][mot] == encoder_last[MOTOR_ENC][mot])){
	if (encoder_err_cnt[mot] < 0xff)encoder_err_cnt[mot]++;
}
else encoder_err_cnt[mot] = 0;

if (encoder_err_cnt[mot] < 20) return 0;
else return 1;


}

void sync_servo_mot(unsigned char mot){
	

signed int corr;

signed int prop;


signed int diff ;
signed int integr ;
static char active;





if (!initialized)return;
if (no_sync[mot]){

	current_set(mot, 0);
	return;
}

if (!active){
	
active=1;




    
    get_encoders(&encoder[MOUNT_ENC][RA],&encoder[MOUNT_ENC][DEC],&encoder[MOTOR_ENC][RA],&encoder[MOTOR_ENC][DEC]);

    
 //   spcorr=abs(mot_servo_speed[mot])/10;
 //   if (!spcorr)spcorr++;
 //   if (spcorr>100)spcorr=100;
    
 //   if (abs(mot_servo_speed[mot])>20)spcorr=10;else spcorr=1;
 //   mot_speed[mot]=0;
    	if (mot_dir[mot])
    		cc[mot]=cc[mot]-mot_speed[mot];
    	else 
    		cc[mot]=cc[mot]+mot_speed[mot];
    
     
     mot_err_i[mot]=(encoder[MOTOR_ENC][mot])+cc[mot]/48;//mot_encoder_w[mot];

   //mot_encoder_w[mot]++;//mot_encoder_w_last[mot])
////    mot_err_i[mot]=(encoder[mot][ENC])-cc/8;//mot_encoder_w[mot];
//    else ;//mot_err_i[mot]=encoder[mot][ENC]-mot_encoder_w_last[mot];
    prop=(servo_prop_const*(mot_err_i[mot]))/256;                                  //hiba
    
    diff=(servo_diff_const*(encoder_last[MOTOR_ENC][mot]-encoder[MOTOR_ENC][mot]))/16;
//    encoder_last2[mot][ENC]=encoder_last1[mot][ENC];
//    encoder_last1[mot][ENC]=encoder_last[mot][ENC];
    encoder_last[MOTOR_ENC][mot]=encoder[MOTOR_ENC][mot];
    
    if (diff>DIFF_LIMIT)diff=DIFF_LIMIT;
    if (diff<-DIFF_LIMIT)diff=-DIFF_LIMIT;
    
    
    
    integ[mot]=((integ[mot]+mot_err_i[mot]));
    
    if (integ[mot]>INTEG_LIMIT)integ[mot]=INTEG_LIMIT;
    if (integ[mot]<-INTEG_LIMIT)integ[mot]=-INTEG_LIMIT;
    
    integr=(servo_integ_const*integ[mot])/1024;
    
    corr=prop-diff+integr;
    

               
 //   mot_speed_a[mot]=abs(corr);
 //   if (corr>0)mot_dir_a[mot]=0;else mot_dir_a[mot]=1;
    
    
	
		
  //  if (abs(mot_servo_speed[mot])>40)mot_preci[mot]++;	
	//corr=corr/mot_preci[mot];
	//if (mot_servo_speed[mot]>8000)corr=corr-1;
		
	if (corr>SPLIM)corr=SPLIM;   //mert kiakad a timer setting
	if (corr<-SPLIM)corr=-SPLIM;
//	if (corr!=last_corr[mot])
	{
		
	
		    current_set(mot, corr);
		    last_corr[mot]=corr;		    
			mot_err_p[mot]=prop;
			mot_err_d[mot]=diff;
			mot_err_in[mot]=integr;
	}
	
	 	
	
active=0;	
}

	
	
	
	
	
	
	
}




/*

signed long encoder_last[2][2]={
								{ 0,0 },
								{ 0,0 }							
							};



void measure_servo_speed(void){
	static signed long encoder[2][2]={
									{ 0,0 },
									{ 0,0 }							
								};
	
	get_encoders(&encoder[0][0],&encoder[0][1],&encoder[1][0],&encoder[1][1]);
	mot_servo_speed[RA]=5*(encoder[RA][ENC]-encoder_last[RA][ENC]);	
	mot_servo_speed[DEC]=5*(encoder[DEC][ENC]-encoder_last[DEC][ENC]);	
	
	encoder_last[RA][ENC]=encoder[RA][ENC];	
	encoder_last[DEC][ENC]=encoder[DEC][ENC];
	
	
}


*/


//*************************************************************************************
//
// Szervo md temezsek
//
//*************************************************************************************

void servo_tick(void){
	
	
static char active;	
/*static signed long encoder[2][2]={
								{ 0,0 },
								{ 0,0 }							
							};
*/
if (get_motortype()==SERVO_MODE){
	
if (!initialized)return;		

if (!active){
active=1;
 //get_encoders(&encoder[0][0],&encoder[0][1],&encoder[1][0],&encoder[1][1]);
	
 
 //if (encoder_b[RA][1]!=encoder[RA][1])
//LEDON
	 sync_servo_mot(RA);
	 sync_servo_mot(DEC);
//LEDOFF
// if (encoder_b[DEC][1]!=encoder[DEC][1])sync_servo_mot(DEC); 
/*		
 encoder_b[RA][0]=encoder[RA][0];
 encoder_b[RA][1]=encoder[RA][1];
 encoder_b[DEC][0]=encoder[DEC][0];
 encoder_b[DEC][1]=encoder[DEC][1];
*/ 
 active=0;
}	
}
}

#endif          //servo mode








#ifdef  ALT_AZ_MODE_ENABLED
//--------------------------------------------------------------------------------------------------------------
// ALTAZ mountnl a virtulis motorokat timereit inicializlja
//-----------------------------------------------------------------------------------------------------------------

unsigned int calc_timer_ALTAZ(unsigned char m,unsigned int d){
	
unsigned int t=0;	
unsigned char cc;
	
if (d>0){
//	t=360/d;
	
		
		
	
		
		
		for (cc=1;cc<10;cc++){
			t=1;
			t=(360*mot_st[m])/d;
			
			if ((t<15)&&(mot_st[m]<128))mot_st[m]=mot_st[m]*2;
			if ((t>60)&&(mot_st[m]>1))mot_st[m]=mot_st[m]/2;
			if ((t>5) &&(t<3000))break;
			
		}
		
if (t<1)t=1;		
		
		
	
	
}
else t=0;


return t;	
}



//*******************************************************************************
//	ALTAZ mountnl a virtulis motorokat kpezzk le ALT_AZ ban
//  todo PID 
//
//
//*******************************************************************************

float r_motor_az=2;



#define ALTAZ_INTEG_LIMIT 6000
#define ALTAZ_DIFF_LIMIT 60


void sync_mot_ALT_AZ(unsigned char mot){
	
	
//unsigned char i;
unsigned char dir=0;
float r_motor=0;
unsigned int st=0;
//unsigned int tt=0;
signed long stc;
float scope_pos=0;
signed int err=0;

unsigned int err_i=0;
signed int corr=0;
//static char busy=0;

//static int suro[4]={0,0,0,0};
//static int suro1[4]={0,0,0,0};


static signed int integ[4]={0,0,0,0};
static signed int err_last[4]={0,0,0,0};

//static signed int last_corr[4]={0,0,0,0};

signed int prop=0;
signed int diff=0 ;
signed int integr=0 ;



//return;

//if (busy)return;


if (!initialized)return;	
if (!ALTAZ_can_start)return;



//busy=1;


st=step[mot];
stc=stepcount[mot];

//printf("st:%d,stc:%d",st,stc);

if (mot==AZ){
	
//	int azdeg ;
//	unsigned int azdegres ;
	
	r_motor=step_to_rad(RA,stc,st);			//itt az ttteleket az RA/DEC motorokrl veszi
	scope_pos=scope_AZ;
	
	 
	 
	if  (last_AZ-scope_AZ<-M_PI)corr_AZ_pos--; 
	if  (last_AZ-scope_AZ>M_PI)corr_AZ_pos++;
	last_AZ=scope_AZ;
	//if (corr_AZ_pos<0)
	scope_pos=scope_pos+M2_PI*corr_AZ_pos;  //a 1-360 vlts problma megoldsa

	
//	rad_to_degfloat(scope_ALT,&altdeg,&altdegres);
//	rad_to_degfloat(r_motor,&azdeg,&azdegres);
//	printf("CA:%d,AZ:%d,%d\n\r",corr_AZ_pos,azdeg,azdegres);
	
	
}
if (mot==ALT){
	r_motor=step_to_rad(DEC,stc,st);
	scope_pos=scope_ALT; 
}



/*
for (i=1;i<5;i++){
 if (r_motor>M2_PI)r_motor=r_motor-M2_PI; else break;
 
}

for (i=1;i<5;i++){
 if (r_motor<0)r_motor=r_motor+M2_PI; else break;
 
}

*/
	err=(r_motor-scope_pos)*100000.;
	
	
	prop=(ALTAZ_prop_const*err);                                  //hiba
	    
	diff=(ALTAZ_diff_const*(err_last[mot]-err));
	err_last[mot]=err;
	
	if (diff>ALTAZ_DIFF_LIMIT)diff=ALTAZ_DIFF_LIMIT;
	if (diff<-ALTAZ_DIFF_LIMIT)diff=-ALTAZ_DIFF_LIMIT;
	
	
	integ[mot]=((integ[mot]+err));
	    
	if (integ[mot]>ALTAZ_INTEG_LIMIT)integ[mot]=ALTAZ_INTEG_LIMIT;
	if (integ[mot]<-ALTAZ_INTEG_LIMIT)integ[mot]=-ALTAZ_INTEG_LIMIT;
	    
	integr=(ALTAZ_integ_const*integ[mot])/1024;
   
	corr=prop-diff+integr;  
	
	
//-------------------------------------------	
	

	
	
	if (corr<0){err_i=-corr;dir=1;} else {err_i=corr;dir=0;};
	mot_dir[mot]=dir;
//	if (err_i>100000) return;
	if (err_i>userpar[mot-2].gotospeed)err_i=userpar[mot-2].gotospeed;
	
	
	if (mot==AZ){
	set_sin_timer_e(RA,err_i,1);
	}
	if (mot==ALT){
	set_sin_timer_e(DEC,err_i,1);	
	}
	
	
	
	
	

	
//	printf("s-%d,a-%d,p-%d,P=%d,I=%d,D=%d\n\r",err_i,tt,mot_st[AZ],prop,integr,diff);
	



	
	

}

//*************************************************************************************
//
// ALT_AZ md temezsek
//
//*************************************************************************************




void tick_AZ(void){
	if (!initialized)return;
	if (misc.mounttype == ALTAZ){
	step_timer(RA);
		
	}
}

void tick_ALT(void){
	if (!initialized)return;
	if (misc.mounttype == ALTAZ){
	step_timer(DEC);
	
	}
	
	
}
#else



void sync_mot_ALT_AZ(unsigned char mot){}


void tick_AZ(void){}

void tick_ALT(void){}

#endif

//*************************************************************************************
//szinkronizlja a stepper motort az alapjelhez 
//egyik oldalon a motor pozicioja radinban (mot_rot)
//a msikon amit szeretnnk:
//korrekciok:offset1
//			 refrakcio
//			 pec
//			 backlash
//s az        offset ami a usertl jn (csak ennek kell ltszani a kijelzn)
//**************************************************************************************



#ifndef PID_SYNC

#define ACCMUL 1

void sync_mot(unsigned char mot)

{
static float s;
unsigned int ms;
int vv;
long tx;
long corr1;
long corr,corra;
static float r_motor;
static float rate_t;
static float temp;
int spr;
//char i;
long stc;

static unsigned int st;
static char mot_s[2];
static char s_m_busy;

//static int cc[2]={0,0};

signed int diff ;
signed int integr ;


unsigned int azdeg ;
unsigned int azdegres ;


//sync_mot_flag=1;
//if (s_m_busy)return;
s_m_busy=1;
//mot_offset[RA]=0;
//***************************************************************************
//
// Kiszmolja a hiba mrtkt s eljelt
//
//
//***************************************************************************

rate_t=0;

rate_t=get_mot_rate(mot);

/*
if (mot==0){
 rad_to_degfloat(r_motor_az,&azdeg,&azdegres);
 printf("az-: %d,%d\n\r",azdeg,azdegres);	
}
*/

if (get_motortype() == STEPPER_MODE){

stc=stepcount[mot];
//while (stc!=stepcount[mot])
//  stc=stepcount[mot];
  
 
st=step[mot] ;
while (st!=step[mot])
  st=step[mot];
  
while (stc!=stepcount[mot])
  stc=stepcount[mot];  
 

//r_motor=step_to_rad(mot,stepcount[mot],step[mot]&(ustep_per_step-1));
//ez valamirt nagy szivs hogy 4-el kell szorozni...todo
r_motor=step_to_rad(mot,stc,st);//&(ustep_per_step-1));

//if (r_motor!=step_to_rad(mot,stc,st&(ustep_per_step-1)))
//  i=2;
}
else if (initialized){						//servo mode
/*
	signed long encoder[2][2]={
								{ 0,0 },
								{ 0,0 }							
							};
*/
	get_encoders(&encoder[MOUNT_ENC][RA],&encoder[MOUNT_ENC][DEC],&encoder[MOTOR_ENC][RA],&encoder[MOTOR_ENC][DEC]);
	r_motor=encoder_to_rad(mot,MOTOR_ENC,encoder[MOTOR_ENC][mot]);
//	calc_encoder_wanted(); 2013.05.09
	
	
}
	
   

   
   
mot_rot[mot]=r_motor;                                                         // mot_rot - a motor pozicija az indulshoz kpest


//if (mot&&NODECPEC)temp=+mot_offset1[mot];									  //+mot_offset_pec[mot]);///teszt

// else  
 temp=+mot_offset1[mot]+(mot_offset_refr[mot]+mot_backlash[mot]);//+mot_offset_pec[mot]);

off_pec[mot]=(rate_t-r_motor)-temp;

if (mot&&NODECPEC)
;
else
{  
  if (userpar[mot].PEC_corr!=0)
    temp=temp+mot_offset_pec[mot]; 											//ha be van kapcsolva a PEC
	else temp=temp+mot_last_offset_pec[mot];
//  if (mot_offset_pec[mot]>0.0012)
//	  printf("pec-error");
}

//if (mot_speed[RA]>40)
//	printf("speed-error");

mot_pos[mot]=rate_t-r_motor-temp;								//mot_pos a kijelzett

if (sid_midnight()&&(userpar[mot].rate_sel==SID)){
	mot_offset[mot]-=M2_PI;sid_midnight_corr(0);
	}//sid jflkor ne tekerjen

//if ((no_sync[mot])||lx200_busy||no_synctest){
if ((no_sync[mot])||lx200_busy){
/*	
	if (mot){
	 extern	 float mot_start[2];
	 extern volatile char startbacklash; 
	 float temp; 	 
	 
	 temp=mot_start[mot]-mot_rot[mot];
	 if (temp<0)temp=-temp;
	 
	    if (temp>=userpar[mot].backlash){
	    	startbacklash=0;	    
	    	no_sync[DEC]=0;
	    }
	 }
	
*/	
	s_m_busy=0;
	return;
	}
//printf("sync");
/*if ((tpb==1)&&(mot_pos[1]!=tfx))
   beep();
   
if ((tpb1==1)&&(mot_pos[1]!=tfx1))
   beep();   
*/




																			   // "s"  a hiba 
s=(r_motor-rate_t+mot_offset[mot]+rate_offset[mot]+temp);                      //-SidT;			ha s=0 akkor szinkronban van!										   //ez a hiba amit ki kell szablyozni
 																																																						
 if (s>0.00005)
mot_err[mot]=s; 
else mot_err[mot]=s;

 
 
//corr=100000*s;
corr=20000*s;							//ha tl nagy akkor kis red*motres rtkeknl gerjed

if (mot_speed_a[mot]>100){
if (mot_speed_a[mot]<8000)ms=mot_speed_a[mot];else ms=8000;  //ez a lassuls elnyujtsra van
corra=(((1+(8000-(ms/4)))*stepper_prop_const)*s);   										//
///
}else 	corra=(8000*stepper_prop_const)*s;  
	
	
//corr=2000*s;
    


stepper_integ[mot]+=corra;

if (stepper_integ[mot]>INTEG_LIMIT_STEPPER)stepper_integ[mot]=INTEG_LIMIT_STEPPER;
if (stepper_integ[mot]<-INTEG_LIMIT_STEPPER)stepper_integ[mot]=-INTEG_LIMIT_STEPPER;
    
integr=(stepper_integ_const*stepper_integ[mot])*0.001;

//if (mot)printf("integr=%d",integr);

//diff=stepper_diff_const*((last_mot_rot[mot]-mot_rot[mot])*mul1[mot]);
if (!mot_dir[mot])diff=(stepper_diff_const*mot_speed[mot])/100;else diff=-((stepper_diff_const*mot_speed[mot])/100);
//last_mot_rot[mot]=mot_rot[mot];
corr=(signed long)((corra)-diff+integr);
///
  



if (corr>0x7fff)corr=0x7fff;   //mert klnben vv hamis lesz!	
if (corr<-0x7fff)corr=-0x7fff;															   
//corr1=100000000*s;
//if (corr1<0)corr1=-corr1;
//corr=corr;
//if (!mot)printf("_p=%d,d=%d,i=%d\r\n",(signed int)corra,(signed int)diff,(signed int)integr);

//if (corr>30000L)corr=30000L; 
//if (corr<-30000L)corr=-30000L;


if (corr<0)vv=-corr;else vv=corr;
//vv1=corr;
if (vv>20000L)vv=20000L;  
if (vv>userpar[mot].gotospeed)vv=userpar[mot].gotospeed;
//if (mot)printf("speed=%d,%d",mot_speed_a[DEC],mot_speeed[DEC]);

//if (vv<100) vv=vv/2;
//********************************************************************************************************
// Irny vizsglat , j fele forog a hiba irnyhoz kpest?
// Ha nem , belltja a kivnt irnyt (mot_dir_a)
//********************************************************************************************************

if (userpar[mot].rate_sel==STOP)			//ha nics kvets, DEC

{
 spr=0;
if (corr<spr)							   //ha DEC teht 0 a hiba tengelye
 {
  if (!mot_dir_ch[mot])                //nincs irnyvlts folyamatban
   { 
     //if (!mot_dir_a[mot])mot_backlash[mot]-=userpar[mot].backlash;
	 if (!mot_dir_a[mot])
     mot_dir_a[mot]=1;
	 
   }
  }
  else if (corr>spr)
  { 
   
   if (!mot_dir_ch[mot])
    {
	 //if (mot_dir_a[mot])mot_backlash[mot]+=userpar[mot].backlash;
	 if (mot_dir_a[mot])
	 mot_dir_a[mot]=0;
	
	} 
  }
}   

//ez a RECTA motor folyamatos kvets
 
else {
spr=10;//mot_speed[mot];
 if (mot_dir[mot]==0)spr=0; 
  
 
if (corr<spr)							   //ha megy akkor -10 az irnyvlts
 {
  if (!mot_dir_ch[mot])mot_dir_a[mot]=1;
  
  }
  else if (corr>spr)
  { 
   
   if (!mot_dir_ch[mot])mot_dir_a[mot]=0;
  }
} 



 
if (mot_speed[mot]<10)
 { 
  if (mot_dir!=mot_dir_a)
  {
   
  // mot_dir[mot]=mot_dir_a[mot]; //lassunl rgtn vlt irnyt de a backlash megzavarodik! errt kivettem 2003.05.02.
 /*  if (!mot_dir[mot])
			   {
			     mot_backlash[mot]-=userpar[mot].backlash;
			   }
			    else 
			   {
			   
			     mot_backlash[mot]+=userpar[mot].backlash;
			   }*/
  }   
 }
  


/**************************************************************************
 * 
 * Meghatrozza a hibhoz tartoz kvnt sebessget "mot_speed_a" 
 * Ha DEC - akkor nincs gond minnl nagyobb a hiba annl nagyobb a sebessg
 * Ha REC akkor a kvets miatt vigyzni kell mi van az irny vltssal
 * 
 * 
 *************************************************************************/

//if (!vv)vv=1;   		 	//ha 0 a hiba akkor 1 a sebessg														      		 															      		 															   

 
/*
if (mot==RA){
	
	printf("c=%d v=%d s_a=%d",corr,vv,mot_speed_a[RA]);
	
}
*/


if (!mot_dir_ch[mot]) 	{		   								//irnyvlts folyamatban!!! nem szabad vltoztatni
	
	
   if (userpar[mot].rate_sel==STOP)								//Nics kvets
   {   
	   
	   mot_speed_a[mot]=vv/ACCMUL;		   								//minnl nagyobb a hiba annl gyorsabb
	   
      // if (vv<5)mot_speed_a[mot]=1;
    } 
   
   else															//kvets van '10*' es sebessggel
    { 
	 if (mot_dir[mot]==1)                                       //ha elre forog 1
	 {
	  if ((vv>=1)&&(corr<=0)) //(vv>=10)		                //ez az RA motor
   		mot_speed_a[mot]=10+vv/ACCMUL;                       
		else
		if ((vv<=10)&&(corr>=0))
		  mot_speed_a[mot]=11-vv/ACCMUL;                               //10 volt todo
		else  
		 if ((vv>10)&&(corr>=0)) mot_speed_a[mot]=vv-10/2;
	 }	   
	 else  			//htra forog
	  { 
		   mot_speed_a[mot]=vv/ACCMUL;
	  }
		
	 //mot_speed_a[mot]=10;;;;	
		
    }		
   }//else 
   //if ((mot_speed_b[mot]>vv))     //lassuls kzben idert
    // {mot_speed_b[mot]=vv;}

/*
//if (!mot)teszti=corr;
if (mot==RA)
{
if (mot_speed_a[RA]<6)
 i=1;

if (mot_speed_a[RA]>14)
 i=1;
} 
*/
moterr[mot]=vv;

//if (moterr[0]>30)
  //beep(); 

/****************************************************************************************************
 * 
 * Specilis eset, mikor mr minimlis a hiba
 * DEC -  nl ha mr gyakorlatilag nincs hiba akkor lelltja a motort
 * RECTA -nl
 * 
 * 
 ****************************************************************************************************/
if ((vv<50)&&!mot_dir_ch[mot])mot_arrive_speed[mot]=1;

if(vv<1)  								//mr majdnem j helyen vagyunk
 {
 
 //  corr1=100000000*s; 
 //  corr1=20000000*s; //ha tl nagy akkor kis red*motres rtkeknl gerjed
	last_s_error=s;
 //  	corr1=80000000*s;	
   	corr1=corr;
 //  	corr1=corr*1000;						//itt 1000*es szorz a pontossg miatt;
 moterr1[mot]=(int)corr1;						//
// mot_arrive[mot]=1;						//megjott
 
 
 if (userpar[mot].rate_sel==STOP){		//DEC- le lehet llni ha elg kicsi a hiba
 //beep();
  	if ((corr1<150)&&(corr1>-150))	  		//+-250
	{
//  		printf("leall=%d\n\r",corr1);
	 mot_speed_a[mot]=0;
	 //mot_stopped[DEC]=2;
	// if (sync_mot_flag)
	  mot_arrive[mot]=1;	
//	  printf("meee");
	  	
  	  set_sin_timer(mot,0,1);	  			//ha llunk s megrkeztnk
	 mot_dir_ch[mot]=0;
	//beep();
	 
	} 
  }
  else{										//RECTA - kvetsi sebessget kell finoman korriglni, a hiba fggvnyben
     tx=(track_timer_base[mot]&0x0000ffff); 
	
  	 tx=tx+corr1;  	  		//finombellts alpseb esetn
 // 	if (!mot)teszti=corr1;
    
 	 if (tx<TIMER_MIN)tx=TIMER_MIN;
	 if (tx>TIMER_MAX)tx=TIMER_MAX;  
//	 printf("corr1=%d,tx=%d,speed=%d\n\r",(int)corr1,(int)tx,mot_speed_a[mot]);
     track_timer[mot]=tx;			 //csak bizonyos hatrok kztt!!
	
	 //mot_speed_a[mot]=10;  
	// if (sync_mot_flag)
 //    set_sin_timer(mot,10,1);			  //egyes sebessg s irny  
    	
       set_sin_timer(mot,mot_speed_a[mot],mot_dir[mot]);  //ez itt sokat javtott a pec-en
	 if (mot_s[mot])
	 {
	  mot_dir_a[mot]=1;
	  mot_speed_a[mot]=10;
	  mot_dir_ch[mot]=0;
	  mot_s[mot]=0;
	  mot_arrive[mot]=1;	
	  enable_encoder_IT(1);                      //ha most lassult le kvetsre akkor engedi az RA encode IT-t

     }
  }
  
 }else {

     if (mot_s[mot]==0){
    	 enable_encoder_IT(0);                   //ha most gyorsult fel kvetsrl akkor tiltja az RA encode IT-t

     }
	 mot_s[mot]=1;//hogy a lessitskor egyszer legalbb aktualizlja a speed_at
 }

s_m_busy=0;

}


#else

/*************************************************************************************
//szinkronizlja a stepper motort az alapjelhez
//egyik oldalon a motor pozicioja radinban (mot_rot)
//a msikon amit szeretnnk:
//korrekciok:offset1
//			 refrakcio
//			 pec
//			 backlash
//s az        offset ami a usertl jn (csak ennek kell ltszani a kijelzn)
**************************************************************************************/

#define ACCMUL 1

//#define INTEG_LIMIT_STEPPER 3000


void sync_mot(unsigned char mot)

{
static float s;
unsigned int ms;
int vv;
long tx;
long corr1;
long corr,corra;
static float r_motor;
static float rate_t;
static float temp;
int spr;
//char i;
long stc;

static unsigned int st;
static char mot_s[2];
static char s_m_busy;

//static int cc[2]={0,0};

signed int diff ;
signed int integr ;


//unsigned int azdeg ;
//unsigned int azdegres ;




s_m_busy=1;

//***************************************************************************
//
// Kiszmolja a hiba mrtkt s eljelt
//
//
//***************************************************************************

rate_t=0;

rate_t=get_mot_rate(mot);



if (get_motortype() == STEPPER_MODE){                                  //stepper mode

stc=stepcount[mot];
st=step[mot] ;

while (st!=step[mot])                              					   //ellenrzi nem volt-e 2 bytos olvassi hiba
  st=step[mot];

while (stc!=stepcount[mot])
  stc=stepcount[mot];


//r_motor=step_to_rad(mot,stepcount[mot],step[mot]&(ustep_per_step-1));
//ez valamirt nagy szivs hogy 4-el kell szorozni...todo
r_motor=step_to_rad(mot,stc,st);//&(ustep_per_step-1));

//if (r_motor!=step_to_rad(mot,stc,st&(ustep_per_step-1)))
//  i=2;
}
else if (initialized){						                            //servo mode

	signed long encoder[2][2]={
								{ 0,0 },
								{ 0,0 }
							};


	get_encoders(&encoder[MOUNT_ENC][RA],&encoder[MOUNT_ENC][DEC],&encoder[MOTOR_ENC][RA],&encoder[MOTOR_ENC][DEC]);
	r_motor=encoder_to_rad(mot,MOTOR_ENC,encoder[MOTOR_ENC][mot]);
//	calc_encoder_wanted(); 2013.05.09


}





mot_rot[mot]=r_motor;                                                         // mot_rot - a motor pozicija az indulshoz kpest


//if (mot&&NODECPEC)temp=+mot_offset1[mot];									  //+mot_offset_pec[mot]);///teszt

// else
 temp=+mot_offset1[mot]+(mot_offset_refr[mot]+mot_backlash[mot]);			  //+mot_offset_pec[mot]);

off_pec[mot]=(rate_t-r_motor)-temp;

if (mot&&NODECPEC)
;
else
{
  if (userpar[mot].PEC_corr!=0)
    temp=temp+mot_offset_pec[mot]; 											//ha be van kapcsolva a PEC
	else temp=temp+mot_last_offset_pec[mot];

}


mot_pos[mot]=rate_t-r_motor-temp;								//mot_pos a kijelzett

if (sid_midnight()&&(userpar[mot].rate_sel==SID)){
	mot_offset[mot]-=M2_PI;sid_midnight_corr(0);
	}															//sid jflkor ne tekerjen
#ifdef NOSYNCTEST
if ((no_sync[mot])||lx200_busy||no_synctest){
#else

if ((no_sync[mot])||lx200_busy){

#endif

	s_m_busy=0;
	return;
	}

																			   // "s"  a hiba
s=(r_motor-rate_t+mot_offset[mot]+rate_offset[mot]+temp);                      //-SidT;			ha s=0 akkor szinkronban van!										   //ez a hiba amit ki kell szablyozni


mot_err[mot]=s;

//corr=100000*s;
corr=20000*s;							                     //ha tl nagy akkor kis red*motres rtkeknl gerjed

if (mot_speed_a[mot]>100){
if (mot_speed_a[mot]<8000)ms=mot_speed_a[mot];else ms=8000;  //ez a lassuls elnyujtsra van
corra=(((1+(8000-(ms/4)))*stepper_prop_const)*s);            //todo !!!!
}else 	corra=(8000*stepper_prop_const)*s;






stepper_integ[mot]+=corra;

if (stepper_integ[mot]>INTEG_LIMIT_STEPPER)stepper_integ[mot]=INTEG_LIMIT_STEPPER;
if (stepper_integ[mot]<-INTEG_LIMIT_STEPPER)stepper_integ[mot]=-INTEG_LIMIT_STEPPER;

integr=(stepper_integ_const*stepper_integ[mot])*0.0001;

//if (mot)printf("integr=%d",integr);

diff=stepper_diff_const*((last_mot_rot[mot]-mot_rot[mot])*5000.);//mul1[mot]);
//if (mot_dir[mot])diff=(stepper_diff_const*mot_speed[mot])/100;else diff=(stepper_diff_const*-(signed int)mot_speed[mot])/100;

//diff=(stepper_diff_const*-(signed int)mot_speed[mot])/100;
//if (mot)printf("diff=%d,",diff);
last_mot_rot[mot]=mot_rot[mot];
corr=(signed long)((corra)-diff+integr);
///




if (corr>0x7fff)corr=0x7fff;   //mert klnben vv hamis lesz!
if (corr<-0x7fff)corr=-0x7fff;

//if (!mot)printf("_p=%d,d=%d,i=%d\r\n",(signed int)corra,(signed int)diff,(signed int)integr);

if (corr<0)vv=-corr;else vv=corr;
//vv1=corr;
if (vv>20000L)vv=20000L;
if (vv>userpar[mot].gotospeed)vv=userpar[mot].gotospeed;
//ha mr kzeleg a cl nem kell gyorsan menni
// a max seb legyen arnyos a cltl val tvolsggal ???

{
unsigned long vss;
signed long sss;
//extern float mot_go[2];
//unsigned char lassit=1;
//static float last_sss[]={0,0};
//&&((mot_speed[mot])<last_sss[mot])

//vss=1000;

  sss=35*stepper_prop_const*s;
  if (sss<0) sss=-sss;							//mot_go=0 -> goto
  if (sss>900L)sss=900L;                                                                  //sss a hiba abszolut rtke

  vss=(unsigned long)((userpar[mot].gotospeed*(userpar[mot].ramp+1))*sss)/1000L;
  vss=vss+400;
 // &&(vv>10)&&(mot_speeed[mot]>25)
  if ((vv>vss)){
//	  printf ("vv:%d,vss:%d-",vv,vss);
	  vv=vss;
  }

/*
  if ((sss<userpar[mot].gotospeed*4)&&(sss>vss)&&(mot_go[mot]==0)){
//  if ((sss<userpar[mot].gotospeed*4)&&(sss>vss)&&(mot_go[mot]==0)){
	  vv=vss;
//	  printf("-f-");
  }//else if (mot)printf ("n");


*/
//  if mot_speed[mot])<last_sss[mot]
//  last_sss[mot]=mot_offset[mot];
}
		//(mot_speeed[mot]>userpar[mot].gotospeed/2)&& (vv)

//********************************************************************************************************
// Irny vizsglat , j fele forog a hiba irnyhoz kpest?
// Ha nem , belltja a kivnt irnyt (mot_dir_a)
//********************************************************************************************************

if (userpar[mot].rate_sel==STOP)			//ha nics kvets, DEC

{
 spr=0;
if (corr<spr)							   //ha DEC teht 0 a hiba tengelye
 {
  if (!mot_dir_ch[mot])                //nincs irnyvlts folyamatban
   {
     //if (!mot_dir_a[mot])mot_backlash[mot]-=userpar[mot].backlash;
	 if (!mot_dir_a[mot])
     mot_dir_a[mot]=1;

   }
  }
  else if (corr>spr)
  {

   if (!mot_dir_ch[mot])
    {
	 //if (mot_dir_a[mot])mot_backlash[mot]+=userpar[mot].backlash;
	 if (mot_dir_a[mot])
	 mot_dir_a[mot]=0;

	}
  }
}

//ez a RECTA motor folyamatos kvets------------------------------------------------------------

else {
spr=10;//mot_speed[mot];
 if (mot_dir[mot]==0)spr=0;


if (corr<spr)							   //ha megy akkor -10 az irnyvlts
 {
  if (!mot_dir_ch[mot])mot_dir_a[mot]=1;

  }
  else if (corr>spr)
  {

   if (!mot_dir_ch[mot])mot_dir_a[mot]=0;
  }
}






/**************************************************************************
 *
 * Meghatrozza a hibhoz tartoz kvnt sebessget "mot_speed_a"
 * Ha DEC - akkor nincs gond minnl nagyobb a hiba annl nagyobb a sebessg
 * Ha RA  - akkor a kvets miatt vigyzni kell mi van az irny vltssal
 *
 *
 *************************************************************************/

//if (!vv)vv=1;   		 	//ha 0 a hiba akkor 1 a sebessg


/*
if (mot==RA){

	printf("c=%d v=%d s_a=%d",corr,vv,mot_speed_a[RA]);

}
*/


if (!mot_dir_ch[mot]) 	{		   								//irnyvlts folyamatban!!! nem szabad vltoztatni


   if (userpar[mot].rate_sel==STOP)								//Nics kvets
   {

	   mot_speed_a[mot]=vv/ACCMUL;		   								//minnl nagyobb a hiba annl gyorsabb

      // if (vv<5)mot_speed_a[mot]=1;
    }

   else															//kvets van '10*' es sebessggel
    {//
	static unsigned int ccnt=0;
//	if (ccnt>0){
	unsigned int msp=0;
//	static unsigned int last_mspeed[]={10,10};
	ccnt=0;
	 if (mot_dir[mot]==1)                                       //ha elre forog 1
	 {
	  if ((vv>=1)&&(corr<=0)) //(vv>=10)		                //ez az RA motor
   		msp=10+vv/ACCMUL;
		else
		if ((vv<=10)&&(corr>=0))
		  msp=11-vv/ACCMUL;                               //10 volt todo
		else
		 if ((vv>10)&&(corr>=0)) msp=vv-10/2;
	 }
	 else  			//htra forog
	  {
		   msp=vv/ACCMUL;
	  }
    // msp=10;
     mot_speed_a[mot]=msp;//(msp+last_mspeed[mot])/2;
//     if (!mot)printf ("sp:%d",mot_speed_a[mot]);
//     last_mspeed[mot]=msp;
	 //mot_speed_a[mot]=10;;;;

//    }else ccnt++;
    }

   }//else
   //if ((mot_speed_b[mot]>vv))     //lassuls kzben idert
    // {mot_speed_b[mot]=vv;}

/*
//if (!mot)teszti=corr;
if (mot==RA)
{
if (mot_speed_a[RA]<6)
 i=1;

if (mot_speed_a[RA]>14)
 i=1;
}
*/
moterr[mot]=vv;

//if (moterr[0]>30)
  //beep();

/****************************************************************************************************
 *
 * Specilis eset, mikor mr minimlis a hiba
 * DEC -  nl ha mr gyakorlatilag nincs hiba akkor lelltja a motort
 * RECTA -nl
 *
 *
 ****************************************************************************************************/
if ((vv<50)&&!mot_dir_ch[mot])mot_arrive_speed[mot]=1;

if(vv<1)  								//mr majdnem j helyen vagyunk
 {

  if (  lassul[mot])lassul[mot]--;
	last_s_error=s;

   	corr1=corr;

    moterr1[mot]=(int)corr1;						//



 if (userpar[mot].rate_sel==STOP){		//DEC- le lehet llni ha elg kicsi a hiba

  	if ((corr1<150)&&(corr1>-150))	  		//+-250
	{
//  		printf("leall=%d\n\r",corr1);
	 mot_speed_a[mot]=0;
	 mot_arrive[mot]=1;
     set_sin_timer(mot,0,1);	  			//ha llunk s megrkeztnk
	 mot_dir_ch[mot]=0;

	}
  }
  else{										//RECTA - kvetsi sebessget kell finoman korriglni, a hiba fggvnyben
     tx=(track_timer_base[mot]&0x0000ffff);

  	 tx=tx+corr1;  	  						//finombellts alpseb esetn
 // 	if (!mot)teszti=corr1;

 	 if (tx<TIMER_MIN)tx=TIMER_MIN;
	 if (tx>TIMER_MAX)tx=TIMER_MAX;
//	 printf("corr1=%d,tx=%d,speed=%d\n\r",(int)corr1,(int)tx,mot_speed_a[mot]);
     track_timer[mot]=tx;			 		//csak bizonyos hatrok kztt!!

	 //mot_speed_a[mot]=10;
	// if (sync_mot_flag)
 //    set_sin_timer(mot,10,1);			  	//egyes sebessg s irny

       set_sin_timer(mot,mot_speed_a[mot],mot_dir[mot]);  //ez itt sokat javtott a pec-en

	 if (mot_s[mot])
	 {
		 mot_dir_a[mot]=1;
		 mot_speed_a[mot]=10;
		 mot_dir_ch[mot]=0;
		 mot_s[mot]=0;
		 mot_arrive[mot]=1;
		 if (mot==0)enable_encoder_IT(1);    //ha most gyorsult fel kvetsrl akkor tiltja az RA encode IT-t

     }
  }

 }else {

//     if ((mot_s[mot]==0)&&((mot_speed_a[mot]<5)||(mot_speed_a[mot]>15))){
//    	 if (mot==0)enable_encoder_IT(0);    //ha most gyorsult fel kvetsrl akkor tiltja az RA encode IT-t
//
//     }
	 mot_s[mot]=1;							//hogy a lessitskor egyszer legalbb aktualizlja a speed_at
 }
if ((mot_speed[mot]<0)||(mot_speed[mot]>20))if (mot==0)enable_encoder_IT(0);
s_m_busy=0;

}



#endif

/*---------------------------------------------------------------------------------------------*/





//**************************************************************************************************
//
// Az irnytl fggen lpteti a ustep rtkt, ha full step volt azt is kezeli
//
// ide jn, ha eljtt a lps ideje
// mot0 2,3 az altaz motorok, ilyenkor a mot0 1,2 csak virtulisan megy
//
//**************************************************************************************************



void step_timer(unsigned char mot0)  

{
//if (step_disable[mot0]) return;

	if (((step[mot0]-POS_MAX/4)<=5)||((step[mot0]-(POS_MAX*3)/4)<=5)){  //lehet ramot mrni ahol a kt tekerscs azonos rm

		if (mot0) peek_curr[mot0]=I_DEC_A+I_DEC_B;
		 else peek_curr[mot0]=I_RA_A+I_RA_B;
        // if (!mot0)printf("++%d\n\r",peek_curr[mot0]);
	}

	if (mot_dir[mot0]){
		
	   if (step[mot0]<(POS_MAX-mot_st[mot0]))step[mot0]=step[mot0]+mot_st[mot0];      //?          
	   else {
		   		step[mot0]=0;
		   		stepcount[mot0]++;
	   }
	   
	   //step[mot0]&=POS_MAX-1;
	  
	  }
	  
	else{
	  
	    if (step[mot0]>=mot_st[mot0])step[mot0]=step[mot0]-mot_st[mot0];    //?
	   else {
		     step[mot0]=POS_MAX-1; //-1
		     stepcount[mot0]--;
	      }
	   }
	    
	   // step[mot0]&=POS_MAX-1;
	  
	  	  
	

/*	
if (mot0){
	
LEDPULS_2;

}
*/	
	
	
}


char Set_Umode_period(unsigned char mot,unsigned int period)

{
	
mot_period[mot]=period;

if (mot==RA){	
				
				PWMC_SetPeriod(2, (2*mot_period[RA]));
				PWMC_SetPeriod(3, (2*mot_period[RA]));	
				while (AT91C_BASE_PWMC->PWMC_CH[2].PWMC_CPRDR != (2*mot_period[RA]));
				while (AT91C_BASE_PWMC->PWMC_CH[3].PWMC_CPRDR != (2*mot_period[RA]));	
			}

if (mot==DEC){
				PWMC_SetPeriod(0, (2*mot_period[DEC]));
		    	PWMC_SetPeriod(1, (2*mot_period[DEC]));	
		    	while (AT91C_BASE_PWMC->PWMC_CH[1].PWMC_CPRDR != (2*mot_period[DEC]));
		    	while (AT91C_BASE_PWMC->PWMC_CH[2].PWMC_CPRDR != (2*mot_period[DEC]));
	
			}
return 0;	
}







void leap_RA (unsigned int step1){
	
	unsigned int duty1 = MIN_DUTY_CYCLE;
	unsigned int duty2 = MIN_DUTY_CYCLE;	
	
	
		    	if (drive_mode[RA]==UMODE){
		    		
		    		
		    		duty2=sintab_u_RA[step1]+mot_period[RA];//MAX_DUTY_CYCLE/2;
		    		duty1=costab_u_RA[step1]+mot_period[RA];//MAX_DUTY_CYCLE/2;
		    		PIO_Set(&Mode_CD_IM);
		    		PIO_Clear(&Mode_CDIR);    //vszlell ellen
		    		PIO_Clear(&Mode_DDIR);
		    	    }
		    		else if (drive_mode[RA]==IMODE) {
		    		
		    		duty1=2*mot_period[RA]-sintab_i_RA[step1];//MAX_DUTY_CYCLE/2;
		            duty2=2*mot_period[RA]-costab_i_RA[step1];//MAX_DUTY_CYCLE/2;	
		            PIO_Clear(&Mode_CD_IM);	
		            if (!(dir_cos[step1]&MDIR_RA))PIO_Set(&Mode_CDIR);   else PIO_Clear(&Mode_CDIR);
		            if (dir_sin[step1]&MDIR_RA)PIO_Set(&Mode_DDIR);   else PIO_Clear(&Mode_DDIR);
		    		} 
		    	
		    		else{									//servo
		    			
		    		}
		    	
		    	if (duty1 > AT91C_BASE_PWMC->PWMC_CH[2].PWMC_CPRDR)duty1=AT91C_BASE_PWMC->PWMC_CH[2].PWMC_CPRDR/2;
		    		PWMC_SetDutyCycle(2, duty1);

		    	if (duty2 > AT91C_BASE_PWMC->PWMC_CH[3].PWMC_CPRDR)duty2=AT91C_BASE_PWMC->PWMC_CH[3].PWMC_CPRDR/2;
		    		PWMC_SetDutyCycle(3, duty2);


		    		
	
	
	
}



void leap_DEC (unsigned int step1){
	
unsigned int duty1 = MIN_DUTY_CYCLE;
unsigned int duty2 = MIN_DUTY_CYCLE;
	
	if (drive_mode[DEC]==UMODE){
		
		duty2=sintab_u_DEC[step1]+mot_period[DEC];//MAX_DUTY_CYCLE/2;
		duty1=costab_u_DEC[step1]+mot_period[DEC];//MAX_DUTY_CYCLE/2;
		PIO_Set(&Mode_AB_IM);
		PIO_Clear(&Mode_ADIR);				//csak hogy ne legyen kikapcsolva a hajts(ha minden kimenet 1 akkor vlszlell
		PIO_Clear(&Mode_BDIR);
	    }
		else if (drive_mode[DEC]==IMODE){
		
		duty1=2*mot_period[DEC]-sintab_i_DEC[step1];//MAX_DUTY_CYCLE/2;
        duty2=2*mot_period[DEC]-costab_i_DEC[step1];//MAX_DUTY_CYCLE/2;	
        PIO_Clear(&Mode_AB_IM);
        if (!(dir_cos[step1]&MDIR_DEC))PIO_Set(&Mode_ADIR);   else PIO_Clear(&Mode_ADIR);
        if (dir_sin[step1]&MDIR_DEC)PIO_Set(&Mode_BDIR);   else PIO_Clear(&Mode_BDIR);
		} 
		else {
			
		}
	if (duty1 > AT91C_BASE_PWMC->PWMC_CH[0].PWMC_CPRDR)duty1=AT91C_BASE_PWMC->PWMC_CH[0].PWMC_CPRDR/2;
		PWMC_SetDutyCycle(0, duty1);
	if (duty2 > AT91C_BASE_PWMC->PWMC_CH[1].PWMC_CPRDR)duty2=AT91C_BASE_PWMC->PWMC_CH[1].PWMC_CPRDR/2;
		PWMC_SetDutyCycle(1, duty2);
	
		
}




//------------------------------------------------------------------------------
/// Interrupt handler for TC2. RA motor
/// 
/// 
//------------------------------------------------------------------------------
void ISR_Tc2(void)
{
unsigned int status;
static unsigned int step1  = 0;	  


 // Read TC2 status
 status = AT91C_BASE_TC2->TC_SR;
          
 // RC compare
 if ((status & AT91C_TC_CPCS) == AT91C_TC_CPCS) {
	    
	    	
	
	    	
#ifdef NOSTEP	    	
	    	
		
	  		



	if (get_motortype()== SERVO_MODE){
          
           //stepper_ms1();
  //         printf("*");

	}

		
	
	if (misc.mounttype == ALTAZ){
		//return;
		step_timer(AZ);
		step1=step[AZ];
		
	}
	else						//FORK, GERMAN
	{
		step_timer(RA);
		step1=step[RA];
		}    	
	
	leap_RA(step1);			
	    	

		    	
	
#else
	    	step_timer(RA);	    
#endif
   
	     
	 }  
}







//------------------------------------------------------------------------------
/// Interrupt handler for TC1. DEC motor
/// 
/// 
//------------------------------------------------------------------------------
void ISR_Tc1(void)
{
unsigned int status;
static unsigned int step1  = 0;	

	    // Read TC1 status
	    status = AT91C_BASE_TC1->TC_SR;
          
	    // RC compare
	    if ((status & AT91C_TC_CPCS) == AT91C_TC_CPCS) {
//	       ms_1_event();  // 1 ms
	    	
//step_timer(DEC);	

#ifdef NOSTEP	    	

    		

	    	if (misc.mounttype == ALTAZ){
	    		//return;
	    		step_timer(ALT);
	    		step1=step[ALT];
	    		
	    		
	    	}
	    	else {	    	//FORK, GERMAN


				step_timer(DEC);
		    	step1=step[DEC];
				}
leap_DEC (step1);
	    	
	    	
	    	


	    	
    
#else
step_timer(DEC);	    
#endif
	       
	}	    
}





//******************************************************************************
// RA TImer paramter llits
//
//******************************************************************************

void RA_timer_init_t(unsigned char presc,unsigned int timer,unsigned char jump)
{
static unsigned int timer_b;	
//unsigned int ib;
unsigned int cc;

if (timer_b!=timer){	
//	printf("timer init = %d",timer );	
	cc=MAX_TIMERINIT_WAIT;
		while(AT91C_BASE_TC2->TC_CV>timer-TIMER_MIN/2)
			{
			 cc--;
			
			if (cc==0){
			   //printf("r%u",timer);
			   //LEDON
			   break;
			}
			}
		//LEDON
	//	mot_st[RA]=jump;//gggggggggggggggggggggg
		AT91C_BASE_TC2->TC_RC = timer;  
		AT91C_BASE_TC2->TC_CMR = presc | AT91C_TC_CPCTRG;    	//az eloszt kdja
	timer_b=timer;
	
  }
}



void RA_timer_init(unsigned char presc,unsigned int timer,unsigned char jump)
{
static unsigned int timer_b;	
//unsigned int ib;
unsigned int cc;



if (timer_b!=timer){
//	printf("t:_%d  p:%d st:%d %c%c",timer,presc,mot_st[RA],0x0d,0x0a);
//	AT91C_BASE_TC2->TC_CCR = AT91C_TC_CLKDIS;			//stop timer
//	ib=AT91C_BASE_TC2->TC_IMR;
//	AT91C_BASE_TC2->TC_IDR =0xffff;
	//LEDOFF
//	printf("timer init = %d",timer );
	
	cc=MAX_TIMERINIT_WAIT;
	while(AT91C_BASE_TC2->TC_CV>timer-TIMER_MIN/2)
		{
		 cc--;
		
		if (cc==0){
		   //printf("r%u",timer);
		   //LEDON
		   break;
		}
		}
	//LEDON
//	mot_st[RA]=jump;//gggggggggggggggggggggg
	AT91C_BASE_TC2->TC_RC = timer;  
	AT91C_BASE_TC2->TC_CMR = presc | AT91C_TC_CPCTRG;    	//az eloszt kdja
	timer_b=timer;
}
//	AT91C_BASE_TC2->TC_CCR = AT91C_TC_CLKEN | AT91C_TC_SWTRG;
//	AT91C_BASE_TC2->TC_IER=ib; 		
}


//******************************************************************************
// DEC Timer paramter llits
//
//******************************************************************************

void DEC_timer_init(unsigned char presc,unsigned int timer,unsigned char jump)
{
	
static unsigned int timer_b;
unsigned int cc;
//	AT91C_BASE_TC1->TC_CCR = AT91C_TC_CLKDIS;			//stop timer
	if (timer!=timer_b){
		cc=MAX_TIMERINIT_WAIT;
	while(AT91C_BASE_TC1->TC_CV>timer-TIMER_MIN/2)
	{
			 cc--;
			
			if (cc==0){
			   //printf("d%u",timer);
			  
			   break;
			}
			}
///	mot_st[DEC]=jump;ggggggggggggggg
	AT91C_BASE_TC1->TC_RC  = timer;
	AT91C_BASE_TC1->TC_CMR = presc | AT91C_TC_CPCTRG;
	timer_b=timer;
	}
//	AT91C_BASE_TC1->TC_CCR = AT91C_TC_CLKEN | AT91C_TC_SWTRG;
	
}





//------------------------------------------------------------------------------
/// Configures Timer Counter 0 (TC2) RA motor speed
/// 
//------------------------------------------------------------------------------
void ConfigureTc2(void)
{
//    unsigned int div, tcclks;
//    unsigned int val;
    unsigned int pres;
    unsigned int timer;
    	
    calc_track_timer_e(RA,&pres, &timer);	
    track_presc[RA]=pres;										//ez ksbb is kell
    mot_track_timer[RA]=timer;
    // Enable TC2 peripheral clock
    PMC_EnablePeripheral(AT91C_ID_TC2);

    /// Configure TC for a 10ms (= 100Hz) tick
//    val=TC_FindMckDivisor(10000, BOARD_MCK, &div, &tcclks),
//    TC_Configure(AT91C_BASE_TC2, tcclks | AT91C_TC_CPCTRG);  	//az eloszt kdja
//    AT91C_BASE_TC2->TC_RC = (BOARD_MCK / (2 * div*10000));    //az a szmll
    
    TC_Configure(AT91C_BASE_TC2, pres | AT91C_TC_CPCTRG);  		//az eloszt kdja
    AT91C_BASE_TC2->TC_RC = timer;
    
    // Configure interrupt on RC compare
    AIC_ConfigureIT(AT91C_ID_TC2, AIC_PRIOR_TC2, ISR_Tc2);   				//it vektor
    AT91C_BASE_TC2->TC_IER = AT91C_TC_CPCS;
    AIC_EnableIT(AT91C_ID_TC2);
    //milisec=0;
}

//------------------------------------------------------------------------------
/// Configures Timer Counter 1 (TC1) DEC motor speed
/// 
//------------------------------------------------------------------------------
void ConfigureTc1(void)
{
//    unsigned int div, tcclks;
//    unsigned int val;
    unsigned int pres;
    unsigned int timer;
    	
    
    
    calc_track_timer_e(DEC,&pres, &timer);			//ksbb kivenni!!!!
    track_presc[DEC]=pres;	
    mot_track_timer[DEC]=timer;
    // Enable TC2 peripheral clock
    PMC_EnablePeripheral(AT91C_ID_TC1);

    /// Configure TC for a 10ms (= 100Hz) tick
    //val=TC_FindMckDivisor(16000, BOARD_MCK, &div, &tcclks),
    //TC_Configure(AT91C_BASE_TC2, 2 | AT91C_TC_BCPC_TOGGLE);  	//az eloszt kdja
    //AT91C_BASE_TC1->TC_RC = (BOARD_MCK / (2 * 512*16000));      //az a szmll
    
    TC_Configure(AT91C_BASE_TC1, pres | AT91C_TC_CPCTRG);  		//az eloszt kdja
    AT91C_BASE_TC1->TC_RC = timer;
    
    // Configure interrupt on RC compare
    AIC_ConfigureIT(AT91C_ID_TC1, AIC_PRIOR_TC1, ISR_Tc1);   				//it vektor
    AT91C_BASE_TC1->TC_IER = AT91C_TC_CPCS;
    AIC_EnableIT(AT91C_ID_TC1);
 //   milisec=0;
}


//********************************************************************************************-
//
// Tilts utn jraleszti a motorokat
//
//********************************************************************************************

char enable_motors (unsigned char st){

unsigned long cc;
unsigned char ii;

	

	if (st){
		   

          
		   
 //          ampl[RA]=30;
 //          ampl[DEC]=30;
           
           stepper_parinit();
           for (cc=0;cc<0xfffff;cc++)no_sync[RA]=0;
           no_sync[RA]=0;
           no_sync[DEC]=0;

           motors_enabled=1;
           if (misc.motortype == SERVO)
           {
			   i_DEC = 0;   // hogy kis rammal induljon
			   i_RA  = 0;
			   i_RA1=0;
			   i_RA2=0;
			   i_DEC1=0;
			   i_DEC2=0;

           }
           else
           {
			   i_DEC = 100;   // hogy kis rammal induljon
			   i_RA  = 100;
			   i_RA1=100;
			   i_RA2=100;
			   i_DEC1=100;
			   i_DEC2=100;

           }


           PIO_Clear(&Mode_CD_IM);     //tilts megsznik

       //    PIO_Clear(&Mode_AB_IM);
           AIC_EnableIT(AT91C_ID_TC1);
           AIC_EnableIT(AT91C_ID_TC2);
         //  drive_mode_count[RA]=10;
           if (misc.motortype == SERVO)
           {
			   last_mot_stat[RA]=0;
			   last_mot_stat[DEC]=0;
			   sync_encoder(RA);
			   sync_encoder(DEC);
			   servo_var_reset();

           }
           else
           {
        	   last_mot_stat[RA]=100;
        	   last_mot_stat[DEC]=100;

           }
           set_motor_type(misc.motortype);
           PIO_Configure(&DBGU_txd, 1);
           printf("kamu motor on");   //ez reseteli a dbgu porton ketesztl a motors disablet
           	    
           	    
	}

	else					//todo
	
	{

	//	   drive_mode[RA]=IMODE;           //bekapcsolskor egy j hossz IMODE-dal indul, aztn majd tkapsol UMODE-ra ha kell
	//	   drive_mode_count[RA]=100;
	//	   drive_mode[DEC]=IMODE;
	//	   drive_mode_count[RA]=100;
		//   for (cc=0;cc<0xffffff;cc++)drive_mode_count[RA]=100;
	      // printf("kamu motor off");
		   AIC_DisableIT(AT91C_ID_TC1);
		   AIC_DisableIT(AT91C_ID_TC2);
		   
#ifndef MOT_OFF_DEBUG
		   PIO_Configure(&Motor_enable, 1); //debug modben kell todo
	       PIO_Set(&Motor_enable);
#endif
	       PIO_Set(&Mode_CD_IM);
	       PIO_Set(&Mode_CDIR);				//lehet hogy beleszakt valaki??? todo
	       PIO_Set(&Mode_DDIR);             //az a baj, hogy a debugger kimenet visszakapcsolhatja!!
	       PIO_Set(&Mode_AB_IM);
	       PIO_Set(&Mode_ADIR);
	       PIO_Set(&Mode_BDIR);
/*
	       PIO_Set(&Mode_CD_IM);
	       PIO_Set(&Mode_CDIR);
	       PIO_Set(&Mode_DDIR);
	       PIO_Set(&Mode_AB_IM);
	       PIO_Set(&Mode_ADIR);
	       PIO_Set(&Mode_BDIR);
	       motors_enabled=0;*/
	       no_sync[RA]=1;
	       no_sync[DEC]=1;

//	       printf("kamu motor off");
	}

return 0;
}

#define IENABLE()                      					/* Nested Interrupts Entry */   \
    asm volatile ( 	"MRS     LR, SPSR"   		"\n\t"/* Copy SPSR_irq to LR     */   \
    				"STMFD   SP!, {LR}"         "\n\t"/* Save SPSR_irq           */   \
    				"MSR     CPSR_c, #0x1F"     "\n\t"/* Enable IRQ (Sys Mode)   */   \
    				"STMFD   SP!, {LR}"         "\n\t")/* Save LR                 */   \

#define IDISABLE()                      				/* Nested Interrupts Exit */   \
  asm volatile ( 	"LDMFD   SP!, {LR}"          "\n\t"/* Restore LR              */   \
  					"MSR     CPSR_c, #0x92"      "\n\t"						/* Disable IRQ (IRQ Mode)  */   \
  					"LDMFD   SP!, {LR}"          "\n\t"						/* Restore SPSR_irq to LR  */   \
  					"MSR     SPSR_cxsf, LR"      "\n\t")					/* Copy LR to SPSR_irq     */   \



#define FIQ_ENTRY() \
    asm volatile("sub   lr, lr,#4"          "\n\t"  /* Adjust LR */ \
                 "stmfd sp!,{r0-r7,lr}"    "\n\t"  /* Save registers on IRQ stack.r7 */ \
                 )


/*!
 * \brief Fast interrupt exit.
 */
#define FIQ_EXIT1() \
    asm volatile("ldmfd sp!, {r1}"          "\n\t"  /* Restore SPSR */ \
                 "msr   spsr_c, r1"         "\n\t"  /* */ \
                 "ldr   r0, =0xFFFFF000"    "\n\t"  /* End of interrupt. */ \
                 "str   r0, [r0, #0x130]"   "\n\t"  /* */ \
                 "ldmfd sp!, {r0-r7, pc}^" "\n\t")     /* Restore registers and return.r7 */

#define FIQ_EXIT() \
    asm volatile("ldmfd sp!, {r0-r7, pc}^" "\n\t")     /* Restore registers and return.r7 */



#define FIQ_EOF() \
    asm volatile("ldr   r0, =0xFFFFF000"    "\n\t"  /* End of interrupt. */ \
                 "str   r0, [r0, #0x130]"   "\n\t")  /* */ 
                 


 
 //spuriosu FAST IT




#ifndef NEW_ENCODER_PINOUT



#define ENC_1() \
			  if (Piob&0x80)              \
			  asm("add    r8, r8, #1");	  \
              else 						  \
              asm("sub    r8, r8, #1");
#define ENC_2() \
			  if (Piob&0x20)			\
			  asm("add    r9, r9, #1");	  \
              else 						  \
              asm("sub    r9, r9, #1");
#define ENC_3() \
			  if (Piob&0x40)			\
			  asm("add    r10, r10, #1");	  \
              else 						  \
              asm("sub    r10, r10, #1");
#define ENC_4() \
			  if (Piob&0x10)				\
			  asm("add    r11, r11, #1");	  \
              else 						  \
              asm("sub    r11, r11, #1");



#else
// kozos csatlakozn van a RA s RA-0 ill DEC s DEC-0

/*

#define ENC_1() \
			  if (Piob&0x80)              \
			  asm("add    r8, r8, #1");	  \
              else 						  \
              asm("sub    r8, r8, #1");
#define ENC_3() \
			  if (Piob&0x20)			\
			  asm("add    r9, r9, #1");	  \
              else 						  \
              asm("sub    r9, r9, #1");
#define ENC_2() \
			  if (Piob&0x40)			\
			  asm("add    r10, r10, #1");	  \
              else 						  \
              asm("sub    r10, r10, #1");
#define ENC_4() \
			  if (Piob&0x10)				\
			  asm("add    r11, r11, #1");	  \
              else 						  \
              asm("sub    r11, r11, #1");

*/

//csak 2 bemenetet hasznlunk, azokat hasznljuk a motorra is
#define ENC_1() \
			  if ((Piob&0x80)){              \
			  asm("add    r8, r8, #1");	  \
			  asm("add    r10, r10, #1");\
			  } \
              else {						  \
              asm("sub    r8, r8, #1");\
			  asm("sub    r10, r10, #1");}
#define ENC_2() \
			  if ((Piob&0x20))			\
			  asm("add    r10, r10, #1");	  \
              else 						  \
              asm("sub    r10, r10, #1");
#define ENC_3() \
			  if ((Piob&0x40)){			\
			  asm("add    r9, r9, #1");	  \
			  asm("add    r11, r11, #1");	  }\
              else {						  \
              asm("sub    r9, r9, #1");\
              asm("sub    r11, r11, #1");}
#define ENC_4() \
			  if ((Piob&0x10))				\
			  asm("add    r11, r11, #1");	  \
              else 						  \
              asm("sub    r11, r11, #1");



/* new ok
#define ENC_1() \
			  if ((Piob&0x80))              \
			  asm("add    r8, r8, #1");	  \
              else 						  \
              asm("sub    r8, r8, #1");
#define ENC_2() \
			  if ((Piob&0x20))			\
			  asm("add    r10, r10, #1");	  \
              else 						  \
              asm("sub    r10, r10, #1");
#define ENC_3() \
			  if ((Piob&0x40))			\
			  asm("add    r9, r9, #1");	  \
              else 						  \
              asm("sub    r9, r9, #1");
#define ENC_4() \
			  if ((Piob&0x10))				\
			  asm("add    r11, r11, #1");	  \
              else 						  \
              asm("sub    r11, r11, #1");

*/

#endif


// 1sor

// 2.sor

// 3.sor

// 4.sor

//3412 = ket luk felcserelve
//3214 = ra ok


//3241 uj, ket luk csrelve
//4132 also felso sor csrelve
//4321 sor, csati csrelve
//2314
//1423 encoderek ok , 0 pos csere

void ISR_SPUR (void) {

	 AT91C_BASE_AIC->AIC_EOICR= 0xff;   //a lekezelt IT , brmit lehet rni
//	 printf("-SPURI-");    
	
}

/*
RAMFUNC static void ISR_IRQ1 (void) __attribute__((naked));

//#define LEDI
RAMFUNC void ISR_IRQ1 (void){
	FIQ_ENTRY();
	AT91C_BASE_AIC->AIC_ICCR= 1<<AT91C_ID_IRQ1;
	FIQ_EXIT();


}

*/
//msr cpsr_c, #MODE_FIQ|FIQ_BIT|IRQ_BIT   ; @ switch to FIQ
//static void ISR_IRQ1 (void) __attribute__((interrupt ("IRQ1"))); //IRQ1
static void ISR_IRQ1 (void) __attribute__((naked));

//#define LEDI
void ISR_IRQ1 (void){
	
//unsigned int ss;	
	
// unsigned int status;
	
register unsigned int Piob asm("r4");;  //,Pioa;

FIQ_ENTRY();
//AT91C_BASE_AIC->AIC_ICCR= 1<<AT91C_ID_IRQ1;   //a lekezelt IT trlse Forced Fiq esetn kell
//ss=AT91C_BASE_AIC->AIC_IVR;
//printf(".");

//AT91C_BASE_DBGU->DBGU_THR='.';
//return;
//AT91C_BASE_AIC->AIC_ICCR= 1<<AT91C_ID_IRQ1;
//FIQ_EXIT();
//return;
//Piob=0;
//Led bizgets
#ifdef LEDI
    __asm__(        "mov r3,#0xb0000000\n\t"
    				"asr   r3, r3, #19\n\t"
    				   		
    				"mov   r2, #0x10000000\n\t"   		
    				"str   r2, [r3, #48]\n\t"
   // 				"str   r2, [r3, #52]\n\t"
    	     );

#endif
   
      
      __asm__(        
 
    		  
    		  		  "ldr   r3,=0xFFFFF600\n\t"     //PIOB_BASE   Irnyok
    		      	  "ldr   r3, [r3, #0x3c]\n\t"    //PDSR    		      
    		      	  "lsr   r3, r3, #19\n\t"
    		      	  "and   r3,r3,#0x0f0\n\t"
    		  		  "push {r3}\n\t"
    		  
    		  
    		          "ldr   r3,=0xFFFFF400\n\t"     //PIOA_BASE ITk
    		          "ldr   r3, [r3, #0x3c]\n\t"    //PDSR
    		  		  "lsr   r3, r3, #7\n\t"
 
    		          "and   r2,r3,#0x07\n\t"	 
    		          "and   r3,r3,#0x80\n\t"
    		          "lsr   r3,r3, #4\n\t"                               		  
    		          "add   r2,r2,r3\n\t"   		  
    		  		 // "lsr   r2,r2, #4\n\t" 
    		  		  "pop {r3}\n\t"
    		  
    		          "add   %0,r3,r2\n\t"	         //r3 ban az  

    		  	  	  "ldr   r3,=enc_dir\n\t"	// irny korrekci
    		          "ldr   r3,[r3]\n\t"
    		  	  	  "eor   %0,%0,r3\n\t"
    		  		  
    		          : "=r" (Piob) 
  //  		          :
  //  		          : "r4"
    //      		      "mov   r2,#4\n\t"
   
    		        
          	     );
 
      
/*      
      
      __asm__(        "mov r3,#0xb0000000\n\t"
          				"asr   r3, r3, #19\n\t"
          				   		
          				"mov   r2, #0x10000000\n\t"   		
          				"str   r2, [r3, #48]\n\t"
         // 				"str   r2, [r3, #52]\n\t"
          	     );
 */         
//    FIQ_EOF();    
//llllAT91C_BASE_AIC->AIC_ICCR= 1<<AT91C_ID_IRQ1;   //a lekezelt IT trlse Forced Fiq esetn kell   
    AT91C_BASE_AIC->AIC_ICCR= 1<<AT91C_ID_IRQ1;
    
 
      switch (Piob&0xf){
            
            case 0:
          	  									//error
          	  break;
            case 1:
               ENC_4();		          	  
            	     
          	  break;
            case 2:				//1
              ENC_2();	
                       
          	  break;
            case 3:
            	ENC_4();
            	ENC_2();
          	  break;
            case 4:
            	ENC_3();	  
            	          	  
          	  break;
            case 5:
            	ENC_3();
            	ENC_4();	
          	  break;
            case 6:
            	ENC_3();
            	ENC_2();	
          	  break;
            case 7:
            	ENC_3();
            	ENC_2();
            	ENC_4();
          	  break;
          	  
            case 8:           //2
            	ENC_1();
              break;	
            case 9:
            	ENC_1();
            	ENC_4();
              break;
            case 10:         //1+2
            	ENC_1();
            	ENC_2();
            	
      
              break;
            case 11:
            	ENC_1();           	
            	ENC_2();
            	ENC_4();
             
              break;
            case 12:
            	ENC_1();
            	ENC_3();
              break;
            case 13:
            	ENC_1();
            	ENC_3();
            	ENC_4();
              break;
            case 14:
            	ENC_1();
            	ENC_3();
            	ENC_2();
              break;
            case 15:
            	ENC_1();
            	ENC_2();
            	ENC_3();
            	ENC_4();
            break;  
           
     
                      	  

            
           
            
            
            }
            
        
/*      
      __asm__(        "mov r3,#0xb0000000\n\t"
              				"asr   r3, r3, #19\n\t"
              				   		
              				"mov   r2, #0x10000000\n\t"   		
              	//			"str   r2, [r3, #48]\n\t"
              				"str   r2, [r3, #52]\n\t"
              	     );   
 */     
#ifdef LEDI
      
//Led bizgets     
    __asm__(        "mov r3,#0xb0000000\n\t"
    				"asr   r3, r3, #19\n\t"
    				   		
    				"mov   r2, #0x10000000\n\t"   		
    	//			"str   r2, [r3, #48]\n\t"
    				"str   r2, [r3, #52]\n\t"
    	     );
   
#endif
//	status &= AT91C_BASE_PIOB->PIO_IMR;
	
//	AT91C_BASE_PIOB->PIO_SODR=1<<28;
//	AT91C_BASE_PIOB->PIO_CODR=1<<28;
	
	//PIO_Set(&Wp_Sd);
	//PIO_Clear(&Wp_Sd);
    
/*    
	__asm__("mov r3,#0xb0000000\n\t"
			"asr   r3, r3, #19\n\t"
			"mov   r2, #0x10000000\n\t"
			"str   r2, [r3, #48]\n\t"
			"str   r2, [r3, #52]\n\t"
     );
	
	encoder[0]--;	
	encoder[1]++;
*/	
//    AT91C_BASE_DBGU->DBGU_THR='.';
//AT91C_BASE_AIC->AIC_ICCR= 1<<AT91C_ID_IRQ1;
FIQ_EXIT();    
}


#define MEASURE_SPEED 2000
float measure_reduction(unsigned char motor,unsigned char enc,unsigned char dir)
{

	signed long encoder[2][2]={
									{ 0,0 },
									{ 0,0 }							
								};

float mot_start=0;
unsigned long stc_start;
unsigned int step_start;

unsigned long enc_start;

float encoder_start=0;

float red=0;
float diff=0;
float enc_diff;

long stc=0;
static unsigned int st=0;
char mes_ok=0;
unsigned long cc=0;
float h;
//int aa;
signed int n=0;

extern char keypressed (void);
unsigned char k;

mot_dir[motor]=dir;

//elteszi az aktulis motor s encoder llsokat

no_sync[motor]=1;					//lell a motor-szinkron a mrs idejre


set_sin_timer(motor,100,0);        //elidtja, a backlash miatt
delay(3000);


set_sin_timer(motor,0,0);          //meg kell llni
delay (300);


get_encoders(&encoder[MOUNT_ENC][RA],&encoder[MOUNT_ENC][DEC],&encoder[MOTOR_ENC][RA],&encoder[MOTOR_ENC][DEC]);
st=step[motor] ;
while (st!=step[motor])
  st=step[motor];
  
while (stc!=stepcount[motor])
  stc=stepcount[motor];  


//eltekeri a morort 500x sebessggel, 20 fokot
//s kiszmolja mennyi a vals tttel
for (n=1;n<MEASURE_SPEED;n=n+100){                          //szp lassan gyorst
set_sin_timer(motor,n,0);
delay(200);
}


stc_start=stc;
step_start=st;




mot_start=step_to_rad(motor,stc,st);
enc_start=encoder[enc][motor];
	


h=(float)mot[motor].encoderres[enc] ;
if (h)h=2*M_PI/h;	 										//egy encoder lps radinban

encoder_start=h*(float)encoder[enc][motor];

//printf("esolepes") ;

/*
//eltekeri a morort 500x sebessggel, 20 fokot
//s kiszmolja mennyi a vals tttel
for (n=1;n<MEASURE_SPEED;n=n+100){                          //szp lassan gyorst
set_sin_timer(motor,n,0);
delay(100);
}

*/




for (cc=0;cc<60000;cc++){									//vrja, hogy megrkezzen debug
//	no_sync[motor]=1;
//	set_sin_timer(motor,2000,0);
	st=step[motor] ;
	while (st!=step[motor])
	  st=step[motor];
	  
	while (stc!=stepcount[motor])
	  stc=stepcount[motor];  

	diff=mot_start-step_to_rad(motor,stc,st);	
	if (diff<0){diff=-diff;}


	if (diff>M2_PI/18){			//20 fok teszt csak a /17 a lassulst kivegyem
		mes_ok=1;
		break;


	}
//	printf("c:%d",cc);
	delay(1);

	k=keypressed();
    if (((k>='0')&&(k<='9'))||(k=='-')||(k==ESC)){
    	     set_sin_timer(motor,0,0);
			 return 0;
		 }
}




for (n=MEASURE_SPEED;n>0;n=n-100){								//lelasst
if (n<0)n=0;	
set_sin_timer(motor,n,0);
delay(200);
k=keypressed();
if (((k>='0')&&(k<='9'))||(k=='-')||(k==ESC)){
			 set_sin_timer(motor,0,0);
			 return 0;
		 }
}

set_sin_timer(motor,0,0);
delay (300);
get_encoders(&encoder[MOUNT_ENC][RA],&encoder[MOUNT_ENC][DEC],&encoder[MOTOR_ENC][RA],&encoder[MOTOR_ENC][DEC]);
																							//megint beolvassa az encodereket
diff=mot_start-step_to_rad(motor,stc,st);
	    
if (mes_ok){			//j a mrs lehet szmolni
	
int mch=0;
int ech=0;

//printf("ok a meres");

//diff=mot_start-step_to_rad(motor,stc,st);
if (diff<0){diff=-diff;mch=1;}


//get_encoders(&encoder[0][RA],&encoder[0][DEC],&encoder[1][RA],&encoder[1][DEC]); //megint beolvassa az encodereket
enc_diff=(h*(float)encoder[enc][motor])-encoder_start;
//aa=encoder[enc][motor];
//printf ("encoder:%d",aa);
//aa=(stepcount[motor]*ustep_per_step)+step[motor];
//printf ("motor::%d",aa);

if (enc_diff<0){enc_diff=-enc_diff;ech=1;}




	if (mch!=ech)
	{
	if (mot[motor].encoder_dir[MOUNT_ENC]==0)mot[motor].encoder_dir[MOUNT_ENC]=1;else mot[motor].encoder_dir[MOUNT_ENC]=0;
    set_enc_dir();       //aktivizlja a vltoztatst
   // beep();
//    printf("enc valt");
	}


{
 int ed;
 int md;
// int resi;
 float oo;
 float ee;
 
    ed=enc_diff*10000;
    md=diff*10000;
    
    ed=enc_start-encoder[enc][motor];
    if (ed<0)ed=-ed;
    
    md=((stc_start*ustep_per_step)+step_start)-((stepcount[motor]*ustep_per_step)+step[motor]);
    if (md<0)md=-md;
    
    oo=(float)ed/(4*(float)mot[motor].encoderres[enc]);									//todo mirt 4???
    ee=(float)md/(oo*(float)mot[motor].motres*(float)ustep_per_step);
//    (float)(mot[motor].reduction*mot[motor].motres*ustep_per_step);
    red=ee;
//    " %05u.%02u",(unsigned int)redu,(unsigned int)(100*((redu+0.007)-(unsigned int)redu)));
    //resi=(int)(1000*(ee-(int)ee));
//	printf ("\n\r mot_diff=%d,enc_diff=%d,reduction:%05u.%02u\n\r",md,ed,(unsigned int)(red+0.007),(unsigned int)(100*((red+0.007)-(unsigned int)red)));
	
	
}
	
}else printf("rossz a meres");

/*
for (n=MEASURE_SPEED;n>0;n=n-100){								//lelasst
if (n<0)n=0;
set_sin_timer(motor,n,0);
delay(100);
k=keypressed();
if (((k>='0')&&(k<='9'))||(k=='-')||(k==ESC)){
			 set_sin_timer(motor,0,0);
			 return 0;
		 }
}

set_sin_timer(motor,0,0);
*/


delay (1000);
no_sync[motor]=0;	

	    		
return red;	    		
}
 






//******************************************************************************************************
//
//  Encoder interrupt to stabilize tracking speed - experimental module, not used
//
//******************************************************************************************************




#define  SidRate  1.00273790935
#define ENC_BUFF_SIZE 3
#define ENC_COUNT_CORR 10
//#define MAX_KOV_ERR 0.0000004*CORR_ENC_CNT  //2
//#define MAX_KOV_ERR 0.0000005*CORR_ENC_CNT  //2
#define MAX_KOV_ERR 0.0000025*CORR_ENC_CNT  //2
#define LITDIV 60

unsigned int enc_buffer [ENC_BUFF_SIZE+1];
unsigned short enc_buff_ptr=0;

unsigned int ra_mes_cnt=0;
void ISR_encoder(const Pin *pPin){

static unsigned int enc_cnt_div=0;
static unsigned long ra_mes=0;
unsigned short ii;
unsigned int enc_corred_time=0;
//unsigned int tx;
//float h;
static float error=0;
float error1;
float enc_step_time;
static float integ_err=0;
static char litcnt=0;
static unsigned int enc_speed;




if (no_synctest==0)                                                 //ha teszt van akkor menjen
   if (no_sync[RA])return;                                          //mert belehlyl a gyors megszaktsba!!!!


if (first_enc_it){         //bekapcskor alapllapotba teszi a dolgokat

unsigned char ii;
	                                                                 //a bekapcs utni els mrs nem kell, mert gyis hasznlhatatlan
    first_enc_it--;
    integ_err=0;
    for (ii=0;ii<ENC_BUFF_SIZE;ii++){                               //az utols x summja


    	    	enc_buffer[ii]=(float)LITDIV*10000.*((86400./mot[RA].encoderres[MOUNT_ENC])/SidRate);

    	    }
    ra_mes_tick=0;
	return ;
}



//printf(".");


if (litcnt<(3+LITDIV-1)){                                           //3 impulzust kihagy az impulzus utn

	litcnt++;
/*	if (((LITDIV/2)==litcnt)||((LITDIV/4)==litcnt)||(((3*LITDIV)/4)==litcnt))
		if (estiteszt || misc.trackstab){                  //ha be van kapcsolva akkor korrigl
		 mot_offset1[RA]+=error;                           //flton mgegy korr. gy 2 * es lesz
		// printf(".");
		}*/

	if (litcnt==3){

		enc_speed=(ra_mes_tick*LITDIV)/(LITDIV+3);
		ra_mes_tick=0;                            //innnetl mr LITDIV darabot
	}
	return;
}
litcnt=0;
//printf("x");


if (ra_mes_tick>ENC_COUNT_CORR*2)
  ra_mes+=ra_mes_tick-ENC_COUNT_CORR;
else ra_mes+=ra_mes_tick;





if (enc_buff_ptr<ENC_BUFF_SIZE-1)enc_buff_ptr++;else enc_buff_ptr=0;


enc_step_time=((float)LITDIV)*((86400./mot[RA].encoderres[MOUNT_ENC])/SidRate);

if (ra_mes_tick>ENC_COUNT_CORR*2)
 enc_buffer[enc_buff_ptr]=ra_mes_tick-ENC_COUNT_CORR;                              //kell egy kis mrs korrekci
else enc_buffer[enc_buff_ptr]=ra_mes_tick;                                         //a cirkulris pufferben mindg az utols x darab van
if (enc_buffer[enc_buff_ptr]>enc_step_time*1.4*10000);//enc_buffer[enc_buff_ptr]=enc_step_time*10000*1.4;
if (enc_buffer[enc_buff_ptr]<enc_step_time*10000/1.4);//enc_buffer[enc_buff_ptr]=enc_step_time*10000/1.4;


//ra_mes_tick=0;

enc_corred_time=0;



for (ii=0;ii<ENC_BUFF_SIZE;ii++){                               //az utols x summja


	enc_corred_time+=enc_buffer[ii];
//	printf("cc=%d\n",ii);
}



if (enc_cnt_div){
	 enc_cnt_div--;
    }
else{
//if (pPin==&Px_It_A12){

//	tx=track_timer[RA];


if (reset_ra_enc_corr){

		corr_ra_encoder=0;
		reset_ra_enc_corr=0;
	}




//error1=(float)enc_corred_time-enc_step_time*(float)ENC_BUFF_SIZE*10000.;

error1=(float)enc_buffer[enc_buff_ptr]-enc_step_time*10000.;   //egyenknt korriglunk
integ_err+=error1;

integ_err=0;

//error1=error1/2.;

if (integ_err>100000.)integ_err=100000.;
if (integ_err<-100000.)integ_err=-100000.;

//integ_err=integ_err/10;
//integ_err=0;
//error=-((error1/260.)+(integ_err/30.))/(19000000000./(((float)CORR_ENC_CNT)*(float)LITDIV));   //50-2  //3 //0 // /10 //3
//error=-((error1/460.)+(integ_err/20.))/(10000000000./(((float)CORR_ENC_CNT)*(float)LITDIV)); //ezzel visznylag j volt
error=-((0.001*error1*(float)encoder_prop)+(integ_err/40.))/(10000000000./(((float)CORR_ENC_CNT)*(float)LITDIV));
if (error>MAX_KOV_ERR)error=MAX_KOV_ERR;
if (error<-MAX_KOV_ERR)error=-MAX_KOV_ERR;

if (estiteszt || misc.trackstab){                  //ha be van kapcsolva akkor korrigl



corr_ra_encoder=error;                           //picit tompt a meredeksgen
mot_offset1[RA]+=error;

/*
	if (enc_corred_time<enc_step_time)
	    //{if (corr_ra_encoder>-200)corr_ra_encoder--;}
	    {if (corr_ra_encoder>-0.0000002)corr_ra_encoder=corr_ra_encoder-0.00000001;}
	else if (enc_corred_time>enc_step_time)

	    {if (corr_ra_encoder<0.0000002) corr_ra_encoder=corr_ra_encoder+0.00000001;}
	    //{if (corr_ra_encoder<200) corr_ra_encoder++;}

*/

/*

	h=(float)((mot[RA].reduction+corr_ra_encoder)*mot[RA].motres)*ustep_per_step;
	if (h)h=M2_PI/h;//egy mstep radinban
	mot_ustep_rad[RA]=h;
*/
} else corr_ra_encoder=0;
/*
	if (tx<TIMER_MIN)tx=TIMER_MIN;
	if (tx>TIMER_MAX)tx=TIMER_MAX;
	track_timer[RA]=tx;*/
//	set_sin_timer(RA,10,mot_dir[RA]);  //ez itt sokat javtott a pec-en
/*
	printf("\n\rRA en_st:;%d;%d;%d,%d;",ra_mes_cnt,enc_buffer[enc_buff_ptr],enc_corred_time,enc_buff_ptr);
	printf_float(enc_step_time*(float)ENC_BUFF_SIZE);
	printf(";");
	printf_float(error1);
	printf(";");
//	printf_float(integ_err);
	printf("%d",encoder_prop);
	printf(";");
	printf_float(corr_ra_encoder);
	printf(";");
//	printf_float(mot_offset1[RA]);
    printf("%d",enc_speed);
*/
	ra_mes=0;
	ra_mes_cnt++;

	enc_cnt_div=ENC_CNT_DIV-1;
}
//	if (!PIO_Get(pPin))printf("-");else printf("+");      //csak "-" van mert olyan rvid az impulzus
//}

}
/*
void inc_enc_propo(void){

if (encoder_prop<255)encoder_prop+=10;
printf("prop-encoder:%d",encoder_prop);

}


void dec_enc_propo(void){


if (encoder_prop>20)encoder_prop-=10;
printf("prop-encoder:%d",encoder_prop);
}
*/
void get_encoder_0_pos1(void){


//unsigned char  e1;
//unsigned char   e2;


//e1=(PIO_Get(&Px_It_A12)<<3)+(PIO_Get(&Px_It_A34)<<2)+(PIO_Get(&Px_It_B12)<<1)+PIO_Get(&Px_It_B34);

//e2=(PIO_Get(&Px_Ud_A12)<<3)+(PIO_Get(&Px_Ud_A34)<<2)+(PIO_Get(&Px_Ud_B12)<<1)+PIO_Get(&Px_Ud_B34);
//printf("%x,",e1);






}







void inc_enc_prop(void){




}


void dec_enc_prop(void){




}


//*****************************************************************************
//
// Trli az enkoder 0 pozci ervnyessgt
//
//*****************************************************************************


void clr_encoder_0_pos(unsigned char enc){


ecoder_0_mark[enc]=0;


}

//*****************************************************************************
//
// Visszaadja az enkoder 0 pozci ervnyessgt
//
//*****************************************************************************


char get_encoder_0_pos(unsigned char enc){


return ecoder_0_mark[enc];
}



//*****************************************************************************
//
// Enkoder 0 pozci megyszaktsok
//
//*****************************************************************************




void ISR_encoder_0(const Pin *pPin){                  // encoder 0 pos
	ecoder_0_mark[RA]=1;
//	printf("-it-0=,%x",	PIO_Get(&Px_It_A12));
//    beep();


}


void ISR_encoder_1(const Pin *pPin){                 // encoder 1 pos
	ecoder_0_mark[DEC]=1;
//	printf("-it-1=,%x",	PIO_Get(&Px_It_A34));
//	beep();

}





void ISR_encoder_2(const Pin *pPin){
	ecoder_0_mark[DEC]=1;
//	printf("-it-2=,%x",	PIO_Get(&Px_It_B12));

}

void ISR_encoder_3(const Pin *pPin){

//	printf("-it-3=,%x",	PIO_Get(&Px_It_B34));


}


//*****************************************************************************
//
// Enkoder megyszakts engednyezs
//
//*****************************************************************************


void enable_encoder_IT(char en){
static char st=0;
static char st_cnt=0;

 if (en){

     if (st_cnt<50)st_cnt++;                                    //elg lassan kapcsoljon be
     else if (!st){

       first_enc_it=2;

	   PIO_EnableIt(&Px_Ud_B12);
//	   printf("it-on");

	   st=1;
     }
 }
 else {if ((st_cnt>48)&&st){

	   PIO_DisableIt(&Px_Ud_B12);
//	   printf("it-off");
	   st=0;
  }
  st_cnt=0;
 }

}


//*****************************************************************************
//
// Enkoder megszakts init
//
//*****************************************************************************


void init_encoder_IT(void)

{

static	unsigned char inited=0;

if (!inited){
inited=1;

	    PIO_ConfigureIt(&Px_Ud_B12, ISR_encoder);


	    PIO_ConfigureIt(&Px_It_A12, ISR_encoder_0);
	    PIO_EnableIt(&Px_It_A12);
#ifndef NEW_ENCODER_PINOUT

	    PIO_ConfigureIt(&Px_It_A34, ISR_encoder_1);
	    PIO_EnableIt(&Px_It_A34);
#else

	    PIO_ConfigureIt(&Px_It_B12, ISR_encoder_2);
	    PIO_EnableIt(&Px_It_B12);
#endif
/*	    PIO_ConfigureIt(&Px_It_B34, ISR_encoder_3);
	    PIO_EnableIt(&Px_It_B34);
*/
}
}


//*****************************************************************************
//
// Az enkoder forgsirnyt aktualizlja
//
//*****************************************************************************


void set_enc_dir(void){

#ifndef NEW_ENCODER_PINOUT

if (mot[DEC].encoder_dir[MOTOR_ENC])enc_dir&=~0x0040;else enc_dir|=0x0040;
if (mot[RA].encoder_dir[MOTOR_ENC])enc_dir&=~0x0010;else enc_dir|=0x0010;
if (mot[DEC].encoder_dir[MOUNT_ENC])enc_dir&=~0x0080;else enc_dir|=0x0080;
if (mot[RA].encoder_dir[MOUNT_ENC])enc_dir&=~0x0020;else enc_dir|=0x0020;

#else

if (mot[DEC].encoder_dir[MOTOR_ENC])enc_dir&=~0x0020;else enc_dir|=0x0020;   //DEC motor
if (mot[RA].encoder_dir[MOTOR_ENC])enc_dir&=~0x0010;else enc_dir|=0x0010;    //RA motor
if (mot[DEC].encoder_dir[MOUNT_ENC])enc_dir&=~0x0080;else enc_dir|=0x0080;   //DEC mount
if (mot[RA].encoder_dir[MOUNT_ENC])enc_dir&=~0x0040;else enc_dir|=0x0040;    //RA mount

#endif

}



//*****************************************************************************
//
// Kiszmolja a fesz, s ram rtkek effektv rtkt
//
//*****************************************************************************


void calc_adc(void)
{

int cc;	
volatile unsigned  long U=0;
volatile unsigned  long i_RA_1=0;
volatile unsigned  long i_RA_2=0;
volatile unsigned  long i_DEC_1=0;
volatile unsigned  long i_DEC_2=0;

volatile int dx,dy;

volatile unsigned char ioffset[2];

dx=ADC_ARRAY_SIZE-2;
//dx=30;
if (drive_mode[RA]==IMODE){
	
	ioffset[RA]=IOFFSET_IMODE;
	
}
else{
	
	ioffset[RA]=IOFFSET_UMODE;
}

if (drive_mode[DEC]==IMODE){
	
	ioffset[DEC]=IOFFSET_IMODE;
	
}
else{
	
	ioffset[DEC]=IOFFSET_UMODE;
}



for (cc=0;cc<dx;cc++)
{	
	
if (cc<ADC_ARRAY_SIZE-1)U += adc_buffer[cc].U;

i_RA_1 += (adc_buffer[cc].RA1-ioffset[RA]);
i_RA_2 += (adc_buffer[cc].RA2-ioffset[RA]);
i_DEC_1 += (adc_buffer[cc].DEC1-ioffset[DEC]);
i_DEC_2 += (adc_buffer[cc].DEC2-ioffset[DEC]);
}

dy = U/(dx-1);  //mert az utolso az a 0xaa sentinel



i_RA1 = i_RA_1/dx;
i_RA2 = i_RA_2/dx;
i_DEC1 = i_DEC_1/dx;
i_DEC2 = i_DEC_2/dx;

dy=dy/2.8; //3.35;

U_in=dy;

/*
printf("U_in=%i\n\r",U_in);
printf("i_RA1=%i\n\r",i_RA1);
printf("i_RA2=%i\n\r",i_RA2);
printf("i_DEC1=%i\n\r",i_DEC1);
printf("i_DEC2=%i\n\r",i_DEC2);

*/
if ((i_RA1+i_RA2)<10000)i_RA=(i_RA1+i_RA2)*2;
if ((i_DEC1+i_DEC2)<10000)i_DEC=(i_DEC1+i_DEC2)*2;


//printf("i_RA=%i",i_RA);
//printf("i_DEC=%i\n\r",i_DEC);
if (!motors_enabled){i_RA=i_DEC=1000;};
//set_mot_current();                              //2010.11.02 inkbb cscsrtk alapjn szmolunk, de srbben
/*if (U_in<30){
	printf("11");
	printf("11");
}*/


}

int get_U_supply(void){

	

	


	
return U_in;	
	
}


//*****************************************************************************
//
// Belltja az ramot a megadott csatornn
//
//*****************************************************************************

unsigned char current_set(unsigned char mot, short curr){
	
unsigned short duty;	
	
//MAX_DUTY_CYCLE
//MIN_DUTY_CYCLE
duty=mot_period[mot]+curr;	 //2009.09.5 RA volt, javtottam
	
	
 if (mot){	               //DEC servo
	
	PWMC_SetDutyCycle(3, duty);
 }
	
 else{					   //RA servo	
    PWMC_SetDutyCycle(2, duty);
 }
	
return 0;	
	
}


//*************************************************************************************************-
//
// A motor tpust lehet kivlasztani (stepper, vagy servo)
//
// servo mdban a RA stepper motor meghajtit hasznlja
//
//*************************************************************************************************


char set_motor_type(char type){
	
 if (type==STEPPER_MODE){
	 
	 TC_Start(AT91C_BASE_TC2);
	 TC_Start(AT91C_BASE_TC1);
	 
 }
 
 if (type==SERVO_MODE){

	 
	 
	 
	 
	 TC_Stop(AT91C_BASE_TC1);
	 PIO_Set(&Mode_CD_IM);
	 PIO_Clear(&Mode_CDIR);
	 PIO_Clear(&Mode_DDIR);
	 RA_timer_init(32,50000,1);
	 TC_Stop(AT91C_BASE_TC2);
	 current_set(RA,0);
	 current_set(DEC,0);
	 
 }
	
	
	
return(0);	
}


//---------------------------------------------------------------------------------------------
//
//
// Servo mod syncron
//
//---------------------------------------------------------------------------------------------


//void servo_sync_mot(char mot){
	
	
	
	
	
//}


/*
void motor_enable (unsigned char mot)

{

//todo
}


void motor_disable (unsigned char mot)

{

//todo
}
*/


//*************************************************************************************************-
//
// Motor Timerek inicializlja
//
//*************************************************************************************************


void init_Timers(void)

{
	
unsigned int tt;
unsigned int pr;

//	ConfigureTc1();
//	ConfigureTc2();
	
	

	calc_track_timer(RA,&pr,&tt);
	track_presc_h[RA]=pr;
	track_timer[RA]=tt;
	track_timer_base[RA]=track_timer[RA];
	mot_track_timer_h[RA]=track_timer[RA];
    
	calc_track_timer(DEC,&pr,&tt);
	track_timer[DEC]=tt;
	track_presc_h[DEC]=pr;
	track_timer_base[DEC]=track_timer[DEC];
	mot_track_timer_h[DEC]=track_timer[DEC];

	
	
	
}

//*************************************************************************************************-
//
// AD konverter inicializsa
//
//*************************************************************************************************


void init_Adc(void)
{
	memset(adc_buffer,0,sizeof(adc_buffer-10));
	AT91C_BASE_ADC->ADC_PTCR = AT91C_PDC_RXTDIS | AT91C_PDC_TXTDIS;
	ADC_Init();
	ADC_SetMode(SINGLE_CONVERSION);
	ADC_SetPrescale(4);
//	AT91C_BASE_ADC->ADC_MR=
	    
	    		
	ADC_EnableChannel(3);
	ADC_EnableChannel(4);
	ADC_EnableChannel(5);
	ADC_EnableChannel(6);
	ADC_EnableChannel(7);
	
	
	



	
	
}

//*************************************************************************************************-
//
// Vltozk alapra
//
//*************************************************************************************************


int init_stepper_variables(void)

{

float h;
unsigned char m;
 
oszt=POS_MAX;
if ((mot[RA].reduction>10000)||(mot[DEC].reduction>10000))
;// oszt=POS_MAX/2;							//ha nagy a maingear ,akkor nem kell a nagy felfonts, s a timer gys brja, kiakad stachk overflow-va				 
 
else oszt=POS_MAX;
 
ustep_per_step=oszt;//>>2;					//ennyi mikrostep van egy stepben	
//ustep_msk=(oszt>>1)-1;

for (m=0;m<3;m++){
h=(float)mot[m].reduction*mot[m].motres*ustep_per_step;
if (h)h=M2_PI/h;//egy mstep radinban
mot_ustep_rad[m]=h;

}
return(oszt);
}



#define LOW_LEVEL  0x00
#define HIGH_LEVEL 0x40

#define NEG_EDGE  0x20
#define POS_EDGE  0x60
#define PRIOR     7


//*************************************************************************************************-
//
// Enkoder bemeneteket inicializlja
//
//*************************************************************************************************


void init_QuadInputs(void)

{
	
//	    PIO_InitializeInterrupts(AT91C_AIC_PRIOR_LOWEST); //mr msok megtettk
//	    PIO_Configure(&pin_timerIT, 1);
	
/*	
	    PIO_ConfigureIt(&Px_It_A12, ISR_Px_It_A12);
	    PIO_EnableIt(&Px_It_A12);
	    
	    PIO_ConfigureIt(&Px_It_A34, ISR_Px_It_A34);
	    PIO_EnableIt(&Px_It_A34);
	    	    
	    PIO_ConfigureIt(&Px_It_B12, ISR_Px_It_B12);
	    PIO_EnableIt(&Px_It_B12);
	    
	    PIO_ConfigureIt(&Px_It_B34, ISR_Px_It_B34);
	    PIO_EnableIt(&Px_It_B34);
	    
	    
	AT91C_BASE_PMC->PMC_PCER = 1 << AT91C_ID_PIOB;
	AT91C_BASE_PIOB->PIO_ISR;
	AT91C_BASE_PIOB->PIO_IDR = 0xFFFFFFFF;    
	
	AIC_ConfigureIT(AT91C_ID_IRQ1,PRIOR|POS_EDGE,ISR_IRQ1);
	AIC_EnableIT(AT91C_ID_IRQ1);
 //   AIC_ConfigureIT(AT91C_ID_PIOB,PRIOR|HIGH_LEVEL,ISR_PIOB);
 //   AIC_EnableIT(AT91C_ID_PIOB);
    
    //AT91C_BASE_AIC->AIC_FFER=1 << AT91C_ID_PIOB;
    
    AT91C_BASE_PIOB->PIO_ISR;
    AT91C_BASE_PIOB->PIO_IER = 1 << 23;
    AT91C_BASE_PIOB->PIO_IER = 1 << 24;
    AT91C_BASE_PIOB->PIO_IER = 1 << 25;
    AT91C_BASE_PIOB->PIO_IER = 1 << 26;
*/	  
	//AT91C_BASE_AIC->AIC_ISCR = 1 << AT91C_ID_FIQ;
	AT91C_BASE_AIC->AIC_SPU = (unsigned int)ISR_SPUR;		//(unsigned int) defaultSpuriousHandler;
	AIC_ConfigureIT(AT91C_ID_IRQ1,POS_EDGE,ISR_SPUR);
//	AIC_ConfigureIT(AT91C_ID_IRQ1,AIC_PRIOR_FIQ|POS_EDGE,ISR_IRQ1);
	
    AT91C_BASE_AIC->AIC_FFER = 1 << AT91C_ID_IRQ1;   //force FIQ enable IRQ1

	AIC_ConfigureIT(AT91C_ID_FIQ,AIC_PRIOR_FIQ|POS_EDGE,ISR_IRQ1);         //az encoder megszakts IRQ1 forced FIQ
	AIC_EnableIT(AT91C_ID_IRQ1);
//	AIC_EnableIT(AT91C_ID_FIQ);                              //az igazi fiq nem kell a fast force kikerli
//	 AT91C_BASE_AIC->AIC_IDCR = 0xffff;
//	    AIC_EnableIT(AT91C_ID_IRQ1);
//	    AIC_EnableIT(AT91C_ID_FIQ);
	   
	asm (													//FIQ enable in processor
				   " mrs  r0,CPSR\n\t "
			 	   " bic  r0,r0,#0x40\n\t"		//F_BIT		 	   
			 	   " msr  cpsr_c,r0\n\t ");
			 	   
//	while(1); 
//	AT91C_BASE_AIC->AIC_FFDR = 1 << 31;
//	AT91C_BASE_AIC->AIC_ISCR = 1 << 0 ;    // test
	
	
}
char stepper_servoinit(void){
	
	    initialized=1;
return 0;	
}

//*************************************************************************************************-
//
// Motor, s enkoder paramtereket inicializlja, bekapcsols, vagy motor ill enkoder paramter vltozskor.
//
//*************************************************************************************************



void stepper_parinit (void){
	


	
last_mot_rot[RA]=mot_rot[RA];
last_mot_rot[DEC]=mot_rot[DEC];
stepper_integ[RA]=0;
stepper_integ[DEC]=0;

drive_mode[RA]=IMODE;           							//bekapcsolskor egy j hossz IMODE-dal indul, aztn majd tkapcsol UMODE-ra ha kell
drive_mode_count[RA]=20;
drive_mode[DEC]=IMODE;
drive_mode_count[DEC]=20;
mot_stat[RA]=M_GOTO;
mot_stat[DEC]=M_GOTO;
if (misc.motortype == SERVO)
i_RA=i_DEC=0;
else
i_RA=i_DEC=1000;




}

//*************************************************************************************************-
//
// Ha krbert a forgs, akkor lehet nullzni a step countereket, de csak ha minden ll!!
//
//*************************************************************************************************
#ifdef CLEAR_POLECROSS
void manage_step_counter_owerflow(unsigned char mot){

float r_motor,rate_t,temp;
signed long stc;
unsigned int st;

	stc=stepcount[mot];
	st=step[mot] ;

	r_motor=step_to_rad(mot,stc,st);
/*
	while (r_motor > M2_PI ){
		r_motor-=M2_PI;
		rad_to_step(mot,r_motor,&stepcount[mot], &step[mot]);		mot_offset[mot]-=M2_PI;
		printf ("Step counter correction\r\n");

	}

	while (r_motor < -M2_PI ){
			r_motor+=M2_PI;
			rad_to_step(mot,r_motor,&stepcount[mot], &step[mot]);
			mot_offset[mot]+=M2_PI;
			printf ("Step counter correction\r\n");

		}
*/
	if ((r_motor < -2*M2_PI ) || (r_motor > 2*M2_PI ))
	{

	//	nosync[mot]=1;

		stepcount[mot]=0;
		step[mot]=0;
																		//mot_offset1 et kell gy lltani, hogy ne mozduljon a step nullzsra.
		rate_t=get_mot_rate(mot);
		mot_offset1[mot]-=r_motor;

		temp=mot_offset[mot]+(mot_offset_refr[mot]+mot_backlash[mot]);
		mot_offset1[mot]=rate_t-(/*r_motor*/+rate_offset[mot]+temp);
		printf ("Step counter correction\r\n");
	//	nosync[mot]=0;

	}


}
#endif

//*************************************************************************************************-
//
// Motor, s enkoder fggvnyeket inicializlja, bekapcsols, vagy motor ill enkoder paramter vltozskor.
//
//*************************************************************************************************



char stepperInit (void) {
	
	static char inited = 0;
//	    printf("pwm3:%d\n\r",PWMC_GetPeriod(3));
	    enable_motors(Off);

//	    TC_Stop(AT91C_BASE_TC1);
//	    TC_Stop(AT91C_BASE_TC2);

//	    PWMC_DisableChannel(0);
//	    PWMC_DisableChannel(1);
//	    PWMC_DisableChannel(2);
//	    PWMC_DisableChannel(3);


	    ALTAZ_can_start=0;
//	    initialized=1;
	    
	    stepper_parinit ();
		mot_offset1[RA]=0;
		mot_offset1[DEC]=0;
		mot_offset[RA]=0;
		mot_offset[DEC]=0;

		if (!inited){

		    inited = 1;
			PIO_Configure(pins, PIO_LISTSIZE(pins));
			PMC_EnablePCK1 (0x11);	//indtja a imode clk-t 	0x15
			init_QuadInputs();
		}
	    
	 //   sintab_init( M_GOTO);
	 //   sintab_init( M_STOP);
	 //   sintab_init( M_TRACK);
	    make_sin_cos();
	    make_sintab_u(RA, AMPL/10);//jj 10 volt
	    make_sintab_u(DEC,AMPL/10);
	    
	    make_sintab_i(RA, (AMPL_I*mot[RA].trackcurr)/1000);
	    make_sintab_i(DEC,(AMPL_I*mot[DEC].trackcurr)/1000);
	    make_sintab_i_dir(RA,LEFT);
	    make_sintab_i_dir(DEC,LEFT);
	    // ha brmelyik bit (0,1) LEFT akkor fordt, de ha mindkett akkor nem
	    if (( (mot[RA].rotation  & 0x01) == 0x01 )  != (( mot[RA].rotation  & 0x02) == 0x02 ))  change_rotation(RA);
	    if (( (mot[DEC].rotation  & 0x01) == 0x01 ) != (( mot[DEC].rotation  & 0x02) == 0x02 )) change_rotation(DEC);

//	    if (mot[RA].rotation==LEFT_TURN)change_rotation(RA);  // 2013.07.18 a fentire mdostva
//	    if (mot[DEC].rotation==LEFT_TURN)change_rotation(DEC);
	    
	    
	    init_Adc();
	    
	    PIO_Set(&Mode_AB_IM);
	    PIO_Set(&Mode_CD_IM);
	
//	    printf("Stepper sintab configured\n\r");
	
	
	  // Enable PWMC peripheral clock
	 //   AT91C_BASE_PMC->PMC_PCER &=!( 1 << AT91C_ID_PWMC);
	    AT91C_BASE_PMC->PMC_PCER = 1 << AT91C_ID_PWMC;

	    // Settings:
	    // - 100kHz PWM period (PWM_FREQUENCY)
	    // - 1s rise/fall time for the LED intensity

	    // Set clock A to run at 100kHz * MAX_DUTY_CYCLE (clock B is not used)
	    PWMC_ConfigureClocks(PWM_FREQUENCY * MAX_DUTY_CYCLE, 0, BOARD_MCK);

	    
	    // Configure PWMC channel #0 (left-aligned)

	    PWMC_ConfigureChannel(0, AT91C_PWMC_CPRE_MCKA, 0, 0);
	    while (PWMC_GetPeriod(0) != MAX_DUTY_CYCLE){
	    	PWMC_SetPeriod(0, MAX_DUTY_CYCLE);
	    //	printf("-0-");
	    }
	    PWMC_SetDutyCycle(0, MIN_DUTY_CYCLE);
	    
	    // Configure PWMC channel #1 (left-aligned)
	    PWMC_ConfigureChannel(1, AT91C_PWMC_CPRE_MCKA, 0, 0);
	    while (PWMC_GetPeriod(1) != MAX_DUTY_CYCLE){
	    	PWMC_SetPeriod(1, MAX_DUTY_CYCLE);
	    //	printf("-1-");
	    }
	    PWMC_SetDutyCycle(1, MIN_DUTY_CYCLE);

	    // Configure PWMC channel #2 (center-aligned, inverted polarity)
	  //  PWMC_ConfigureChannel(2, AT91C_PWMC_CPRE_MCKA, AT91C_PWMC_CALG, AT91C_PWMC_CPOL);
	    PWMC_ConfigureChannel(2, AT91C_PWMC_CPRE_MCKA, 0, 0);
	    while (PWMC_GetPeriod(2) != MAX_DUTY_CYCLE){
	    	PWMC_SetPeriod(2, MAX_DUTY_CYCLE);
	    //	printf("-2-");
	    }
	    PWMC_SetDutyCycle(2, MIN_DUTY_CYCLE);

	    // Configure PWMC channel #3 (center-aligned, inverted polarity)
	  //  PWMC_ConfigureChannel(3, AT91C_PWMC_CPRE_MCKA, AT91C_PWMC_CALG, AT91C_PWMC_CPOL);
	    PWMC_ConfigureChannel(3, AT91C_PWMC_CPRE_MCKA, 0, 0);

	    while (PWMC_GetPeriod(3) != MAX_DUTY_CYCLE){
	    	PWMC_SetPeriod(3, MAX_DUTY_CYCLE);
	    //	printf("-3-");
	    }
	    PWMC_SetDutyCycle(3, MIN_DUTY_CYCLE);
	    
	    


	    // Configure interrupt on channel #1
	 //   AIC_ConfigureIT(AT91C_ID_PWMC, 0, ISR_Pwmc);
	 //   AIC_EnableIT(AT91C_ID_PWMC);
	 //   PWMC_EnableChannelIt(1);

	    // Enable channel #1 and #2


	    PWMC_EnableChannel(0);
	    PWMC_EnableChannel(1);
	    PWMC_EnableChannel(2);
	    PWMC_EnableChannel(3);
	    
//	    printf("Stepper PWM configured\n\r");
	    set_motor_type(get_motortype());
//	    printf("Stepper Motor type configured\n\r");
	    ConfigureTc2();
//	    DEC_timer_init(32,23000,2);
//	    RA_timer_init(32,23000,2);
	    TC_Start(AT91C_BASE_TC2);
	    
	    ConfigureTc1();
//	    DEC_timer_init(32,23000,2);
//	    RA_timer_init(32,23000,2);
	    TC_Start(AT91C_BASE_TC1);
//	    printf("Stepper Timers configured\n\r");
	    
	    set_encoders(0,0,0,0);
	    init_Timers();
	    

	    PIO_Set(&Wp_Sd);  //spi write protect + LED
	    init_encoder_IT();
	    			                  //RA encoder
//	    set_motor_type(get_motortype());
	    enable_motors(Off);
//	    printf("Stepper All configured\n\r");
	    initialized=1;
return 0;	

}
